/*****************************************************************************/
/* DAYMAIN.I      All function types and parameters for memain               */
/*****************************************************************************/

#include<alloc.h>
#include<conio.h>
#include<ctype.h>
#include<dos.h>
#include<dir.h>
#include<io.h>
#include<math.h>
#include<process.h>
#include<signal.h>
#include<stdarg.h>
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<setjmp.h>                     /* for setjmp/longjmp */
#include"lee_sub.i"
#include"keycode.ii"

typedef struct
   {
      char     ver;                    /* ver=03h dBase III data file */
      char     year;                   /* last modify date - year */
      char     mon;                    /* last modify date - month */
      char     day;                    /* last modify date - day */
      long int total;                  /* total number of records */
      int      header_len;             /* total header length */
      int      record_len;             /* length per record */
   }  DBF_Header;                      /* The Header of *.DBF (dBase III) */

typedef struct
   {
      char delete;                     /* * (2A)  R _ (20)  R */
      char in_or_ex;                   /* JΤX A:J  B:X       */
      char type;                       /* JΤXN A,B,C,E,F,G,...  */
      char account;                    /* bN   A,B,C,E,F,G,...      */
      char date  [ 8];                 /*    00/00/00                 */
      char money [10];                 /* B   0000000000               */
      char memo  [40];                 /* Kn                            */
      char tk_no [10];                 /* ǲX         ( _ ܪť ) */
   }  DAYUNIT;

typedef struct
   {
      int  index;                      /* index in DBF file               */
      char delete;                     /* * (2A)  R _ (20)  R */
      char in_or_ex;                   /* JΤX A:J  B:X       */
      char type;                       /* JΤXN A,B,C,E,F,G,...  */
      char account;                    /* bN   A,B,C,E,F,G,...      */
   }  DAYUNITSHOW;

typedef struct
   {
      char ID1[3];                     /* ID1 words = "SAT"               */
      char account;                    /* total number of account_KINDS   */
      char ID2[76];                    /* ID2 words = Reserved            */
   }  STATHEAD;                        /* Length of (STATHEAD) = 80       */

typedef struct
   {
      char delete;                     /* * (2A)  R _ (20)  R */
      char in_or_ex;                   /* JΤX A:J  B:X       */
      char type;                       /* JΤXN A,B,C,E,F,G,...  */
      char account;                    /* bN   A,B,C,E,F,G,...      */
      char date1 [ 8+1];               /*    00/00/00                 */
      char date2 [ 8+1];               /*    00/00/00                 */
      char memo  [40+1];               /* Kn                            */
      char money1[10+1];               /* B   0000000000               */
      char money2[10+1];               /* B   0000000000               */
      char tk_no [10+1];               /* ǲX         ( _ ܪť ) */
   }  DAYUNITSEARCH;

#define INCOME_KINDS   20
#define EXPEND_KINDS   20
#define ACCOUNT_KINDS  10
#define PAGEL  20
#define First   3

extern char *NoFileSelected;
#ifndef NoExtern
extern FILE *Main_CFG;                  /* system CFG file pointer */
extern char *System_CFG;                /* system CFG file name */
extern FILE *File_CFG;                  /* current CFG file pointer */
extern FILE *File_DBF;                  /* current DBF file pointer */
extern FILE *File_SAT;                  /* current SAT file pointer */
extern char *IC_Path;                   /* initial PATH of MeMain */
extern char *Current_CFG;               /* current CFG file name */
extern char *Current_DBF;               /* current DBF file name */
extern char *Current_SAT;               /* current SAT file name */

extern char **income;                   /* name of income */
extern char far *incomebase;            /* memory base - name of income */
extern char **expend;                   /* name of expend */
extern char far *expendbase;            /* memory base - name of expend */
extern char **account;                  /* name of account */
extern char far *accountbase;           /* memory base - name of account */
extern DAYUNITSHOW **ALL;               /* Be a Index */
extern DAYUNITSHOW far *ALLbase;        /* Base for *ALL[] */
extern char        far *ALLindex;       /* Index of ALL[] */
extern int   *IndexY;                   /* Index of non-deleted data */
extern int   *IndexN;                   /* Index of deleted data */
extern int   *IndexS;                   /* Index of data to show */

extern char  *TitlePrn;                 /* the name of the registed place */
extern char  *UnitPrn;                  /* the name of the registed place */
extern char  *FirstDay;                 /* the very first day of the data file*/
extern char  *LastDay;                  /* the very last day of the data file */

extern char   InAccount[INCOME_KINDS+1]; /* the account of the income */
extern char   ExAccount[EXPEND_KINDS+1]; /* the account of the expend */
extern double IncomeST[INCOME_KINDS];    /* stat kinds of income */
extern double ExpendST[EXPEND_KINDS];    /* stat kinds of expend */
extern double AccountLEST[ACCOUNT_KINDS];/* rest from lest year */
extern double AccountIN[ACCOUNT_KINDS];  /* stat income of an account */
extern double AccountEX[ACCOUNT_KINDS];  /* stat expend of an account */
extern double AccountST[ACCOUNT_KINDS];  /* current kinds of account */
extern double SUMofLEST;                 /* sum of the AccountLEST[] */
extern double SUMofIN;                   /* sum of the AccountIN[] */
extern double SUMofEX;                   /* sum of the AccountEX[] */
extern double SUMofST;                   /* sum of the AccountST[] */

extern char  BeepControlFlag;           /* Beep control flag */
extern char  FlagOfPrinting;            /* Flag of printing data */
extern char  FlagOfPrintBreak;          /* Flag of Break while printing */
extern char  FlagOfBreakPress;          /* Flag of Ctrl-Break Press */
extern char  FlagOfShowingCwords;       /* Flag of Showing Chinese Words */
extern char  FlagOfOpeningDBF;          /* Flag of Opening Current DBF file */
extern int   SleepSeconds;              /* Seconds for Screen Protect */
extern long  DBF_HeaderLen;             /* Header Len of DBF File */
extern char  income_num;                /* count number of income */
extern char  expend_num;                /* count number of expend */
extern char  account_num;               /* count number of account */
extern int   C_IndexY;                  /* Count of IndexY */
extern int   C_IndexN;                  /* Count of IndexN */
extern int   C_IndexS;                  /* Count of IndexS */
extern long  totalnumb;                 /* The Number of Total Records */
extern int   MaxRecords;                /* Maximun Records in a DBF file */
extern long  MemLeft;                   /* Memory Left after Alloc_ALL() */

extern unsigned char Color_Message;
extern unsigned char Color_MenuNormal;
extern unsigned char Color_MenuLightBar;
extern unsigned char Color_DataNormal;
extern unsigned char Color_DataLightBar;
extern unsigned char Color_StringInput;

extern char  YearType;                  /* The type of the year     */
extern char  DisplayType;               /* The type of data display */
extern char  CurrentDataType;           /* Current Data Type flag */
extern char  CurrentSortType;           /* Current Sort Type flag */
extern char  CurrentYearOfDate[2];      /* Current YEAR of the data file  */
extern char  DevicePrinterName[61];     /* Print to ASCII file */
extern int   PrinterPort;               /* Printer Port 0:LPT1  1:LPT2 .. */
extern char  PrinterType;               /* 0 -> Printer   1 -> ASCII file */
extern unsigned char PrinterControlCode;/* Printer Control Code */
extern char  PrinterControlString[45];  /* Printer Control String */
extern char  *FullNumb[];               /* Full type of number (CHINESE) */
extern char  *FullNumb2[];              /* Full type of number (CHINESE) */
extern char  *FullAlpha[];              /* Full type of alpha  (CHINESE) */
#endif

/******** STAT   .C ********/
void ResetMoney(void);
void ResetSTMoney(void);
void AddUnitMoney(DAYUNIT *Mtmp);
void DelUnitMoney(DAYUNIT *Mtmp);
void CalculateMoney(void);

/******** UNIO0  .C ********/
void  *exit_f1(void);
int   NormalControlBreak(void);
int   PrintControlBreak(void);
void  interrupt clock(void);
void  interrupt key(void);
void  ShowProgram(void);
void  CheckAllFile(void);
BOOL2 ChineseSystem(void);
void  PrepareMemain(void);

/******** UNIO1-1.C ********/
void OpenDBF(void);
void CloseDBF(void);
void Read_DBF_Header(DBF_Header *H,FILE *DBF_fptr);
void Write_DBF_Header(FILE *DBF_fptr);
void ReadOneUnit(DAYUNIT *Mtmp,int RecNo);
void WriteOneUnit(DAYUNIT *Mtmp,int RecNo);
void AppendOneUnit(DAYUNIT *Mtmp,FILE *MeAppend);
char Load_DBF(void);
void Load_DBF2(void);
char Get_NewDBF(char *DBF_filename);
char Get_NewDBF_Restore(char *DBF_filename);

/******** UNIO1-2.C ********/
void CenterFrame(char rownumb);
void FreeCenterFrame(char rownumb);
char ModifyUnit(int RecNo_ScrI);
void DeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
void UnDeleteOneUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
char DeleteUnit(int *RecNo_ScrJ,int *RecNo_ScrI);
char AddOneUnit(char drawflag);
char AddUnit(void);
void ReStructure(void);
char UnDeleteUnit(void);

/******** UNIO1-3.C ********/
void Write_CFG(char *CFG_filename);
void Read_CFG(char *CFG_filename);
char SetSubstitution_0(void);
char SetSubstitution_1_2(char Stype);
char SetSubstitution(char Stype);

/******** UNIO1-4.C ********/
void Write_SAT(char *SAT_filename);
void Read_SAT(char *SAT_filename);
void DrawTable(void);
char SetBudget(void);

/******** UNIO1-5.C ********/
char Input_Year(int *defaultyear);
char CreateNew(void);
char DeleteOld(void);
char BackupCurrent(char cDrive);
char RestoreCurrent(char cDrive);

/******** UNIO1-6.C ********/
int   SelectColor(char left,char top,int *colorattr);
void  WriteSystemSetting(void);
void  SettingParameter(void);
void  ReadSystemSetting(void);
void  showcolordemo(unsigned char Scolor,char Ypos,unsigned char dcolor);
BOOL2 SystemSetting(void);

/******** UNIO2-1.C ********/
void ShowOneUnit(DAYUNITSHOW *S);
void ShowOneUnitWithHeader(char ScrY,DAYUNITSHOW *S);
void OffShowOneUnitWithHeader(char ScrY);
void ShowOneNull(void);
void showu1(int ScrJ,int ScrI);
void showu2(int ScrJ,int ScrI);
void showu3(int ScrJ,int ScrI);
void showu4(int ScrJ,int ScrI);
void ShowInfo(int ScrI);
void DrawForm(void);
void NotFound(int *ScrJ,int *ScrI);
void ShowUnit(int *ScrJ,int *ScrI,int keystroke);
BOOL2 SelectDisplayType(void);
void Cwords2(CWORDS *C);
void CwordsOff2(void);

/******** UNIO2-2.C ********/
char CheckBudget(void);
void cline(int x1,int y1,int x2,int y2,int colors,char boundflag);
void ScreenProtect(void);

/******** UNIO2-3.C ********/
char OpenDevicePrinter(char *printername);
void CloseDevicePrinter(void);
char CheckDevicePrinterDriver(void);
char DealWithPrinterNotReady(void);
char PrinterOK(void);
void ToPrinter(char *fmt, ... );
void PrintInit(void);
void PrintFormat(char formatNo);
void FormFeed(void);
void PrintTitle(char *titlewords,int cCol);
void PrintPages(char formatNo,char *Astr,int pTotalPage,int pCurrentPage);
void PrintHeader(char formatNo);
void PrintPartLine(char formatNo);
void PrintPUFrame(void);
void PrintPLFrame(void);
void PrintPUFrame2(void);
void PrintPLFrame2(void);
void PrintPCFrame(void);
void PrintNullFrame(void);
void PrintNull(void);
void PrintUnit(char formatNo,DAYUNIT *pUnt,double Mrest);
void PrintCalculate(char formatNo,double pStat1,double pStat2);
void PrintFromday(void);
void PrintToday(void);
void PrintAccount(char pAccount);
void PrintStatH(void);
void PrintStatF(void);
void PrintAllAccount(void);
void PrintAllType(void);
void PrintStat(char pAccount);

/******** UNIO3-1.C ********/
void ConvertUntToShow(DAYUNITSHOW *shoW,DAYUNIT *unT,int index_in_f);
void Date_String(char *sdate);
void IntToString(char *sstring,int iint);
int  StringToInt(char *sstring);
char IsNumberChar(char numberchar);
void DealWithDateString(char *dstring);
void ShowFormat(char *headerword);
char GetOneUnit(DAYUNIT *tmp,char Newflag,char Drawflag);
void GetCurrent_CFG(void);
void GetCurrent_SAT(void);

/******** UNIO3-2.C ********/
void DrawGetOneUnitSearch(char search_type);
char GetOneUnitSearch1(DAYUNITSEARCH *tmp,char Newflag,char Drawflag);
char GetOneUnitSearch2(DAYUNITSEARCH *tmp,char Newflag,char Drawflag);

/******** UNIO3-3.C ********/
void SetDateRange(DAYUNITSEARCH *Stmp);
void SetMoneyRange(DAYUNITSEARCH *Stmp);
char CheckDateRange(DAYUNIT     *Tmp);
char CheckYear(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckMon(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckDay(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckIn_or_Ex(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckType(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckAccount(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckMemo(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckMoneyRange(DAYUNIT     *Tmp);
char CheckMoney(DAYUNIT     *Tmp);
char CheckTk_no(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
void SetMemo(DAYUNITSEARCH *Stmp);
void SetTk_no(DAYUNITSEARCH *Stmp);
char Searching(DAYUNITSEARCH *Stmp,char Typeflag);
char Search(void);

/******** UNIO4-1.C ********/
void MemNotEnough(void);
void MemNotEnough2(void);
void Alloc_ALL(void);
void Reset_ALL(void);
void Free_ALL(void);
void Yes2Show(void);
void No2Show(void);

void SwapALL(DAYUNITSHOW *unt1,DAYUNITSHOW *unt2);
void SwapIndexS(int *i1,int *i2);
void DateToLong(unsigned long *lLong,char *sdate);
unsigned long DateToL(char *sdate);

int  UnitCmp(DAYUNITSHOW *unt1,DAYUNITSHOW *unt2,char cmpflag);
char ShellSortShow(char cmpflag);
char ShowSort(void);

/******** UNIO4-2.C ********/
char AskPrinterFile(void);             /* ver 0.24 */
char AskPrinterType(void);             /* ver 0.24 */
char PrintBudget(void);
char AskPrintRange(int *pFirst,int *pEnd);
char PrintALL(int *ScrJJ,int *ScrII);
