/*****************************************************************************/
/* DYNAMIC_.C  the test of TWO Dimensions array  (Dyanmic Allocate Memory)   */
/*****************************************************************************/

#include<alloc.h>

double far *OneD(double far **ptr,unsigned size)
{            /* This routine allow size=0xFFFF/sizeof(double)=0x1FFF= 8191 */
   *ptr =(double far *)farcalloc( size ,sizeof(double));
   return *ptr;
}

double far **TwoD(double far ***ptr,unsigned size1,unsigned size2)
{                          /* This routine allow        size1=0xFFFF=65535 */
   double far *ptrbase;    /* and size2=0xFFFF/sizeof(double)=0x1FFF= 8191 */
   double far *ALLindex;
   unsigned int ALL_seg;   /* for far pointer of ALL */
   unsigned int ALL_off;   /* for far pointer of ALL */
   unsigned i;

   *ptr    =(double far **)farcalloc(size1,sizeof(double far *));
   ptrbase =(double far *)farcalloc(size1,sizeof(double)*size2);
   ALLindex=(double far *)ptrbase;
   for(i=0;i<size1;i++)
   {
      (*ptr)[i]=(double far *)ALLindex;
      ALLindex+=size2;
      ALL_off=FP_OFF(ALLindex);
      ALL_seg=FP_SEG(ALLindex);
      ALLindex=MK_FP(ALL_seg+(ALL_off>>4),ALL_off%16);
   }
   return *ptr;
}

void far *OneD(unsigned size,unsigned size1)
{            /* This routine allow size=0xFFFF/sizeof(double)=0x1FFF= 8191 */
   void far *ptr;
   ptr =(void far *)farcalloc(size1,size);
   return ptr;
}

void far **TwoD(unsigned size,unsigned size1,unsigned size2)
{                          /* This routine allow        size1=0xFFFF=65535 */
   void far **ptr;         /* and size2=0xFFFF/sizeof(double)=0x1FFF= 8191 */
   void far *ptrbase;
   char far *ALLindex;
   unsigned int ALL_seg;   /* for far pointer of ALL */
   unsigned int ALL_off;   /* for far pointer of ALL */
   unsigned i;

   ptr     =(void far **)farcalloc(size1,sizeof(void far *));
   ptrbase =(void far *)farcalloc(size1,size*size2);
   ALLindex=(char far *)ptrbase;
   for(i=0;i<size1;i++)
   {
      ptr[i]=(void far *)ALLindex;
      ALLindex+=size*size2;
      ALL_off=FP_OFF(ALLindex);
      ALL_seg=FP_SEG(ALLindex);
      ALLindex=MK_FP(ALL_seg+(ALL_off>>4),ALL_off%16);
   }
   return ptr;
}
main()
{
   int far **array;
   int far *a;
   int b=12000,c=1;
   int i,j,k;

   array=(int far **)farcalloc(b,sizeof(int far *));
   a=(int far *)farcalloc(b*c,sizeof(int far));
   for(i=0;i<b;i++)array[i]=(a+i*c);

   for(i=0,k=0;i<5;i++)
      for(j=0;j<c;j++,k++)
         {
            *(*(array+i)+j)=k;
            printf("\n*(a+k)=%d  %p\t*(*(array+i)+j)=%d  %p",*(a+k),(a+k),*(*(array+i)+j),(*(array+i)+j));
         }
}
