/*****************************************************************************/
/* LAYOUT.C     for layout        Screen input/output                        */
/*****************************************************************************/

#include<alloc.h>
#include<conio.h>
#include<stdarg.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mem.h>
#include"lee_sub.i"
#include"keycode.ii"

/*#define DebugMemoryUsage*/

int  MessageF     =LIGHTRED;
int  MessageB     =BLACK;
int  DataBaseF    =LIGHTGRAY;
int  DataBaseB    =BLUE;
int  DataLightBarF=WHITE;
int  DataLightBarB=BLUE;

void MessageColor     (int FFFF,int BBBB){ MessageF    =FFFF;MessageB  =BBBB; }
void DataBaseColor    (int FFFF,int BBBB){ DataBaseF   =FFFF;DataBaseB =BBBB; }
void DataLightBarColor(int FFFF,int BBBB){DataLightBarF=FFFF;DataLightBarB=BBBB;}
void Clrscr(void)
{
   window(1,1,80,24);
   textcolor(DataBaseF);
   textbackground(DataBaseB);
   clrscr();
   window(1,1,80,25);
}
void MarkLine(char ScrII)
{
   BLfill(ScrII,DataLightBarF+DataLightBarB*16);
}
void UnMarkLine(char ScrII)
{
   BLfill(ScrII,DataBaseF+DataBaseB*16);
}
void DealWith_fget(char *fgetstring)
{
   unsigned int i;
   for(i=0;fgetstring[i];i++)
      if(fgetstring[i]=='\n')
      {
         fgetstring[i]='\0';
         break;
      }
}
void StringKillString(char *src,char *kstr)
{
   char *p;
   int  s=strlen(kstr);
   while((p=strstr(src,kstr))!=NULL)
   {
      memmove(p,p+s,strlen(p+s)+1);
   }
}
void OneBeep(unsigned int delaytime)
{
   sound(110);
   delay(delaytime);
   nosound();
}
void Message(char beepflag,char blinkflag,char posflag,char *msg, ... )
{
   static char msgwords[81];
   va_list  argptr;                       /* Argument list pointer        */
   char Scrx,Scry;
   Scrx=wherex();
   Scry=wherey();
   MessageOff();
   textcolor((blinkflag==1)?MessageF+BLINK:MessageF);
   textbackground(MessageB);
   va_start( argptr, msg );               /* Initialize va_ functions     */
   vsprintf(msgwords, msg, argptr );      /* prints string to buffer      */
   va_end( argptr );                      /* Close va_ functions          */
   msgwords[79]='\0';                     /* Show at the most 79 words    */
   DealWith_fget(msgwords);
   gotoxy(1,25);

#ifndef DebugMemoryUsage
   cprintf("%s",msgwords);
#else
   cprintf("%lu %s",farcoreleft(),msgwords);
#endif

   normvideo();
   if(posflag==0) gotoxy(Scrx,Scry);

   if(beepflag==1)
   {
      OneBeep(200);OneBeep(25);
      sleep(1);
      Clear_KeyBuf();
   }
}
void MessageOff(void)
{
   char *null_line="                                                                               ";
   char ScrX=wherex(),ScrY=wherey();
   window(1,1,80,25);
   gotoxy(1,25);
   normvideo();
   cprintf(null_line);
   gotoxy(ScrX,ScrY);
}
void printfXY(char ScrX,char ScrY,char *msg, ... )
{
   va_list  argptr;                       /* Argument list pointer        */
   gotoxy(ScrX,ScrY);
   va_start( argptr, msg );               /* Initialize va_ functions     */
   vprintf( msg, argptr );                /* prints string to stdout      */
   va_end( argptr );                      /* Close va_ functions          */
}
void cprintfXY(char ScrX,char ScrY,char *msg, ... )
{                                         /* *msg is not allow to scroll  */
   struct text_info R;                    /* the screen or textwindow     */
   va_list  argptr;                       /* Argument list pointer        */
   gotoxy(ScrX,ScrY);
   va_start( argptr, msg );               /* Initialize va_ functions     */
   vprintf( msg, argptr );                /* prints string to buffer      */
   va_end( argptr );                      /* Close va_ functions          */
   gettextinfo(&R);
   R.curx--;
   R.curx=(R.curx<1)?R.winright:R.curx;
   BBfill(ScrX,ScrY,R.curx,R.cury,R.attribute);
}
BOOL2 Ask_Yes(char *askword)
{
   int ch;
   Message(0,0,1,"%sH]^",askword);
   Clear_KeyBuf();
   Cursor(2);
   SetEnglishInput();
   ch=bioskey(0);
/* ch=(ch==Esc)?N_N:ch;*/
   MessageOff();
   Cursor(0);
   if(ch==Esc)                    return OTHER;
   else  if(!(ch==N_N || ch==S_N))return OK;
         else                     return NotOK;
}
BOOL2 Ask_No(char *askword)
{
   int ch;
   Message(0,0,1,"%sH]Bܡ^",askword);
   Clear_KeyBuf();
   Cursor(2);
   SetEnglishInput();
   ch=bioskey(0);
/* ch=(ch==Esc)?N_N:ch;*/
   MessageOff();
   Cursor(0);
   if(ch==Esc)                    return OTHER;
   else  if(!(ch==N_Y || ch==S_Y))return OK;
         else                     return NotOK;
}
void ToCwords(CWORDS *C,char *words,int size,int scrx,int scry,char space,char mode)
{
   C->words=words;
   C->size=size;
   C->scrx=scrx;
   C->scry=scry;
   C->space=space;
   C->mode=mode;
}
/*----------------------------------------------------Change in CenterCwords !!
void CenterCwords(CWORDS *C,char *words,int size)
{
   int  slen=strlen(words);
   int  tspace;
   C->words=words;
   /*C->size=(size!=0)?size:((slen>24)?24:48);*/
   size=(size<16)?4096:size;
   /*
   if(slen>52)      C->size=16;
   else if(slen>26) C->size=(size>24)?24:size;
        else        C->size=(size>48)?48:size;
   */
   if(C->size!=16)
   {
      tspace=(slen==1)?0:((ETen.main_width - (C->size/2)*slen)/(slen-1));
      tspace=(tspace>80)?80:tspace;
      tspace=(tspace<0)?0:tspace;
      C->space=tspace;
      tspace=(slen<2)?0:( (CwordInString(words,slen-2)==1)?1:0 );
      C->scrx=(ETen.main_width - (C->size/2)*slen - ((float)C->space*0.5)*(slen-1-tspace))/2;
   }
   else
   {
      C->space=0;
      C->scrx=(80-slen)*0.5*8;
   }
   C->scry=1;
   C->mode='o';
}
void Cwords(CWORDS *C)
{
   static CWORDS Cwords_Bak;
   char x,y;
   unsigned int etver;
   unsigned char scrcrol,prncrol;

   x=wherex(),y=wherey();
   ETinfo(&etver,&scrcrol,&prncrol);
   if(C!=NULL)memcpy(&Cwords_Bak,C,sizeof(CWORDS));
   gotoxy(1,1);
   if(Cwords_Bak.size==16)
      printfXY(Cwords_Bak.scrx/8 +1,1,Cwords_Bak.words);
   else if(etver>=0x3000)
      printf("%cT%d,%d,%d,%d,1/1,%c;%s%cT16;",scrcrol,
         Cwords_Bak.size,Cwords_Bak.scrx,Cwords_Bak.scry,Cwords_Bak.space,
         Cwords_Bak.mode,Cwords_Bak.words,scrcrol);
   else                                         /* for below ET ver 3.0 */
      printf("%cT%d,%d,%d,%d,%d/%d,%c;%s%cT16;",scrcrol,
         24,Cwords_Bak.scrx,Cwords_Bak.scry,Cwords_Bak.space,
         Cwords_Bak.size/24,Cwords_Bak.size/24,
         Cwords_Bak.mode,Cwords_Bak.words,scrcrol);
   gotoxy(x,y);
}
-----------------------------------------------------------------------------*/
void CenterCwords(CWORDS *C,char *words,int rows)
{
   int  slen=strlen(words);
   int  tspace;
   int  i,c,e;
   int  size;

   C->words=words;
   C->mode='o';
   if(rows<=1)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(ETen.main_width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=(ETen.ascii_height-ETen.ascii_width*2)/2;
      C->scry=(C->scry<0)?0:C->scry;
      return;
   }

   size=((rows*ETen.ascii_height)/24)*24;
   while(size*slen*0.5>ETen.main_width)size-=24;
   if(size<24)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(ETen.main_width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=((ETen.ascii_height*rows-C->size)/2)/ETen.ascii_height*ETen.ascii_height;
      C->scry=(C->scry<0)?0:C->scry;
      return;
   }

   C->size=size;
   tspace=(slen==1)?0:((ETen.main_width - (C->size/2)*slen)/(slen-1));
   tspace=(tspace>80)?80:tspace;
   tspace=(tspace<0)?0:tspace;
   C->space=tspace;
   if(slen<2)e=1,c=0;
   else
      for(i=0,e=0,c=0;i<slen;i++)
         if(CwordInString(words,i)==1)c++,i++;
         else                         e++;
   if(ETen.ver>=0x3500)                            /* ET v3.5 or later  fixed */
   {
      tspace=e+c;
      tspace-=1;
   }
   else
   {
      tspace=e+c+c;
      if(slen>=2 && CwordInString(words,slen-2)==1) tspace-=2;
      else                                          tspace-=1;
   }
   C->scrx=(ETen.main_width - (C->size/2)*slen - ((float)C->space*0.5)*(tspace))/2;
   C->scry=(ETen.ascii_height*rows-C->size)/2;
   C->scry=(C->scry<0)?0:C->scry;
   return;
}
void BlockCenterCwords(CWORDS *C,char *words,int ulx,int uly,int brx,int bry)
{                                      /* ul - upperleft  br - bottomright */
   int  slen=strlen(words);
   int  rows=bry-uly+1;
   int  width=(brx-ulx+1)*ETen.ascii_width;
   int  tspace;
   int  i,c,e;
   int  size;

   C->words=words;
   C->mode='o';
   if(rows<=1)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=(ETen.ascii_height-ETen.ascii_width*2)/2;
      C->scry=(C->scry<0)?0:C->scry;
      C->scry+=(uly-1)*ETen.ascii_height;
      C->scrx+=(ulx-1)*ETen.ascii_width;
      return;
   }

   size=((rows*ETen.ascii_height)/24)*24;
   while(size*slen*0.5>width)size-=24;
   if(size<24)
   {
      C->size=ETen.ascii_width*2;
      C->space=0;
      C->scrx=(width/ETen.ascii_width-slen)*0.5*ETen.ascii_width;
      C->scry=((ETen.ascii_height*rows-C->size)/2)/ETen.ascii_height*ETen.ascii_height;
      C->scry=(C->scry<0)?0:C->scry;
      C->scry+=(uly-1)*ETen.ascii_height;
      C->scrx+=(ulx-1)*ETen.ascii_width;
      return;
   }

   C->size=size;
   tspace=(slen==1)?0:((width - (C->size/2)*slen)/(slen-1));
   tspace=(tspace>80)?80:tspace;
   tspace=(tspace<0)?0:tspace;
   C->space=tspace;
   if(slen<2)e=1,c=0;
   else
      for(i=0,e=0,c=0;i<slen;i++)
         if(CwordInString(words,i)==1)c++,i++;
         else                         e++;
   if(ETen.ver>=0x3500)                            /* ET v3.5 or later  fixed */
   {
      tspace=e+c;
      tspace-=1;
   }
   else
   {
      tspace=e+c+c;
      if(slen>=2 && CwordInString(words,slen-2)==1) tspace-=2;
      else                                          tspace-=1;
   }
   C->scrx=(width - (C->size/2)*slen - ((float)C->space*0.5)*(tspace))/2;
   C->scry=(ETen.ascii_height*rows-C->size)/2;
   C->scry=(C->scry<0)?0:C->scry;
   C->scry+=(uly-1)*ETen.ascii_height;
   C->scrx+=(ulx-1)*ETen.ascii_width;
   return;
}
void Cwords(CWORDS *C)
{
   static CWORDS Cwords_Bak;
   char x,y;
   unsigned int etver;
   unsigned char scrcrol,prncrol;

   x=wherex(),y=wherey();
   ETinfo(&etver,&scrcrol,&prncrol);
   if(C!=NULL)memcpy(&Cwords_Bak,C,sizeof(CWORDS));
   gotoxy(1,1);
   if(Cwords_Bak.size==16)
      printfXY(Cwords_Bak.scrx/ETen.ascii_width +1,Cwords_Bak.scry/ETen.ascii_height +1,Cwords_Bak.words);
   else if(etver>=0x3000)
      printf("%cT%d,%d,%d,%d,1/1,%c;%s%cT16;",scrcrol,
         Cwords_Bak.size,Cwords_Bak.scrx,Cwords_Bak.scry,Cwords_Bak.space,
         Cwords_Bak.mode,Cwords_Bak.words,scrcrol);
   else                                         /* for below ET ver 3.0 */
      printf("%cT%d,%d,%d,%d,%d/%d,%c;%s%cT16;",scrcrol,
         24,Cwords_Bak.scrx,Cwords_Bak.scry,Cwords_Bak.space,
         Cwords_Bak.size/24,Cwords_Bak.size/24,
         Cwords_Bak.mode,Cwords_Bak.words,scrcrol);
   gotoxy(x,y);
}
void CwordsOff(void)
{
   char *cscrbuf;
   struct text_info R;
   gettextinfo(&R);

   cscrbuf=(char *)malloc(80*24*2*sizeof(char));
   window(1,1,80,24);
   gettext(1,1,80,24,cscrbuf);
   textattr(R.attribute);
   clrscr();
   puttext(1,1,80,24,cscrbuf);
   printfXY(1,1,"%cCR;",27);                                /* Redraw screen */
   free(cscrbuf);
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   gotoxy(R.curx,R.cury);
}
void CenterCstring(char *dest,char *surc,int cCol)
{
   CenterCstring2(dest,surc,cCol,0);
}
void CenterCstring2(char *dest,char *surc,int cCol,int maxwspace)
{
   int  slen=strlen(surc);
   int  wnum=NumOfCword(surc);
   int  space,wspace,alen;
   int  i,j,k;
   memset(dest,0,cCol+1);
   if(slen>=cCol)
   {
      strncpy(dest,surc,cCol);
      dest[cCol]='\0';
      return;
   }
   space=cCol-slen;
   if(wnum==1)wspace=0;
   else       wspace=(space-20)/(wnum-1);
   maxwspace=(maxwspace==0)?5:maxwspace;        /* default Maxwspace = 5 */
   wspace=(wspace>maxwspace)?maxwspace:( (wspace<0)?0:wspace );
   alen=slen+wspace*(wnum-1);
   for(i=0;i<(cCol-alen)/2;i++)dest[i]=' ';
   for(j=0;j<slen;)
      if(CwordInString(surc,j)==OK)
      {
         dest[i++]=surc[j++];
         dest[i++]=surc[j++];
         for(k=0;k<wspace;k++) dest[i++]=' ';
      }
      else
      {
         dest[i++]=surc[j++];
         if(CwordInString(surc,j)==OK)
            for(k=0;k<wspace;k++) dest[i++]=' ';
      }
   dest[i++]='\n';
   dest[i++]='\0';
}
void ShowCenterCstring2(int scrX,int scrY,char *surc,int cCol,int maxwspace)
{
   char dest[256];
   int  slen=strlen(surc);
   int  wnum=NumOfCword(surc);
   int  space,wspace,alen;
   int  i,j,k;
   memset(dest,0,cCol+1);
   if(slen>=cCol)
   {
      strncpy(dest,surc,cCol);
      dest[cCol]='\0';
   }
   else
   {
      space=cCol-slen;
      if(wnum==1)wspace=0;
      else       wspace=(space-20)/(wnum-1);
      maxwspace=(maxwspace==0)?5:maxwspace;        /* default Maxwspace = 5 */
      wspace=(wspace>maxwspace)?maxwspace:( (wspace<0)?0:wspace );
      alen=slen+wspace*(wnum-1);
      for(i=0;i<(cCol-alen)/2;i++)dest[i]=' ';
      for(j=0;j<slen;)
         if(CwordInString(surc,j)==OK)
         {
            dest[i++]=surc[j++];
            dest[i++]=surc[j++];
            for(k=0;k<wspace;k++) dest[i++]=' ';
         }
         else
         {
            dest[i++]=surc[j++];
            if(CwordInString(surc,j)==OK)
               for(k=0;k<wspace;k++) dest[i++]=' ';
         }
      dest[i++]='\0';
   }
   gotoxy(scrX,scrY);
   printf(dest);
}
void Encode1Output(char *s)
{
   unsigned int slen=strlen(s);
   unsigned char sseed=(slen&0x00FF);     /* get low byte */
   unsigned int i;
   printf("char *str=\n");
   printf("\"\\x%02X\\x%02X\"\n",(unsigned char )(slen&0x00FF),(unsigned char)(slen&0xFF00));
   printf("\"");
   for(i=0,s[0]+=sseed;i<slen;i++)
   {
      if(i%16==0 && i!=0)printf("\"\n\"");
      if(i!=0)s[i]+=s[i-1];
      printf("\\x%02X",(unsigned char)s[i]);
   }
   printf("\";");
}
char *Decode1(char *t)
{
   unsigned int slen=(t[0]&0x00FF)|(t[1]&0xFF00);
   unsigned char sseed=t[0];
   unsigned int i;
   for(i=slen+1;i>2;i--)
      t[i]-=t[i-1];
      t[i]-=sseed;
   return t+2;     /* Offset 2 */
}
char *Encode1(char *t)
{
   unsigned int slen=(*(t-2)&0x00FF)|(*(t-1)&0xFF00);
   unsigned char sseed=*(t-2);
   unsigned int i;
   t[0]+=sseed;
   for(i=1;i<slen;i++)
      t[i]+=t[i-1];
   return t-2;     /* Offset 2 */
}
/*****************************************************************************
Testing CenterCword();

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "lee_sub.i"
void cline(int x1,int y1,int x2,int y2,int colors,char boundflag)
{
   gotoxy(1,1);
   printf("L%d,%d,%d,%d,%d,%c;",x1,y1,x2,y2,colors,((boundflag==1)?'B':' '));
}
main(int argc,char *argv[])
{
   CWORDS CC1;
   int rows;
   if(argc<3)
   {
      printf("..exe  [argv1=r] [argv2=jp]\n");
      exit(0);
   }
   InitializeETen();
   clrscr();
   CenterCwords(&CC1,argv[1],rows=atoi(argv[2]));
   gotoxy(1,15);
   printf("words=%s\n",CC1.words);
   printf("size =%d\n",CC1.size );
   printf("scrx =%d\n",CC1.scrx );
   printf("scry =%d\n",CC1.scry );
   printf("space=%d\n",CC1.space);
   printf("mode =%c\n",CC1.mode );
   Cwords(&CC1);
   cline(1,1,CC1.scrx,rows*ETen.ascii_height,13,1);
   cline(ETen.main_width-CC1.scrx,rows*ETen.ascii_height,ETen.main_width,1,13,1);
   gotoxy(1,24);
}


Testing BlockCenterCword();
main(int argc,char *argv[])
{
   CWORDS CC1;
   int rows;
   if(argc<3)
   {
      printf("..exe  [argv1=r] [argv2=jp]\n");
      exit(0);
   }
   InitializeETen();
   clrscr();
   rows=atoi(argv[2]);
   BlockCenterCwords(&CC1,argv[1],10,10,70,10+rows-1);
   cline((10-1)*ETen.ascii_width,(10-1)*ETen.ascii_height,
         (70)*ETen.ascii_width,  (10+rows-1)*ETen.ascii_height, 13,1);
   gotoxy(1,1);
   printf("lens =%d\n",strlen(argv[1]));
   printf("words=%s\n",CC1.words);
   printf("size =%d\n",CC1.size );
   printf("scrx =%d\n",CC1.scrx );
   printf("scry =%d\n",CC1.scry );
   printf("space=%d\n",CC1.space);
   printf("mode =%c\n",CC1.mode );
   printfXY(1, 8,"         1         2         3         4         5         6         7         8");
   printfXY(1, 9,"123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789 ");
   Cwords(&CC1);
   cline((10-1)*ETen.ascii_width,(10-1)*ETen.ascii_height,
         CC1.scrx, (10+rows-1)*ETen.ascii_height, 15,1);
   cline((70+10-1)*ETen.ascii_width-1-CC1.scrx,(10+rows-1)*ETen.ascii_height,
         (70)*ETen.ascii_width,  (10-1)*ETen.ascii_height, 15,1);
   gotoxy(1,24);
}
******************************************************************************/
/******************************************************************************
void MessageColor     (int FFFF,int BBBB);
void DataBaseColor    (int FFFF,int BBBB);
void DataLightBarColor(int FFFF,int BBBB);
void Clrscr(void);
void MarkLine(char ScrII);
void UnMarkLine(char ScrII);
void DealWith_fget(char *fgetstring);
void StringKillString(char *src,char *kstr);
void OneBeep(unsigned int delaytime);
void Message(char beepflag,char blinkflag,char posflag,char *msg, ... );
void MessageOff(void);
void printfXY(char ScrX,char ScrY,char *msg, ... );
void cprintfXY(char ScrX,char ScrY,char *msg, ... );
BOOL2 Ask_Yes(char *askword);
BOOL2 Ask_No(char *askword);
void ToCwords(CWORDS *C,char *words,int size,int scrx,int scry,char space,char mode);
void CenterCwords(CWORDS *C,char *words,int row);
void BlockCenterCwords(CWORDS *C,char *words,int ulx,int uly,int brx,int bry);
void Cwords(CWORDS *C);
void CwordsOff(void);
void CenterCstring(char *dest,char *surc,int cCol);
void CenterCstring2(char *dest,char *surc,int cCol,int maxwspace);
void Encode1Output(char *s);
void Decode1(char *t);
void Encode1(char *t);
******************************************************************************/
