/*****************************************************************************/
/* STAT.C        Stat All data for UNIT                                      */
/*****************************************************************************/

#include"daymain.i"

double STATERR=0;
void ResetMoney(void)
{
   memset(IncomeST     ,0,INCOME_KINDS *sizeof(double));
   memset(ExpendST     ,0,EXPEND_KINDS *sizeof(double));
   ResetSTMoney();
}
void ResetSTMoney(void)
{
/*******
   memset(AccountLEST  ,0,ACCOUNT_KINDS*sizeof(double));
*********/
   SUMofLEST=0;

   memset(AccountIN    ,0,ACCOUNT_KINDS*sizeof(double));
   memset(AccountEX    ,0,ACCOUNT_KINDS*sizeof(double));
   memset(AccountST    ,0,ACCOUNT_KINDS*sizeof(double));
   SUMofIN  =0;
   SUMofEX  =0;
   SUMofST  =0;
}
void AddUnitMoney(DAYUNIT *Mtmp)
{
   char money[11];
   double dmoney;
   int type1;

   strncpy(money,Mtmp->money,10); money[10]='\0';
   dmoney=atof(money);
   if(Mtmp->in_or_ex == 'A')  /* income */
   {
      type1=Mtmp->type - 'A';
      if(type1>=0 && type1<=income_num-2)
         IncomeST[type1]+=dmoney;
      else
         STATERR+=dmoney;
   }
   else                       /* expend */
   {
      type1=Mtmp->type - 'A';
      if(type1>=0 && type1<=expend_num-2)
         ExpendST[type1]+=dmoney;
      else
         STATERR+=dmoney;
   }
}
void DelUnitMoney(DAYUNIT *Mtmp)
{
   char money[11];
   double dmoney;
   int type1;

   strncpy(money,Mtmp->money,10); money[10]='\0';
   dmoney=atof(money);
   if(Mtmp->in_or_ex == 'A')  /* income */
   {
      type1=Mtmp->type - 'A';
      if(type1>=0 && type1<=income_num-2)
         IncomeST[type1] -=dmoney;
      else
         STATERR-=dmoney;
   }
   else                       /* expend */
   {
      type1=Mtmp->type - 'A';
      if(type1>=0 && type1<=expend_num-2)
         ExpendST[type1]-=dmoney;
      else
         STATERR-=dmoney;
   }
}
void CalculateMoney(void)
{
   int i;
   ResetSTMoney();
   for(i=0;i<income_num;i++)
      AccountIN[InAccount[i+1]-1]+=IncomeST[i];
   for(i=0;i<expend_num;i++)
      AccountEX[ExAccount[i+1]-1]+=ExpendST[i];
   for(i=0;i<account_num;i++)
      AccountST[i]=AccountIN[i]-AccountEX[i]+AccountLEST[i];
   for(i=0;i<account_num;i++)
      SUMofLEST+=AccountLEST[i],
      SUMofIN+=AccountIN[i],
      SUMofEX+=AccountEX[i],
      SUMofST+=AccountST[i];
}

/******************************************************************************
void ResetMoney(void);
void AddUnitMoney(DAYUNIT *Mtmp);
void DelUnitMoney(DAYUNIT *Mtmp);
void CalculateMoney(void);
******************************************************************************/
