/*****************************************************************************/
/* UNIO0.C       UNIO   0   for All prepare sub-routine and interrupt        */
/*****************************************************************************/

#include"daymain.i"

long far *cntptr=MK_FP(0x0040,0x006c); /* Get tick of time */
void interrupt clock(void);            /* For modify INT 0x08 0x09 */
void interrupt (*oldclock)();
void interrupt key(void);
void interrupt (*oldkey)();
char active08=0,active09=0;            /* Flag of active INT */
long old_time=0;
long this_time=0;
long after_time=60*18.2;

void *exit_f1(void)                    /* Exit function to set INT back */
{
   setvect(0x08,oldclock);
   setvect(0x09,oldkey);
   CVRmenuOff();
   Free_ALL();
   fcloseall();
   window(1,1,80,25);
   normvideo();
   MessageOff();
   ShowProgram();
   Cursor(1);
   exit(0);
}
enum PROCESS { ABORT, CONTINUE };
int  NormalControlBreak(void)
{
/* (*exit_f1)();
   return (ABORT);               /* quit program */  */
   return (CONTINUE);            /* continue program */
}
int  PrintControlBreak(void)
{
   extern char *printmessage;
   int ch;
   struct text_info R;

   if(FlagOfPrintBreak==1) return (CONTINUE);   /* continue working */
   gettextinfo(&R);

   FlagOfBreakPress=1;
   Message(0,0,1,"zF Ctrl-Break I аݬO_nCL  [R] ~CL  [A] CL H");
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   do{
      ch=bioskey(0);
      ch=(ch==Esc)?N_A:ch;
   }while(!(ch==N_R || ch==S_R || ch==N_A || ch==S_A));
   Cursor(0);
   MessageOff();

   window(R.winleft,R.wintop,R.winright,R.winbottom);
   textattr(R.attribute);
   gotoxy(R.curx,R.cury);

   if(ch==N_A || ch==S_A)FlagOfPrintBreak=1;
   else                  FlagOfPrintBreak=0;
   Message(0,0,0,printmessage);
   return (CONTINUE);                  /* continue working */
}
void interrupt clock(void)             /* New INT 0x08 */
{
   oldclock();
   if (active08) return;
   if (FlagOfPrinting) return;
   if (after_time==0) return;
   active08=1;

   old_time=(old_time==0)?(*cntptr):old_time;
   this_time = (*cntptr);
   if(this_time-old_time>=after_time)
      ScreenProtect();

   active08=0;
}
void interrupt key(void)               /* New INT 0x09 */
{
   oldkey();
   if (active09) return;
   if (FlagOfPrinting) return;
   active09=1;

   old_time=(*cntptr);

   active09=0;
}
char *WordsOfAuthor[]={
"",
"    ",
"    ",
"     O  b  {     ",
"                        ",
"   0.254      ",
"                        ",
" {]p  G     ",
"",
"~  ⢯뢯",
""};
char *modifyfile="ɮפwgDקAu۱v{ǡI";   /* joking */
unsigned char *NameOfAuthor= /* "  " */
"\x08\x00"
"\xAF\xA4\xC4\x78\x41\x61\x1D\xF6";
void ShowProgram(void)
{
   char *NameOfProgram;
   unsigned char *cAuthor;
   int  iAuthor;
   int i,j;

   window(1,1,80,24);
   normvideo();
   clrscr();
   window(1,1,80,25);
   textbackground(BLACK);
   for(j=1;j<=15;j=j+2)
   {
      textcolor(RED);
      for(i=1;i<=80;i=i+4)
         gotoxy(i,j),putch(''),putch('');
      textcolor(LIGHTRED);
      for(i=3;i<=80;i=i+4)
         gotoxy(i,j),putch(''),putch('');
   }
   for(j=2;j<=15;j=j+2)
   {
      textcolor(LIGHTRED);
      for(i=1;i<=80;i=i+4)
         gotoxy(i,j),putch(''),putch('');
      textcolor(RED);
      for(i=3;i<=80;i=i+4)
         gotoxy(i,j),putch(''),putch('');
   }
   printfXY(1,1,"%cCR;",27);                 /* ver 0.24 */ /* Redraw screen */
   textcolor(LIGHTGRAY);
   textbackground(BLUE);
   for(j=0;j<11;j++)
      gotoxy(3,3+j),cprintf("%s",WordsOfAuthor[j]);
   gotoxy(1,16);
   cAuthor=(unsigned char *)&WordsOfAuthor[7][41];
   for(i=0,iAuthor=0;i<8;i++)
      iAuthor+=(int)cAuthor[i];           /* 1262 */
   textcolor(WHITE);
   textbackground(BLUE);
   NameOfAuthor=Decode1(NameOfAuthor);
   gotoxy(44,10); cprintf("%s",NameOfAuthor);
   if(iAuthor!=1262)
   {
      Message(1,1,0,modifyfile);
      exit(0);
   }
   for(i=0,iAuthor=0;i<8;i++)
      iAuthor+=(int)NameOfAuthor[i];           /* 1262 */
   if(iAuthor!=1262)
   {
      Message(1,1,0,modifyfile);
      exit(0);
   }
   NameOfAuthor=Encode1(NameOfAuthor);
   gotoxy(30,6);
   NameOfProgram=(char *)&WordsOfAuthor[3][27];
   cprintf("%22.22s",NameOfProgram);
   printfXY(1,1,"%cCR;",27);                 /* ver 0.24 */ /* Redraw screen */
   gotoxy(1,16);
}
void CheckAllFile(void)
{
   if(FileExist("DAYSAT00.SAT")==TRUE && FileExist("DAYCFG00.CFG")==TRUE
      && FileExist("DAYDBF00.DBF")==TRUE/* && FileExist("DAYMAIN.HLP")==TRUE*/)
      return;
   Message(1,1,0,"lɮפA{LkI");
   sleep(3);
   exit(0);
}
BOOL2 ChineseSystem(void)
{
   unsigned int i;
   unsigned char j,k;
   return ETinfo(&i,&j,&k);
}
void PrepareMemain(void)
{
   char *eauthor=
"   \n"
"Daily Accounting System   Version 0.254   (c)  Jul.05,1995    by Lee Dong-Liang\n"
" ͼ ͼ ͼ ͼ\n";
   /* if(ChineseSystem()!=OK) */
   if(InitializeETen()!=OK)                        /* ver 0.248 */
   {
      clrscr();
      printf(eauthor);
      BBfill( 1, 1,24, 3,YELLOW    |BLUE<<4);      /* ver 0.24 */
      BBfill(25, 1,40, 3,LIGHTRED  |BLUE<<4);      /* ver 0.24 */
      BBfill(41, 1,59, 3,LIGHTGREEN|BLUE<<4);      /* ver 0.24 */
      BBfill(60, 1,80, 3,WHITE     |BLUE<<4);      /* ver 0.24 */
      printf("\n\7No Chinese System Found !"
               "\nPlease Run Chinese System First.\n");
      sleep(1);
      exit(0);
   }
   SetEnglishInput();
   Message(0,0,0,"{ɮˬdDDD");
   oldclock = getvect(0x08);                    /* Get Old INT 0x08 */
   oldkey = getvect(0x09);                      /* Get Old INT 0x09 */
   ctrlbrk(NormalControlBreak);                 /* Set Ctrl-Break function  */
   Cursor(0);
   ShowProgram();                               /* Showing Words of Program */
   sleep(2);
   atexit(exit_f1);                             /* Set Exit function caller */
   CheckAllFile();                              /* Check if needed files exist*/
   setvect(0x08,clock);                         /* Set New INT 0x08 */
   setvect(0x09,key);                           /* Set New INT 0x09 */
}
/******************************************************************************
void  *exit_f1(void);
int   NormalControlBreak(void);
int   PrintControlBreak(void);
void  interrupt clock(void);
void  interrupt key(void);
void  ShowProgram(void);
void  CheckAllFile(void);
BOOL2 ChineseSystem(void);
void  PrepareMemain(void);
******************************************************************************/
