/*****************************************************************************/
/* UNIO1-3.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"daymain.i"

char *accountheader=
            ";ɦW : DAYCFG00.CFG\n"
            ";\n"
            ";for Account  (b)\n"
            ";榡:\n"
            ";A=   b \n"
            "; \n"
            ";x |wwwwwww W (Ӥr,tťճ̦heQG)\n"
            ";|wwwwwwww  N (A  J) ̦hQء]tťա^\n"
            "; =        w\n"
            ";\n"
            ";x\n"
            ";|wwwwwww  ť,|]wκA\n";
char *incomeheader=
            ";for Income  (J)\n"
            ";榡:\n"
            ";A=ӤHJ|=A\n"
            ";           \n"
            ";x x          x\n"
            ";x x          |w ϥαb᪺N\n"
            ";x |wwwwwww W (Ӥr,tťճ̦heQG)\n"
            ";|wwwwwwww  N (A  T) ̦hGQء]tťա^\n"
            "; =        w=\n"
            ";              \n"
            ";x              x\n"
            ";|wwwwwwwr  ť,|]wκA\n";
char *expendheader=
            ";for Expenditure (X)\n"
            ";榡:\n"
            ";A=    X=A\n"
            ";           \n"
            ";x x          x\n"
            ";x x          |w ϥαb᪺N\n"
            ";x |wwwwwww W (Ӥr,tťճ̦heQG)\n"
            ";|wwwwwwww  N (A  T) ̦hGQء]tťա^\n"
            "; =        w=\n"
            ";              \n"
            ";x              x\n"
            ";|wwwwwwwr  ť,|]wκA\n";
char *endfooter=
            ";H \";\" }Y,(Remark Line)\n"
            ";\n"
            ";C@W٦bwqᶷ@欰\n"
            ";[END]\n";
char *accountbegin="[bW]\n";
char *incomebegin ="[JW]\n";
char *expendbegin ="[XW]\n";
char *ending   ="[END]\n";
void Write_CFG(char *CFG_filename)     /* Setting unitshort[],unitlong[], */
{                                      /* and typeshort[]                 */
   char *DOSCommand;
   int   i;

   if(GetDiskFreeSpace(CFG_filename[0])<2048L)
   {
      Message(1,0,0,"%sЪŶI]wɵLkإߡI",FullAlpha[CFG_filename[0]]);
      return;
   }
   if( (File_CFG=fopen(CFG_filename,"w"))==NULL)
   {
      Message(1,0,0,"]wɼgJ~I");
      return;
   }
   fprintf(File_CFG,"%s\n",accountheader);
   fprintf(File_CFG,"%s\n",accountbegin);
   for(i=0;i<account_num;i++)
   {
      if(i==0)
         fprintf(File_CFG," =%12.12s\n",account[i]);
      else
         fprintf(File_CFG,"%c=%12.12s\n",'A'+i-1,account[i]);
   }
   fprintf(File_CFG,"\n%s\n",ending);

   fprintf(File_CFG,"%s\n",incomeheader);
   fprintf(File_CFG,"%s\n",incomebegin);
   for(i=0;i<income_num;i++)
   {
      if(i==0)
         fprintf(File_CFG," =%12.12s= \n",income[i]);
      else
         fprintf(File_CFG,"%c=%12.12s=%c\n",'A'+i-1,income[i],InAccount[i]+'A'-1);
   }
   fprintf(File_CFG,"\n%s\n",ending);

   fprintf(File_CFG,"%s\n",expendheader);
   fprintf(File_CFG,"%s\n",expendbegin);
   for(i=0;i<expend_num;i++)
   {
      if(i==0)
         fprintf(File_CFG," =%12.12s= \n",expend[i]);
      else
         fprintf(File_CFG,"%c=%12.12s=%c\n",'A'+i-1,expend[i],ExAccount[i]+'A'-1);
   }
   fprintf(File_CFG,"\n%s\n",ending);

   fprintf(File_CFG,"%s",endfooter);
   fclose(File_CFG);                            /* Close CFG file */

   if(GetDiskFreeSpace(IC_Path[0])>2048L)
   {
      DOSCommand=(char *)calloc(128,sizeof(char));
      strcpy(DOSCommand,"COPY ");
      strcat(DOSCommand,CFG_filename);
      strcat(DOSCommand," ");
      strcat(DOSCommand,IC_Path);
      strcat(DOSCommand,"DAYCFG00.CFG");
      strcat(DOSCommand," >NUL");
      system(DOSCommand);              /* copy file by call DOS command.com */
      free(DOSCommand);
   }
}
void Read_CFG(char *CFG_filename)      /* Setting unitshort[],unitlong[], */
{                                      /* and typeshort[] from CFG file   */
   char *linetemp;     /* Size : 20 */ /* read line temp from file */
   char *nullstring="            ";
   char  accountflag=0;                /* If account setting in CFG file */
   char  incomeflag=0;                 /* If income  setting in CFG file */
   char  expendflag=0;                 /* If expend  setting in CFG file */
   int   i;

   account_num=0; income_num=0; expend_num=0;
   linetemp=(char *)calloc(20,sizeof(char)); /* Memory locate for Data */
   if( (File_CFG=fopen(CFG_filename,"r"))==NULL)
   {
      Message(1,0,0,"]wŪ~I");
      exit(0);
   }

   for(;fgets(linetemp,20,File_CFG)!=NULL;)
   {
      if(linetemp[0]==';')continue;              /* Deal with remark line */
      if(strnicmp(linetemp,accountbegin,10)==0)  /* if [bW] */
      {  accountflag=1; continue; }
      if(strnicmp(linetemp,incomebegin,10)==0)   /* if [JW] */
      {  incomeflag=1;  continue; }
      if(strnicmp(linetemp,expendbegin,10)==0)   /* if [XW] */
      {  expendflag=1;  continue; }
      if(strnicmp(linetemp,ending,5)==0)         /* if [END] */
      {  accountflag=0;incomeflag=0;expendflag=0;continue;  }
      if(accountflag==1 && ( (linetemp[0] >= 'A' && linetemp[0] <= 'A'+ACCOUNT_KINDS) || strncmp(linetemp," =",2)==0 ) )
      {
         i=(linetemp[0]==' ') ? 0 : linetemp[0]-'A'+1 ;
         if(linetemp[1]=='=')
            strncpy(account[i],&linetemp[2],12);
         account[i][12]='\0';
         account_num++;                         /* Count include ' ' */
         continue;
      }
      if(incomeflag==1 && ( (linetemp[0] >= 'A' && linetemp[0] <= 'A'+INCOME_KINDS) || strncmp(linetemp," =",2)==0 ) )
      {
         i=(linetemp[0]==' ') ? 0 : linetemp[0]-'A'+1 ;
         if(linetemp[1]=='=')
            strncpy(income[i],&linetemp[2],12);
         income[i][12]='\0';
         if(linetemp[14]=='=')
            InAccount[income_num]=(linetemp[15]==' ') ? 0 : linetemp[15]-'A'+1 ;
         InAccount[income_num]=(InAccount[income_num]<0 || InAccount[income_num]>account_num) ? 0 : InAccount[income_num] ;
         income_num++;                          /* Count include ' '*/
         continue;
      }
      if(expendflag==1 && ( (linetemp[0] >= 'A' && linetemp[0] <= 'A'+EXPEND_KINDS) || strncmp(linetemp," =",2)==0 ) )
      {
         i=(linetemp[0]==' ') ? 0 : linetemp[0]-'A'+1 ;
         if(linetemp[1]=='=')
            strncpy(expend[i],&linetemp[2],12);
         expend[i][12]='\0';
         if(linetemp[14]=='=')
            ExAccount[expend_num]=(linetemp[15]==' ') ? 0 : linetemp[15]-'A'+1 ;
         ExAccount[expend_num]=(ExAccount[expend_num]<0 || ExAccount[expend_num]>account_num) ? 0 : ExAccount[expend_num] ;
         expend_num++;                          /* Count include ' '*/
         continue;
      }
   }
   fclose(File_CFG);                            /* Close CFG file */
   free(linetemp);                      /* free unused memory */

   for(i=account_num;i<=ACCOUNT_KINDS;i++)
      strcpy(account[i],nullstring);
   for(i=income_num;i<=INCOME_KINDS;i++)
      InAccount[i]=0,
      strcpy(income[i],nullstring);
   for(i=expend_num;i<=EXPEND_KINDS;i++)
      ExAccount[i]=0,
      strcpy(expend[i],nullstring);
/*                                              /* Check */
   for(i=0;i<account_num;i++)
      printf("\n%c=%s",'A'+i-1,account[i]);
   for(i=0;i<income_num;i++)
      printf("\n%c=%s=%c",'A'+i-1,income[i],InAccount[i]+'A'-1);
   for(i=0;i<expend_num;i++)
      printf("\n%c=%s=%c",'A'+i-1,expend[i],ExAccount[i]+'A'-1);
   getch();                                              */
}
/******************************************************** Layout Mode *********
1                                                                             01
2                               ]wb~ץN                               2
3                                                                              3
4                                                                              4
5                                                                              5
6                           N      b   W                              6
7                                                                              7
8                            A   =   [123456789012]                            8
9                            B   =   [123456789012]                            9
01                           C   =   [123456789012]                           10
1                            D   =   [123456789012]                            1
2                            E   =   [123456789012]                            2
3                            F   =   [123456789012]                            3
4                            G   =   [123456789012]                            4
5                            H   =   [123456789012]                            5
6                            I   =   [123456789012]                            6
7                            J   =   [123456789012]                            7
8                                                                              8
9                                                                              9
02                                                                            20
1                                                                              1
2                                                                              2
3                                                                              3
4                                                                              4
 ]wAХ Ԣ s C  Ӣ ]w C                             5
******************************************************************************/
char SetSubstitution_0(void)
{
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   char *scrbuf;                    /* screen buffer */
   char *format1="            ";    /* format of all kinds of name */
   char *helpmsg="]wAХ Ԣ s C  Ӣ ]w C";
   char *accountwords="]wb~ץN";
   char Totalitem=10;
   char Hlen=12;
   CWORDS CC;
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen+1,i++)
      stemp[i]=(sstemp+total_stemp);
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* CenterCwords(&CC,accountwords,48); */
   CenterCwords(&CC,accountwords,3);               /* ver 0.248 */
   Cwords2(&CC);
   gotoxy(29, 6); printf("N      b   W ");
   for(i=0;i<ACCOUNT_KINDS;i++)
   {
      strcpy(stemp[i],account[i+1]);
      gotoxy(30,8+i);
      printf("%c   =   [",'A'+i);
      DrawWords2(stemp[i],wherex(),wherey(),Hlen);
      printf("]");
   }
   Replace_Mode();
   do{
      Message(0,0,0,helpmsg);
      ch=0;eitem=0;
      SetChineseInput();
      while(1)
      {
         ch=FGetWords(stemp[eitem],format1,39,8+eitem);
         DrawWords2(stemp[eitem],39,8+eitem,Hlen);

         if(ch==F2)break;              /* Save */
         if(ch==Esc)                   /* Exit No save */
         {
            CwordsOff2();
            puttext(1,1,80,24,scrbuf);
            free(scrbuf);
            free(sstemp);
            free(stemp);
            Cursor(0);
            Message(0,0,0,"~ץN]wSܡC");
            return NotOK;
         }
         if(ch==Enter)
                  eitem++;
         else  if(ch==Tab || ch==Down)
                  eitem++;
               else  if(ch==S_Tab || ch==Up)
                  eitem--;
         eitem=(eitem>Totalitem-1)?0:eitem;
         eitem=(eitem<0)?Totalitem-1:eitem;
      }
      Message(0,0,1,"%sAO_sɡH]^",accountwords);
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      ch=bioskey(0);
      ch=(ch==Esc)?N_N:ch;
      Cursor(0);
   }while(ch==N_N||ch==S_N);
   Message(0,1,0,"~ץN]wxsDDD");
                                          /* find the last substitution */
   for(i=0,account_num=1;i<ACCOUNT_KINDS;i++)
      if(strcmp(stemp[i],format1)!=0)
      {
         account_num++;
         strcpy(account[i+1],stemp[i]);
      }
      else
      {
         for(;i<ACCOUNT_KINDS;i++)
            strcpy(account[i+1],format1);
      }

   Write_CFG(Current_CFG);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(sstemp);
   free(stemp);
   Cursor(0);
   Message(0,0,0,"~ץN]wxsC");
   return OK;
}
/******************************************************** Layout Mode *********
1  ToCwords(&CC,headerword,24,30,5,2,'o');                                    01
2        ]wJX~ץN                                                2
3        N         W       ϥαbN          ~_b   N _  3
4         A   =   [123456789012]   =     [A]               xA=   b x  4
5         B   =   [123456789012]   =     [A]               xB=s ï  b x  5
6         C   =   [123456789012]   =     [A]               xC=        wx  6
7         D   =   [123456789012]   =     [A]               xD=        wx  7
8         E   =   [123456789012]   =     [A]               xE=        wx  8
9         F   =   [123456789012]   =     [A]               xF=        wx  9
01        G   =   [123456789012]   =     [A]               xG=        wx 10
1         H   =   [123456789012]   =     [A]               xH=        wx  1
2         I   =   [123456789012]   =     [A]               xI=        wx  2
3         J   =   [123456789012]   =     [A]               xJ=        wx  3
4         K   =   [123456789012]   =     [A]               x              x  4
5         L   =   [123456789012]   =     [A]               x              x  5
6         M   =   [123456789012]   =     [A]               x              x  6
7         N   =   [123456789012]   =     [A]               x              x  7
8         O   =   [123456789012]   =     [A]               x              x  8
9         P   =   [123456789012]   =     [A]               x              x  9
02        Q   =   [123456789012]   =     [A]               x              x 20
1         R   =   [123456789012]   =     [A]               x              x  1
2         S   =   [123456789012]   =     [A]               x              x  2
3         T   =   [123456789012]   =     [A]               x              x  3
4                                                          wwwwwww  4
 ]wAХ Ԣ s C  Ӣ ]w C                             5
******************************************************************************/

char SetSubstitution_1_2(char Stype)
{
   extern char *AClegendword;       /* bW٥N */
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   char *scrbuf;                    /* screen buffer */
   char *usedaccount;               /* pointer to In/ExAccount */
   char **Mtype;                    /* pointer to income[] / income[] */
   char *Mtype_num;                 /* pointer to income_num / expend_num */
   char *format1="            ";    /* format of all kinds of name */
   char *format2=" ";               /* format of used_account */
   char *helpmsg="]wAХ Ԣ s C  Ӣ ]w C";
   char *incomewords="]wJ~ץN";
   char *expendwords="]wX~ץN";
   char Totalitem=40;
   char Hlen[]={ 12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,
                 12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1,12, 1 };
   char Mtype_total;                /* refer to IN/EX_KINDS */
   CWORDS CC;
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen[i]+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen[i++]+1)
      stemp[i]=(sstemp+total_stemp);
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   normvideo();
   Clrscr();                                       /* Drawing Screen */
   if(Stype==2)
   {
      /* ToCwords(&CC,expendwords,24,48,2,26,'o'); */
      BlockCenterCwords(&CC,expendwords,1,1,59,2);  /* ver 0.248 */
      usedaccount=ExAccount;
      Mtype=expend;
      Mtype_num=&expend_num;
      Mtype_total=EXPEND_KINDS;
   }
   else
   {
      /* ToCwords(&CC,incomewords,24,48,2,26,'o'); */
      BlockCenterCwords(&CC,incomewords,1,1,59,2);  /* ver 0.248 */
      usedaccount=InAccount;
      Mtype=income;
      Mtype_num=&income_num;
      Mtype_total=INCOME_KINDS;
   }
   Cwords2(&CC);
   gotoxy(10, 3); printf("N         W       ϥαbN");
   for(i=0;i<Mtype_total;i++)
   {
      strcpy(stemp[i*2],Mtype[i+1]);
      stemp[i*2+1][0]=(i+1<(*Mtype_num))?usedaccount[i+1]+'A'-1 : ' ';
      gotoxy(11,4+i);
      printf("%c   =   [",'A'+i);
      DrawWords2(stemp[i*2],wherex(),wherey(),Hlen[i*2]);
      printf("]   =     [");
      DrawWords2(stemp[i*2+1],wherex(),wherey(),Hlen[i*2+1]);
      printf("]");
   }
   ShowLegend(AClegendword,account,account_num);
   Replace_Mode();
   do{
      Message(0,0,0,helpmsg);
      ch=0;eitem=0;
      while(1)
      {
         if(eitem%2==0)
         {
            SetChineseInput();
            ch=FGetWords(stemp[eitem],format1,20,4+eitem/2);
            DrawWords2(stemp[eitem],20,4+eitem/2,Hlen[eitem]);
         }
         else
         {
            SetEnglishInput();
            ch=FGetWords(stemp[eitem],format2,43,4+eitem/2);
            if(strcmp(stemp[eitem-1],format1)!=0)
            {
               if(!isalpha(*(stemp[eitem])))  *(stemp[eitem])='A';
               if(islower(*(stemp[eitem])))   *(stemp[eitem])-='a'-'A';
               if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>account_num-2)  *(stemp[eitem])='A';
            }
            else
               *(stemp[eitem])=' ';
            DrawWords2(stemp[eitem],43,4+eitem/2,Hlen[eitem]);
         }

         if(ch==F2)break;              /* Save */
         if(ch==Esc)                   /* Exit No save */
         {
            CwordsOff2();
            puttext(1,1,80,24,scrbuf);
            free(scrbuf);
            free(sstemp);
            free(stemp);
            Cursor(0);
            Message(0,0,0,"~ץN]wSܡC");
            return NotOK;
         }
         if(ch==Enter)
                  eitem++;
         else  if(ch==Tab || ch==Down)
                  eitem++;
               else  if(ch==S_Tab || ch==Up)
                  eitem--;
         eitem=(eitem>Totalitem-1)?0:eitem;
         eitem=(eitem<0)?Totalitem-1:eitem;
      }
      Message(0,0,1,"%sAO_sɡH]^",(Stype==2)?expendwords:incomewords);
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      ch=bioskey(0);
      ch=(ch==Esc)?N_N:ch;
      Cursor(0);
   }while(ch==N_N||ch==S_N);
   Message(0,1,0,"~ץN]wxsDDD");
                                          /* find the last substitution */
   for(i=0,(*Mtype_num)=1;i<Mtype_total;i++)
      if(strcmp(stemp[i*2],format1)!=0 && strcmp(stemp[i*2+1],format2)!=0)
      {
         (*Mtype_num)++;
         strcpy(Mtype[i+1],stemp[i*2]);
         usedaccount[i+1]=stemp[i*2+1][0]-'A'+1;
      }
      else
      {
         for(;i<Mtype_total;i++)
            strcpy(Mtype[i+1],format1);
            usedaccount[i+1]=0;
      }

   Write_CFG(Current_CFG);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(sstemp);
   free(stemp);
   Cursor(0);
   Message(0,0,0,"~ץN]wxsC");
   return OK;
}
char SetSubstitution(char Stype)
{
   switch(Stype)
   {
      case 1: case 2:
         return SetSubstitution_1_2(Stype);
      default:
         return SetSubstitution_0();
   }
}
/******************************************************************************
void Write_CFG(char *CFG_filename);
void Read_CFG(char *CFG_filename);
char SetSubstitution_0(void);
char SetSubstitution_1_2(char Stype);
char SetSubstitution(char Stype)
******************************************************************************/
