/*****************************************************************************/
/* UNIO1-5.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"daymain.i"

char Input_Year(int *defaultyear)
{
   char *fword="  ";                   /* Format of word */
   char *scrbuf;                       /* Screen Buffer */
   char sword[3];                      /* words to get */
   int  ch;                            /* Key stroke */
   char x,y;                           /* Screen position */

   scrbuf=(char *)malloc(sizeof(char)*(62-20)*3*2);   /* Memory Alloc */
   gettext(20,12,61,14,scrbuf);        /* Get screen text contents */
   Clear_Frame(20,12,61,14);           /* Clear chars */
   CFrame(21,12,59,14,4);              /* Draw frame */
   itoa((*defaultyear),sword,10);      /* I.C. value */
   gotoxy(25,13);
   printf("пJsWɪ~סG[");
   DrawWords2(sword,x=wherex(),y=wherey(),2);
   printf("]~");
   Replace_Mode();
   do{
      ch=0;
      SetEnglishInput();
      while(ch!=Enter)
      {
         ch=DFGetWords(sword,fword,x,y);
         DrawWords2(sword,x,y,2);
         if(ch==Esc)
         {
            puttext(20,12,61,14,scrbuf);  /* Put back screen text */
            free(scrbuf);
            normvideo();
            Cursor(0);
            return USERBREAK ;         /* USERBREAK -> Esc Press no input */
         }
      }
   }while(atoi(sword)<0);
   *defaultyear=atoi(sword);

   puttext(20,12,61,14,scrbuf);        /* Put back screen text */
   free(scrbuf);
   normvideo();
   Cursor(0);
   return OK;                           /* OK -> year input */
}
char CreateNew(void)
{
   char *DOSCommand;
   char *Current_DAT;
   char file_ext[4];
   char datestring[9];
   char yearofdate[3];
   int  wantedyear;
   long bytes_need;
   int  i;

   bytes_need=GetDiskMinBlock(IC_Path[0]);
   bytes_need=(bytes_need>1024L)? bytes_need*3 : bytes_need*4 ;
   if(GetDiskFreeSpace(IC_Path[0])<bytes_need)
   {
      Message(1,0,0,"%sЪŶILksW~׸ɡI",FullAlpha[IC_Path[0]]);
      return NotOK;
   }
   Date_String(datestring);
   strncpy(yearofdate,datestring,2);
   yearofdate[2]='\0';
   if(YearType==0)wantedyear=atoi(yearofdate)-11;
   else           wantedyear=atoi(yearofdate);
   wantedyear=(wantedyear<0) ? wantedyear+100 : wantedyear ;
   if(Input_Year(&wantedyear)==USERBREAK)
      return NotOK;                        /* NotOK -> no New year Created */
   IntToString(yearofdate,wantedyear);

   Message(0,0,1,"O_nsW%s%s~תɡ]^H",
               FullNumb[yearofdate[0]-'0'],FullNumb[yearofdate[1]-'0']);
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   i=bioskey(0);
   Cursor(0);
   MessageOff();
   i=(i==Esc)?N_N:i;
   if(i==N_N || i==S_N)
   {
      Message(0,0,0,"ɩ|sWC");
      return NotOK;                        /* NotOK -> no New year Created */
   }
   DOSCommand=(char *)calloc(128,sizeof(char));
   strcpy(DOSCommand,IC_Path);
   strcat(DOSCommand,"DAY___");
   strcat(DOSCommand,yearofdate);
   strcat(DOSCommand,".");
   strcat(DOSCommand,"DBF");
   if(FileExist(DOSCommand)==TRUE)           /* Check if already exist ? */
   {
      Message(1,0,1,"~׸ɤwgsbI  O_\\g]Bܡ^H");
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      i=bioskey(0);
      i=(i==Esc)?N_N:i;
      Cursor(0);
      MessageOff();
      if(!(i==N_Y || i==S_Y))
      {
         free(DOSCommand);
         return NotOK;                       /* NotOK --> No New Created */
      }
   }
   Message(0,0,0,"ɷsWDDD");
   for(i=1;i<=3;i++)
   {
      switch(i)
      {
         case 1:  strcpy(file_ext,"CFG"); break;
         case 2:  strcpy(file_ext,"SAT"); break;
         case 3:  strcpy(file_ext,"DBF"); break;
      }
      strcpy(DOSCommand,"COPY ");
      strcat(DOSCommand,IC_Path);
      strcat(DOSCommand,"DAY");
      strcat(DOSCommand,file_ext);
      strcat(DOSCommand,"00.");
      strcat(DOSCommand,file_ext);
      strcat(DOSCommand," ");
      strcat(DOSCommand,IC_Path);
      strcat(DOSCommand,"DAY___");
      strcat(DOSCommand,yearofdate);
      strcat(DOSCommand,".");
      strcat(DOSCommand,file_ext);
      strcat(DOSCommand," >NUL");
      system(DOSCommand);              /* copy file by call DOS command.com */
   }
   Message(0,0,0,"ɷsWC");
   strcpy(DOSCommand,IC_Path);
   strcat(DOSCommand,"DAY___");
   strcat(DOSCommand,yearofdate);
   strcat(DOSCommand,".");
   strcat(DOSCommand,file_ext);
   i=FileExist(DOSCommand);
   free(DOSCommand);
   if(i==TRUE)                         /* Check File exist ? */
   {
      Clrscr();
      for(i=1;i<=3;i++)             /* Change Current_DBF.SAT.CFG. to New */
      {
         switch(i)
         {
            case 1:  strcpy(file_ext,"CFG"); Current_DAT=Current_CFG;   break;
            case 2:  strcpy(file_ext,"SAT"); Current_DAT=Current_SAT;   break;
            case 3:  strcpy(file_ext,"DBF"); Current_DAT=Current_DBF;   break;
         }
         strcpy(Current_DAT,IC_Path);
         strcat(Current_DAT,"DAY___");
         strcat(Current_DAT,yearofdate);
         strcat(Current_DAT,".");
         strcat(Current_DAT,file_ext);
      }
      Message(0,0,0,"Х]w~ױbBڶNHΤWC");
      sleep(1);
      Read_CFG(Current_CFG);
      SetSubstitution(0);
      SetSubstitution(1);
      SetSubstitution(2);
      Read_SAT(Current_SAT);
      SetBudget();
      Load_DBF2();
      Yes2Show();
      return OK;                        /* OK -> New Created */
   }
   else
   {
      Message(1,0,0,"ɮ׫~ILksWɡC");
      return ERROR;                    /* ERROR -> No New Created */
   }
}
char DeleteOld(void)
{
   char *dbf_file;         /* Selected DBF file, and for Delete */
   char *cfg_file;
   char *sat_file;
   BOOL2 delete;
   char flag;
   int  i;

   dbf_file=(char *)calloc(61,sizeof(char));
   SelectFile(1,1,20,"day___??.dbf","пܧRɮ",dbf_file,1);
   if(dbf_file[0]<'C')
      switch(DisketteWriteReady(dbf_file[0]))
      {
         case 0:  delete=OK;Message(0,0,0,"iHRC");break;
         case 1:  delete=NotOK;Message(1,0,0,"ХNgKȰhAARC");break;
         case 2:  delete=NotOK;Message(1,0,0,"Ϻо|ǳƦnI");break;
      }
   else
      delete=OK;
   if(delete==OK && FileExist(dbf_file)==TRUE)
   {
      Message(0,0,1,"O_nR%s%s~תɡ]Bܡ^H",
                  FullNumb[dbf_file[strlen(dbf_file)-6]-'0'],
                  FullNumb[dbf_file[strlen(dbf_file)-5]-'0']);
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      i=bioskey(0);
      i=(i==Esc)?N_N:i;
      Cursor(0);
      MessageOff();
      if(!(i==N_Y || i==S_Y))
      {
         free(dbf_file);
         Message(0,0,0,"ɥRC");
         return NotOK;                    /* NotOK -> No Old Deleted */
      }
      Message(0,1,0,"ɧRDDD");
      cfg_file=(char *)calloc(61,sizeof(char));
      sat_file=(char *)calloc(61,sizeof(char));
      GetPathFileExt(cfg_file,dbf_file,".CFG");
      GetPathFileExt(sat_file,dbf_file,".SAT");
      remove(cfg_file);
      remove(sat_file);
      if(remove(dbf_file)==0)
         delete=OK,Message(0,0,0,"ɤwRC");
      else
         delete=ERROR,Message(1,0,0,"ɵLkRI");
      free(sat_file);
      free(cfg_file);
   }
   if(delete==1 && strncmp(Current_DBF,dbf_file,strlen(Current_DBF))==0)
      delete=OTHER;
   free(dbf_file);
   return delete;                      /* ERROR -> No Old Delete (some Error) */
                                       /* NotOK -> No Old Delete */
                                       /* OK -> Delete Data file */
                                       /* OTHER -> Delete Current Data File */
}
char BackupCurrent(char cDrive)
{
   char *BackupPath;
   char *DOSCommand;
   char *Backup_DAT;
   char file_ext[4];
   char backupflag;
   int  i;

   BackupPath=(char *)calloc(61,sizeof(char));

   if(cDrive=='a' || cDrive=='A' || cDrive=='b' || cDrive=='B')
   {
      BackupPath[0]=cDrive;
      BackupPath[1]=':';
      BackupPath[2]='\\';
      BackupPath[3]='\0';
   }
   else
   {
      Message(0,0,0,"Х Enter ܳƥ|AܧЫ ӢC");
      SelectPath(1,1,20,"пܳƥ|",BackupPath,1);
   }

   Message(0,0,1,"O_ƥؿG%s]^H",BackupPath);
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   i=bioskey(0);
   Cursor(0);
   MessageOff();
   i=(i==Esc)?N_N:i;
   if(i==N_N || i==S_N)
   {
      free(BackupPath);
      Message(0,0,0,"ɩ|ƥC");
      return NotOK;
   }
   Message(0,1,0,"ɳƥDDD");
   if(BackupPath[0]<'C')
      switch((DisketteWriteReady(BackupPath[0]),
              DisketteWriteReady(BackupPath[0])))   /* check driver ready ? */
      {
         case 0:  backupflag=1;break;
         case 1:  backupflag=0;Message(1,0,0,"ХNgKȰhAAƥC");break;
         case 2:  backupflag=0;Message(1,0,0,"Ϻо|ǳƦnI");break;
      }
   else
      backupflag=1;
   if(backupflag==0)
   {
      free(BackupPath);
      return NotOK;
   }
   if(GetDiskFreeSpace(BackupPath[0])<GetDiskMinBlock(BackupPath[0])*3+DBF_HeaderLen+(C_IndexY+C_IndexN)*sizeof(DAYUNIT))
   {
      Message(1,0,0,"%sЪŶIƥɵLkإߡI",FullAlpha[BackupPath[0]]);
      free(BackupPath);
      return NotOK;
   }
   DOSCommand=(char *)calloc(128,sizeof(char));
   strcpy(DOSCommand,BackupPath);
   strcat(DOSCommand,"DAYBAK");
   strncat(DOSCommand,CurrentYearOfDate,2);
   strcat(DOSCommand,".");
   strcat(DOSCommand,"DBF");
   if(FileExist(DOSCommand)==TRUE)           /* Check if already exist ? */
   {
      Message(1,0,1,"ƥɤwgsbI  O_\\g]Bܡ^H");
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      i=bioskey(0);
      i=(i==Esc)?N_N:i;
      Cursor(0);
      MessageOff();
      if(!(i==N_Y || i==S_Y))
      {
         free(DOSCommand);
         free(BackupPath);
         return NotOK;                 /* NotOK -> No Backup Data File */
      }
   }
   if(BackupPath[0]<'C')
      switch((DisketteWriteReady(BackupPath[0]),
              DisketteWriteReady(BackupPath[0])))   /* check driver ready ? */
      {
         case 0:  backupflag=1;break;
         case 1:  backupflag=0;Message(1,0,0,"ХNgKȰhAAƥC");break;
         case 2:  backupflag=0;Message(1,0,0,"Ϻо|ǳƦnI");break;
      }
   else
      backupflag=1;
   if(backupflag==0)
   {
      free(DOSCommand);
      free(BackupPath);
      return NotOK;                       /* NotOK -> No Backup Data File */
   }
   Message(0,1,0,"ɳƥDDD");
   for(i=1;i<=3;i++)
   {
      switch(i)
      {
         case 1:  Backup_DAT=Current_CFG;strcpy(file_ext,"CFG"); break;
         case 2:  Backup_DAT=Current_SAT;strcpy(file_ext,"SAT"); break;
         case 3:  Backup_DAT=Current_DBF;strcpy(file_ext,"DBF"); break;
      }
      strcpy(DOSCommand,"COPY ");
      strcat(DOSCommand,Backup_DAT);
      strcat(DOSCommand," ");
      strcat(DOSCommand,BackupPath);
      strcat(DOSCommand,"DAYBAK");
      strncat(DOSCommand,CurrentYearOfDate,2);
      strcat(DOSCommand,".");
      strcat(DOSCommand,file_ext);
      strcat(DOSCommand," >NUL");
      system(DOSCommand);              /* copy file by call DOS command.com */
   }
   free(DOSCommand);
   free(BackupPath);
   Message(0,0,0,"ɳƥC");

   return OK;                           /* OK -> Backup Data File OK */
}
char RestoreCurrent(char cDrive)
{
   char *RestorePath;
   char *DOSCommand;
   char *Restore_DAT;
   char *PtrOfDta;
   char restoreyear[3];
   char file_ext[5];
   struct ffblk FF;
   char restoreflag;
   int  i;

   RestorePath=(char *)calloc(61,sizeof(char));

   if(cDrive=='a' || cDrive=='A' || cDrive=='b' || cDrive=='B')
   {
      char Oldpath[128];     /* Save Old Path */
      char far *PtrOfDta_;  /* Pointer Of DTA */
      char found_restore_file;
      strcpy(Oldpath,"X:\\");                      /* Save Old Path */
      Oldpath[0]='A'+getdisk();
      getcurdir(0,Oldpath+3);
      PtrOfDta_=(char far *)getdta();
      if(cDrive=='a')cDrive='A'; if(cDrive=='b')cDrive='B';
      RestorePath[0]=cDrive;
      RestorePath[1]=':';
      RestorePath[2]='\\';
      RestorePath[3]='\0';

      switch((DisketteReadReady(cDrive),
              DisketteReadReady(cDrive)))  /* check driver ready ? */
      {
         case 0:  break;
         case 1:  Message(1,0,0,"Ϻо|ǳƦnI");
                  free(RestorePath);
                  return NotOK;        /* NotOK -> No Restore Data File */
         default: break;
      }
      setdisk(cDrive-'A');
      found_restore_file=Get_NewDBF_Restore(&RestorePath[3]);

      setdta(PtrOfDta_);
      setdisk(Oldpath[0]-'A');                     /* Back to Old Drive */
      chdir(Oldpath);                              /* Back to Old Path */
      if(found_restore_file!=OK)
      {
         free(RestorePath);
         return NotOK;                    /* NotOK -> No Restore Data File */
      }
   }
   else
   {
      Message(0,0,0,"Х Enter ܭn^ƥɡC");
      SelectFile(1,1,20,"DAYBAK??.DBF","пܨ^ɮ",RestorePath,1);
      if(FileExist(RestorePath)!=TRUE)
      {
         free(RestorePath);
         Message(0,0,0,"|ܳƥɡC");
         return NotOK;                    /* NotOK -> No Restore Data File */
      }
   }
   i=strlen(RestorePath);
   restoreyear[0]=RestorePath[i-6];
   restoreyear[1]=RestorePath[i-5];
   restoreyear[2]='\0';

   Message(0,0,1,"O_^%s%s~תƥơ]^H",
            FullNumb[restoreyear[0]-'0'],FullNumb[restoreyear[1]-'0']);
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   i=bioskey(0);
   Cursor(0);
   MessageOff();
   i=(i==Esc)?N_N:i;
   if(i==N_N || i==S_N)
   {
      free(RestorePath);
      Message(0,0,0,"ƥɩ|^C");
      return NotOK;                       /* NotOK -> No Restore Data File */
   }
   DOSCommand=(char *)calloc(128,sizeof(char));
   strcpy(DOSCommand,IC_Path);
   strcat(DOSCommand,"DAY___");
   strncat(DOSCommand,restoreyear,2);
   strcat(DOSCommand,".");
   strcat(DOSCommand,"DBF");
   if(FileExist(DOSCommand)==TRUE)           /* Check if already exist ? */
   {
      Message(1,0,1,"~תɤwgsbI O_nHƥƻ\\g]Bܡ^H");
      Cursor(2);
      Clear_KeyBuf();
      SetEnglishInput();
      i=bioskey(0);
      i=(i==Esc)?N_N:i;
      Cursor(0);
      MessageOff();
      if(!(i==N_Y || i==S_Y))
      {
         free(DOSCommand);
         free(RestorePath);
         Message(0,0,0,"ƥɩ|^C");
         return NotOK;                 /* NotOK -> No Restore Data File */
      }
   }
   Message(0,1,0,"ɨ^DDD");
   if(RestorePath[0]<'C')
      switch((DisketteReadReady(RestorePath[0]),
              DisketteReadReady(RestorePath[0])))  /* check driver ready ? */
      {
         case 0:  restoreflag=1;break;
         case 1:  restoreflag=0;Message(1,0,0,"Ϻо|ǳƦnI");break;
      }
   else
      restoreflag=1;
   if(restoreflag==0)
   {
      free(DOSCommand);
      free(RestorePath);
      if(C_IndexS==0)sleep(2);
      return NotOK;                    /* NotOK -> No Restore Data File */
   }
   Message(0,1,0,"ɨ^DDD");
   Restore_DAT=(char *)calloc(61,sizeof(char));
   for(i=1;i<=3;i++)
   {
      switch(i)
      {
         case 1:  strcpy(file_ext,".DBF"); break;
         case 2:  strcpy(file_ext,".CFG"); break;
         case 3:  strcpy(file_ext,".SAT"); break;
      }
      strcpy(DOSCommand,"COPY ");
      GetPathFileExt(Restore_DAT,RestorePath,file_ext);
      if(i==1)
      {
         PtrOfDta=(char *)getdta();
         findfirst(Restore_DAT,&FF,0x16);
         setdta(PtrOfDta);
         if(GetDiskFreeSpace(IC_Path[0])<GetDiskMinBlock(IC_Path[0])*3+FF.ff_fsize)
         {
            Message(1,0,0,"%sЪŶIƥɵLk^I",FullAlpha[IC_Path[0]]);
            free(Restore_DAT);
            free(DOSCommand);
            free(RestorePath);
            return NotOK;
         }
      }
      strcat(DOSCommand,Restore_DAT);
      strcat(DOSCommand," ");
      strcat(DOSCommand,IC_Path);
      strcat(DOSCommand,"DAY___");
      strncat(DOSCommand,restoreyear,2);
      strcat(DOSCommand,file_ext);
      strcat(DOSCommand," >NUL");
      system(DOSCommand);              /* copy file by call DOS command.com */
   }
   free(Restore_DAT);
   free(DOSCommand);
   free(RestorePath);
   Message(0,0,0,"ƥɨ^C");
                                    /* check if restore to current database ? */
   if(strncmp(CurrentYearOfDate,restoreyear,2)==0)
      return OTHER;           /* OTHER -> Restore to Current & need Reload DBF */
   else
      return OK;              /* OK -> Restore Data File OK */
}

/******************************************************************************
char Input_Year(int *defaultyear);
char CreateNew(void);
char DeleteOld(void);
char BackupCurrent(char cDrive);
char RestoreCurrent(char cDrive);
******************************************************************************/
