/*****************************************************************************/
/* UNIO1.C     View the Header of *.R_C files                                */
/*****************************************************************************/

#include"viewer.i"

char *showmsgwords="%-63.63sӢ뵲dߡC";
char *showmsgwords1="Шϥδd߸ơC  PgUp PgDn Home End";

BOOL2 ShowROWCOL(char *R_C_filename)
{
   FILE *R_Cfile;
   char **rcheader;
   char *rcheaderbase;
   char far *rcheaderindex;
   int  *rcindex;
   ROWCOL rc;
   int  totalrow;
   int  sx,sy,ch;
   int  i,j,k,l;
#ifdef _LARGE_
   unsigned int index_seg;   /* for far pointer of index */
   unsigned int index_off;   /* for far pointer of index */
#endif

   if((R_Cfile=fopen(R_C_filename,"rb"))==NULL)
   {
      Message(1,0,0,"ɮ \"%s\" }ҿ~I",R_C_filename);
      Clear_KeyBuf();
      bioskey(0);
      return(NotOK);
   }
   rewind(R_Cfile);
   if(fread(&rc,sizeof(ROWCOL),1,R_Cfile)!=1)
   {
      Message(1,0,0,"ɮ \"%s\" Ū~I",R_C_filename);
      Clear_KeyBuf();
      bioskey(0);
      return(NotOK);
   }
   rcindex=(int *)calloc(rc.height+rc.trow,sizeof(int));
   rcheader=(char **)calloc(rc.height,sizeof(char *));
   rcheaderbase=(char *)calloc((rc.width+1)*rc.height,sizeof(char));
   rcheaderindex=(char far *)rcheaderbase;
   for(i=0;i<rc.height;i++)
   {
      rcheader[i]=(char *)rcheaderindex;
      rcheaderindex+=sizeof(char)*(rc.width+1);
#ifdef _LARGE_
      index_off=FP_OFF(rcheaderindex);
      index_seg=FP_SEG(rcheaderindex);
      rcheaderindex=MK_FP(index_seg+(index_off>>4),index_off%16);
#endif
   }
   fseek(R_Cfile,rc.headerlen,SEEK_SET);
   if(fread(rcheaderbase,rc.width+1,rc.height,R_Cfile)!=rc.height)
   {
      Message(1,0,0,"ɮ \"%s\" Ū~I",R_C_filename);
      Clear_KeyBuf();
      bioskey(0);
      return(NotOK);
   }

   rcindex[0]=0;
   for(i=0;i<rc.hdrow;i++)
      rcindex[1+i]=rc.hdwordbeg+i;
   for(j=0,l=0;j<rc.trow;j++)
   {
      rcindex[1+i++]=rc.hdwordbeg-2;
      for(k=0;k<rc.row[j];k++)
         rcindex[1+i++]=rc.hdwordbeg+rc.hdrow+l++;
   }
   rcindex[1+i++]=rc.hdwordbeg-1;
   totalrow=i+1;

   Cursor(0);
   i=sx=sy=0;
   DrawTextWindow3(rc.col[0],3,80,23,totalrow,rcheader,rcindex,&sy);
   totalrow-=rc.hdrow+2;
   memmove(&rcindex[0],&rcindex[rc.hdrow+2],totalrow*sizeof(int));
                                 /* header fixed */
   Message(0,0,0,showmsgwords,(totalrow>23-(rc.hdrow+2+3)+1)?showmsgwords1:"");
   while(TextWindow5(rc.col[0],rc.hdrow+2+3,80,23,totalrow,rcheader,rcindex,&sx,&sy)!=Esc)
   {
      if(sx==totalrow-1)Message(0,0,0,showmsgwords,"ɮ׵");
      else if(sx==0)    Message(0,0,0,showmsgwords,"ɮ׶}Y");
           else         Message(0,0,0,showmsgwords,(totalrow>23-4+1)?showmsgwords1:"");
      if(i==sy)OneBeep(200),Clear_KeyBuf();
      i=sy;
   }

   free(rcheaderbase);
   free(rcheader);
   free(rcindex);
   fclose(R_Cfile);
   return OK;
}
int ShowTXTMaxinumLines=1000;
char *upperline= "";
char *lowerline= "";
BOOL2 ShowTXTfile(char *TXTfilename)
{
   FILE *TXTfile;
   char **txt;
   char *txtbase;
   char far *txtindex;
   char *linetmp;
   int  totalrow;
   int  sx,sy,ch;
   int  i;
   int  iLenR;
#ifdef _LARGE_
   unsigned int index_seg;   /* for far pointer of index */
   unsigned int index_off;   /* for far pointer of index */
#endif

   if((TXTfile=fopen(TXTfilename,"r"))==NULL)
   {
      gotoxy(1,3); printf(upperline);
      gotoxy(1,24);printf(lowerline);
      Message(1,0,0,"ɮ \"%s\" }ҿ~I",TXTfilename);
      Clear_KeyBuf();
      bioskey(0);
      return NotOK;
   }
   iLenR=sizeof(char)*81+sizeof(char *);
   ShowTXTMaxinumLines=(coreleft()-32000L)/iLenR;
   txt=(char **)farcalloc(ShowTXTMaxinumLines,sizeof(char *));
   txtbase=(char *)farcalloc(ShowTXTMaxinumLines,sizeof(char)*81);
   linetmp=(char *)farcalloc(257,sizeof(char));
   txtindex=(char far *)txtbase;
   for(i=0;i<ShowTXTMaxinumLines;i++)
   {
      txt[i]=(char *)txtindex;
      txtindex+=sizeof(char)*81;
#ifdef _LARGE_
      index_off=FP_OFF(txtindex);
      index_seg=FP_SEG(txtindex);
      txtindex=MK_FP(index_seg+(index_off>>4),index_off%16);
#endif
   }
   for(i=0;i<ShowTXTMaxinumLines && fgets(linetmp,257,TXTfile);i++)
   {
      linetmp[80]='\0';
      DealWith_fget(linetmp);
      strcpy(txt[i],linetmp);
   }

   /* totalrow=FindBlockEnd(txt,ShowTXTMaxinumLines)+1; */
   totalrow=i;
   gotoxy(1,3); printf(upperline);
   gotoxy(1,24);printf(lowerline);
   i=sx=sy=0;
   Cursor(0);
   DrawTextWindow2(1,4,80,23,totalrow,txt,&sy);
   Message(0,0,0,showmsgwords,(totalrow>23-4+1)?showmsgwords1:"");
   while(TextWindow4(1,4,80,23,totalrow,txt,&sx,&sy)!=Esc)
   {
      if(sx==totalrow-1)Message(0,0,0,showmsgwords,"ɮ׵");
      else if(sx==0)    Message(0,0,0,showmsgwords,"ɮ׶}Y");
           else         Message(0,0,0,showmsgwords,(totalrow>23-4+1)?showmsgwords1:"");
      if(i==sy)OneBeep(200),Clear_KeyBuf();
      i=sy;
   }

   farfree(linetmp);
   farfree(txtbase);
   farfree(txt);
   fclose(TXTfile);
   return OK;
}
