/*****************************************************************************/
/* UNIO2-1.C     Unit I/O  2  for Screen input/output                        */
/*****************************************************************************/

#include"daymain.i"

char *HHtemp01="                K                                    n        B ";
char *HHtemp02=" ========= ============ ======================================== == ===========";
char *HHtemp03="  %8.8s %12.12s %40.40s %2.2s %10.10s";
char *HHtemp11="     b                  K                          n        B";
char *HHtemp12="======== ============ ============ ============================== == ==========";
char *HHtemp13="%8.8s %12.12s %12.12s %30.30s %2.2s %10.10s";
char *HHtemp21="       ǲX           K                          n        B ";
char *HHtemp22="========= ========== ============ ============================== == ===========";
char *HHtemp23=" %8.8s %10.10s %12.12s %30.30s %2.2s %10.10s";
char *null   ="                                                                               ";
char *typeof_in_or_ex[]={"","",""};
char *datatype[]={"","{s","jM","R"};
char *sorttype0[]={"W",""};
char *sorttype1[]={"",""};
char *sorttype2[]={"","ɮ","","","ڶ","b","Kn","B","ǲ"};

void ShowOneUnit(DAYUNITSHOW *S)
{
   DAYUNIT s;
   char **moneytype;
   ReadOneUnit(&s,S->index);
   moneytype = (S->in_or_ex==1) ? income : expend ;
   gotoxy(1,wherey());
   switch(DisplayType)
   {
      case 1:
         printf(HHtemp13, s.date, account[S->account], moneytype[S->type],
               s.memo, typeof_in_or_ex[S->in_or_ex], s.money ); break;
      case 2:
         printf(HHtemp23, s.date, s.tk_no ,moneytype[S->type],
               s.memo, typeof_in_or_ex[S->in_or_ex], s.money ); break;
      default:
         printf(HHtemp03, s.date,                      moneytype[S->type],
               s.memo, typeof_in_or_ex[S->in_or_ex], s.money ); break;
   }
}
void ShowOneUnitWithHeader(char ScrY,DAYUNITSHOW *S)
{
   switch(DisplayType)
   {
      case 1:
         gotoxy(1,ScrY  );printf(HHtemp11);gotoxy(1,ScrY+1);printf(HHtemp12);break;
      case 2:
         gotoxy(1,ScrY  );printf(HHtemp21);gotoxy(1,ScrY+1);printf(HHtemp22);break;
      default:
         gotoxy(1,ScrY  );printf(HHtemp01);gotoxy(1,ScrY+1);printf(HHtemp02);break;
   }
   gotoxy(1,ScrY+2);ShowOneUnit(S);
}
void OffShowOneUnitWithHeader(char ScrY)
{
   gotoxy(1,ScrY  );printf(null);
   gotoxy(1,ScrY+1);printf(null);
   gotoxy(1,ScrY+2);printf(null);
}
void ShowOneNull(void)
{
   gotoxy(1,wherey());printf(null);
}
void showu1(int ScrJ,int ScrI)               /* show data as total not */
{                                            /* enough for a page      */
   int i;                                    /* or specific top Rec of data */
   gotoxy(1,First);
   for(i=ScrJ;i<ScrJ+PAGEL && i<C_IndexS;i++)
      ShowOneUnit(ALL[IndexS[i]]),putch('\n');
   if(i>=C_IndexS)
      for(;i<ScrJ+PAGEL;i++)ShowOneNull(),putch('\n');
   MarkLine(ScrI-ScrJ+First);
}
void showu2(int ScrJ,int ScrI)                  /* show data  only mark */
{                                               /* different position   */
   MarkLine(ScrI-ScrJ+First);
}
void showu3(int ScrJ,int ScrI)                  /* show data Up scroll */
{
   window(1,First,80,First+PAGEL-1);
   gotoxy(1,1);
   delline();
   gotoxy(1,PAGEL);
   if(C_IndexS-ScrJ>=PAGEL)
      ShowOneUnit(ALL[IndexS[ScrJ+PAGEL-1]]);
   else
      ShowOneNull();
   window(1,1,80,25);
   MarkLine(ScrI-ScrJ+First);
}
void showu4(int ScrJ,int ScrI)                  /* show data Down Scroll */
{
   window(1,First,80,First+PAGEL-1);
   gotoxy(1,PAGEL);
   delline();
   gotoxy(1,1);
   insline();
   gotoxy(1,1);
   ShowOneUnit(ALL[IndexS[ScrJ]]);
   window(1,1,80,25);
   MarkLine(ScrI-ScrJ+First);
}
void ShowInfo(int ScrI)
{
   char datestring[9];
   char i,j;
/******************************************************************************
00/00/00  AA~   A   ƫAGAA   ƧǡGӣAAA   @0000 0000
******************************************************************************/
   gotoxy(1,24);
   Date_String(datestring);
   printf("%s",datestring);
   gotoxy(11,24);
   i=CurrentYearOfDate[0]-'0';
   j=CurrentYearOfDate[1]-'0';
   i=(i<0 || i>9)?0:i;
   j=(j<0 || j>9)?0:j;
   printf("%s%s~",FullNumb[i],FullNumb[j]);
   gotoxy(22,24);
   i=Current_DBF[0]-'A';
   i=(i<0 || i>25)?23:i;
   printf("%s",FullAlpha[i]);
   gotoxy(29,24);
   printf("ƫAG%s",datatype[CurrentDataType]);
   gotoxy(63,24);
   printf("@%4d %4d",C_IndexS,ScrI+1);
   gotoxy(46,24);
   printf("ƧǡG%s%s",sorttype1[(CurrentSortType>10)?1:0],sorttype2[CurrentSortType%10]);
}
void DrawForm(void)
{
   switch(DisplayType)
   {
      case 1:
         gotoxy(1,1);printf(HHtemp11);gotoxy(1,2);printf(HHtemp12);
         gotoxy(1,23);printf(HHtemp12);break;
      case 2:
         gotoxy(1,1);printf(HHtemp21);gotoxy(1,2);printf(HHtemp22);
         gotoxy(1,23);printf(HHtemp22);break;
      default:
         gotoxy(1,1);printf(HHtemp01);gotoxy(1,2);printf(HHtemp02);
         gotoxy(1,23);printf(HHtemp02);break;
   }
}
void NotFound(int *ScrJ,int *ScrI)
{
   Clrscr();
   DrawForm();
   *ScrJ=*ScrI=0;
   ShowInfo(*ScrI);
   showu2(*ScrJ,*ScrI);
}
void ShowUnit(int *ScrJ,int *ScrI,int keystroke)
{                                                 /* ScrJ -- Top Line No */
   static int  totalpages;                        /* ScrI -- Current Line No */
   char datestring[9];
   void  (*showu)();
   char  cmdflag;
   int   tmpI;

   if(C_IndexS==0){ NotFound(ScrJ,ScrI);return; }
   totalpages=((C_IndexS%PAGEL == 0) ? C_IndexS/PAGEL : C_IndexS/PAGEL+1) ;

   UnMarkLine(*ScrI-*ScrJ+First);                      /* need unmark line first */
   cmdflag=0;showu=showu2;
   switch(keystroke)
   {
      case Up     :  if(*ScrI<=0)break;             /* top already */
                     cmdflag=1;
                     if(*ScrJ==*ScrI)                /* current at the top */
                        *ScrJ-=1, *ScrI-=1, showu=showu4;
                     else
                        *ScrI-=1,           showu=showu2;
                     break;
      case Down   :  if(*ScrI>=C_IndexS-1)break;    /* end already */
                     cmdflag=1;
                     if(*ScrI-*ScrJ==PAGEL-1)    /* current at the bottom */
                        *ScrJ+=1, *ScrI+=1, showu=showu3;
                     else
                        *ScrI+=1,           showu=showu2;
                     break;
      case Home   :  if(*ScrI==*ScrJ)break;       /* current at the top already */
                     cmdflag=1;
                     *ScrI=*ScrJ,  showu=showu2;
                     break;
      case End    :  if(*ScrI-*ScrJ==PAGEL-1)break;  /* current at the bottom already */
                     cmdflag=1;
                     *ScrI=*ScrJ+PAGEL-1,
                     *ScrI=((*ScrI>=C_IndexS-1)?C_IndexS-1:*ScrI), showu=showu2;
                     break;
      case C_Home :  if(*ScrI==0)break;          /* current at home already */
                     cmdflag=1;
                     if(*ScrJ==0)                /* at the first page */
                        *ScrI=0,         showu=showu2;
                     else
                        *ScrJ=0, *ScrI=0, showu=showu1;
                     break;
      case C_End  :  if(*ScrI==C_IndexS-1)break; /* current at the end already */
                     cmdflag=1;
                     if(*ScrJ>=C_IndexS-PAGEL && C_IndexS>*ScrJ)   /* at the end page */
                        *ScrI=C_IndexS-1,            showu=showu2;
                     else
                        *ScrJ=((C_IndexS-PAGEL<0)?0:C_IndexS-PAGEL), *ScrI=C_IndexS-1, showu=showu1;
                     break;
      case PgUp   :  if(*ScrJ==0 && *ScrI==0)break;/* at the top already */
                     cmdflag=1;
                     if(*ScrJ==0)   /* at the first page */
                        *ScrI=0, showu=showu2;
                     else
                     {
                        tmpI=*ScrI-*ScrJ;
                        *ScrJ-=PAGEL-1;             /* turn 1 page */
                        *ScrJ=(*ScrJ<0)?0:*ScrJ;
                        *ScrI=*ScrJ+tmpI;
                        showu=showu1;
                     }
                     break;
      case PgDn   :  if(*ScrJ>=C_IndexS-PAGEL && C_IndexS>*ScrJ && *ScrI==C_IndexS-1)break;/* at the end already */
                     cmdflag=1;
                     if(*ScrJ>=C_IndexS-PAGEL && C_IndexS>*ScrJ)   /* at the end page */
                        *ScrI=C_IndexS-1,            showu=showu2;
                     else
                     {
                        tmpI=*ScrI-*ScrJ;
                        *ScrJ+=PAGEL-1;             /* turn 1 page */
                        *ScrJ=(*ScrJ>C_IndexS-PAGEL)?C_IndexS-PAGEL:*ScrJ;
                        *ScrI=*ScrJ+tmpI;
                        *ScrI=((*ScrI>=C_IndexS-1)?C_IndexS-1:*ScrI);
                        showu=showu1;
                     }
                     break;
      case C_PgUp :  if(*ScrJ==0)break;          /* at the first page already */
                     cmdflag=1;
                     tmpI=*ScrI-*ScrJ;
                     *ScrJ-=(PAGEL-1)*5;         /* turn 5 page */
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=*ScrJ+tmpI;
                     showu=showu1;
                     break;
      case C_PgDn :  if(*ScrJ>=C_IndexS-PAGEL)break;/* at the end page already */
                     cmdflag=1;
                     tmpI=*ScrI-*ScrJ;
                     *ScrJ+=(PAGEL-1)*5;         /* turn 5 page */
                     *ScrJ=(*ScrJ>C_IndexS-PAGEL)?C_IndexS-PAGEL:*ScrJ;
                     *ScrI=*ScrJ+tmpI;
                     *ScrI=((*ScrI>=C_IndexS-1)?C_IndexS-1:*ScrI);
                     showu=showu1;
                     break;
      case 0      :  cmdflag=1;                 /* I.C. at home */
                     Clrscr();
                     DrawForm();
                     *ScrJ=*ScrI=0;
                     showu=showu1;
                     break;
      case 1      :  cmdflag=1;                 /* I.C. at the end */
                     Clrscr();
                     DrawForm();
                     *ScrJ=C_IndexS-PAGEL;
                     *ScrI=C_IndexS-1;
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=(*ScrI<0)?0:*ScrI;
                     showu=showu1;
                     break;
      case 2      :  cmdflag=1;                 /* I.C. at the current pos */
                     Clrscr();
                     DrawForm();
                     *ScrJ=(*ScrJ>C_IndexS-PAGEL)?C_IndexS-PAGEL:*ScrJ;
                     *ScrI=(*ScrI>C_IndexS-1    )?C_IndexS      :*ScrI;
                     *ScrJ=(*ScrJ<0)?0:*ScrJ;
                     *ScrI=(*ScrI<0)?0:*ScrI;
                     showu=showu1;
                     break;
   }
   showu(*ScrJ,*ScrI);
   if(cmdflag==0)return;            /* other key input */
   ShowInfo(*ScrI);
}
void Cwords2(CWORDS *C)
{
   Cwords(C);
   FlagOfShowingCwords=1;
}
void CwordsOff2(void)
{
   CwordsOff();
   FlagOfShowingCwords=0;
}
/*----------------- Use Left / Right Arrow Key to Switching the Display Format
BOOL2 SelectDisplayType(void)
{
   char *selectmegword="ХΡӲʤϥզCHܬd߮榡Aå Enter wA Esc C";
   char tmpdisplaytype;
   int  ch;

   DisplayType=(DisplayType!=1 && DisplayType!=2)?0:DisplayType;
   tmpdisplaytype=DisplayType;

   CenterFrame(14);
   printfXY( 1, 3,HHtemp01);
   printfXY( 1, 4,HHtemp02);
   printfXY( 1, 6,HHtemp11);
   printfXY( 1, 7,HHtemp12);
   printfXY( 1, 9,HHtemp21);
   printfXY( 1,10,HHtemp22);
   printfXY( 9,13,selectmegword);
   for(ch=0;ch<3;ch++)
      UnMarkLine(ch*3+4+3),UnMarkLine(ch*3+4+4);

   MarkLine(tmpdisplaytype*3+4+3);
   MarkLine(tmpdisplaytype*3+4+4);

   while(1)
   {
      SetEnglishInput();
      ch=bioskey(0);
      if(ch==Up || ch==Down)
      {
         UnMarkLine(tmpdisplaytype*3+4+3);
         UnMarkLine(tmpdisplaytype*3+4+4);
         tmpdisplaytype=(ch==Up)?tmpdisplaytype-1:tmpdisplaytype+1;
         tmpdisplaytype=(tmpdisplaytype<0)?2:tmpdisplaytype;
         tmpdisplaytype=(tmpdisplaytype>2)?0:tmpdisplaytype;
         MarkLine(tmpdisplaytype*3+4+3);
         MarkLine(tmpdisplaytype*3+4+4);
      }
      if(ch==Enter || ch==Esc)break;
   }
   UnMarkLine(tmpdisplaytype*3+4+3);
   UnMarkLine(tmpdisplaytype*3+4+4);
   FreeCenterFrame(14);

   if(ch==Enter && tmpdisplaytype!=DisplayType)
   {
      DisplayType=tmpdisplaytype;
      return(OK);
   }
   else
      return(NotOK);
}
-----------------------------------------------------------------------------*/
/*****************************************************************************


                K                                    n        B
 ========= ============ ======================================== == ===========

     b                  K                          n        B
======== ============ ============ ============================== == ==========

       ǲX           K                          n        B
========= ========== ============ ============================== == ===========


        ХΡӲʤϥզCHܬd߮榡Aå Enter wA Esc C

*****************************************************************************/
/******************************************************************************
void ShowOneUnit(DAYUNITSHOW *S);
void ShowOneUnitWithHeader(char ScrY,DAYUNITSHOW *S);
void OffShowOneUnitWithHeader(char ScrY);
void ShowOneNull(void);
void showu1(int ScrJ,int ScrI);
void showu2(int ScrJ,int ScrI);
void showu3(int ScrJ,int ScrI);
void showu4(int ScrJ,int ScrI);
void ShowInfo(int ScrI);
void DrawForm(void);
void NotFound(int *ScrJ,int *ScrI);
void ShowUnit(int *ScrJ,int *ScrI,int keystroke);
BOOL2 SelectDisplayType(void);
void Cwords2(CWORDS *C);
void CwordsOff2(void);
******************************************************************************/
