/*****************************************************************************/
/* UNIO2-2.C     Unit I/O  2  for Screen input/output                        */
/*****************************************************************************/

#include"memain.i"

/******************************************************** Layout Mode *********
1
2        ~`w
3        wϥΤgO
4        lB
5  zwwwwwwwswwwwwwswwwwwwswwwwwwswwwwww{
6  x     @ ڶ  x  ~      x        x  ]      x  12    34  x
7  x   @     x            x            x            x            x
8  
9  x  `  g  O  x  12345678  x  12345678  x  12345678  x  12345678  x
0  x  B      x  12345678  x  12345678  x  12345678  x  12345678  x
1  x  ҥ~ʲ  x  12345678  x  12345678  x  12345678  x  12345678  x
2  x    |    x  12345678  x  12345678  x  12345678  x  12345678  x
3  x  ͬɲ  x  12345678  x  12345678  x  12345678  x  12345678  x
4  x  ~ɫ  x  12345678  x  12345678  x  12345678  x  12345678  x
5  x  åͫO  x  12345678  x  12345678  x  12345678  x  12345678  x
6  x  ߲zɫ  x  12345678  x  12345678  x  12345678  x  12345678  x
7  x   ĳ |  x  12345678  x  12345678  x  12345678  x  12345678  x
8  x  ͻɫ  x  12345678  x  12345678  x  12345678  x  12345678  x
9  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
0  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
1  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
2  x  1234567890  x  12345678  x  12345678  x  12345678  x  12345678  x
3  |wwwwwwwrwwwwwwrwwwwwwrwwwwwwrwwwwww}
4
ЧQ PgUp , PgDn ½dߡAԢ CL A  Ӣ d C
******************************************************************************/

char CheckBudget(void)
{
   char *helpmsg="ЧQ PgUp , PgDn ½dߡAԢ CL A  Ӣ d C";
   char *scrbuf;                    /* screen buffer */
   CWORDS CC1,CC2,CC3;
   int  ch;                         /* Get from bioskey() */
   char pagenumb,cflag;
   char i,j;

   if((type_num-1)<=0)
   {
      Message(1,0,0,"Х]wڶNI");
      return NotOK;
   }
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);
   CalculateMoney();
   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* ToCwords(&CC1," ~`w ",48,90,10,36,'o');
      ToCwords(&CC2,"wϥΤgO",48,90,10,36,'o');
      ToCwords(&CC3,"  l    B  ",48,90,10,36,'o'); */
   CenterCwords(&CC1,"~`w",3);
   CenterCwords(&CC2,"wϥΤgO",3);                  
   CenterCwords(&CC3,"l   B",3);
   DrawTable();
   pagenumb=0;
   cflag=1;
   while(1)
   {
      Message(0,0,0,helpmsg);
      switch(pagenumb)
      {
         case 0:  if(cflag!=1)break;
                  Cwords2(&CC1);
                  for(j=0;j<type_num-1;j++)
                  {
                     gotoxy(24+j*14,9);
                     printf("%8ld",STATSET[j]);
                  }
                  for(i=0;i<unit_num-1;i++)
                     for(j=0;j<type_num-1;j++)
                     {
                        gotoxy(24+j*14,10+i);
                        printf("%8ld",STSET[i][j]);
                     }
                  break;

         case 1:  if(cflag!=1)break;
                  Cwords2(&CC2);
                  for(j=0;j<type_num-1;j++)
                  {
                     gotoxy(24+j*14,9);
                     printf("%8ld",STATALL[j]);
                  }
                  for(i=0;i<unit_num-1;i++)
                     for(j=0;j<type_num-1;j++)
                     {
                        gotoxy(24+j*14,10+i);
                        printf("%8ld",STALL[i][j]);
                     }
                  break;

         case 2:  if(cflag!=1)break;
                  Cwords2(&CC3);
                  for(j=0;j<type_num-1;j++)
                  {
                     gotoxy(24+j*14,9);
                     printf("%8ld",STATREST[j]);
                  }
                  for(i=0;i<unit_num-1;i++)
                     for(j=0;j<type_num-1;j++)
                     {
                        gotoxy(24+j*14,10+i);
                        printf("%8ld",STREST[i][j]);
                     }
                  break;
      }
      cflag=0;
      Clear_KeyBuf();
      ch=bioskey(0);
      if(ch==F7)break;
      if(ch==Esc)
      {
         CwordsOff2();
         puttext(1,1,80,24,scrbuf);
         free(scrbuf);
         Message(0,0,0,"~׸gOϥΪpdߧC");
         return OK;
      }
      if(ch==PgDn || ch==Down)
            cflag=1,pagenumb=(pagenumb>=2)?0:pagenumb+1;
      else  if(ch==PgUp || ch==Up)
            cflag=1,pagenumb=(pagenumb<=0)?2:pagenumb-1;
      if(cflag==1) CwordsOff2();
   }
   ch=PrintBudget();
   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   Message(0,0,0,"~׸gOϥΪpdߧA%sCLC",(ch!=0)?"w":"");
   return OTHER;
}

#define SCR_LEFT 0
#define SCR_TOP  0
void cline(int x1,int y1,int x2,int y2,int colors,char boundflag)
{
   gotoxy(1,1);
   printf("L%d,%d,%d,%d,%d,%c;",x1,y1,x2,y2,colors,((boundflag==1)?'B':' '));
}
void ScreenProtect(void)
{
   unsigned int  count=0;
   int  t=0;                           /* line number */
   char first=1;
   int  colors=1;
   int  DTime=50;
   char *buf;                          /*[80*24*2];*/
   char *msgbuf;                       /*[80* 1*2]*/
   int  *p1[2],*p2[2];                 /*[LINES]*/
   struct text_info R;
   int  CLINES;
   int  LINES;
   char boundflag;
   int  i,j;
   int  x1,y1,x2,y2,dx1,dy1,dx2,dy2;
   unsigned int cursorsize;
   int MaxColors;
   int MaxX,MaxY;

   randomize();
   CLINES=random(128)+1;
   LINES =random(64)+1;
   boundflag=random(250)%2;
   ChineseInt10('C');                        /* "\x1BIC;" set CHINESE input */
   ChineseInt10('c');                        /* "\x1BIc;" set ENGLISH input */
   MaxX=ETen.main_width;
   MaxY=ETen.ascii_height*24-1;              /* not include the bottom line */
   MaxColors=ETen.MaxColors;
   x2=y2=0;

   gettextinfo(&R);
   window(1,1,80,25);
   msgbuf=(char *)calloc(80*1*2,sizeof(char));
   buf=(char *)calloc(80*24*2,sizeof(char));
   for(i=0;i<2;i++)p1[i]=(int *)calloc(LINES,sizeof(int));
   for(i=0;i<2;i++)p2[i]=(int *)calloc(LINES,sizeof(int));

   cursorsize=GetCursorSize();
   Cursor(0);
   gettext(1,1,80,24,buf);
   gettext(1,25,80,25,msgbuf);
   Message(0,0,0,"gOBz{𮧤DDD");
   window (1,1,80,24);
   clrscr();
   ChineseInt10('M');                  /* "\x1BIM;" Off Message Line */
   x1=y1=0;                            /* First point in 0,0 */
   x2=(x2==0)?random(MaxX)+1:x2;       /* Second point use usersetup */
   y2=(y2==0)?random(MaxY)+1:y2;       /* position or random position */
   dx1=dy1=5+boundflag*3;              /* position change in first point */
   dx2=dy2=7+boundflag*5;              /* position change in second point */
   while(bioskey(1)==0)
   {
      count++;
      cline(x1,y1,x2,y2,colors,boundflag);
      cline(x1,MaxY-y1,x2,MaxY-y2,colors,boundflag);
      cline(MaxX-x1,MaxY-y1,MaxX-x2,MaxY-y2,colors,boundflag);
      cline(MaxX-x1,y1,MaxX-x2,y2,colors,boundflag);
      delay(DTime);
      if(count>=LINES || first==0)
      {
         first=0;
         t=count % LINES;
         cline(p1[0][t],p1[1][t],p2[0][t],p2[1][t],0,boundflag);
         cline(p1[0][t],MaxY-p1[1][t],p2[0][t],MaxY-p2[1][t],0,boundflag);
         cline(MaxX-p1[0][t],MaxY-p1[1][t],MaxX-p2[0][t],MaxY-p2[1][t],0,boundflag);
         cline(MaxX-p1[0][t],p1[1][t],MaxX-p2[0][t],p2[1][t],0,boundflag);
      }
      t=count % LINES;
      if(count%CLINES == 0)
      {
         colors+=1;
         colors%=MaxColors;
         if(colors==0)colors+=1;
      }
      p1[0][t]=x1;p1[1][t]=y1;
      p2[0][t]=x2;p2[1][t]=y2;
      x1+=dx1;y1+=dy1;
      x2+=dx2;y2+=dy2;
      if(x1<=SCR_LEFT || x1>=MaxX)dx1=-dx1;
      if(y1<=SCR_TOP  || y1>=MaxY)dy1=-dy1;
      if(x2<=SCR_LEFT || x2>=MaxX)dx2=-dx2;
      if(y2<=SCR_TOP  || y2>=MaxY)dy2=-dy2;
      if(count % (CLINES*LINES)==0)count=0;
   }
   ChineseInt10('m');                        /* On ETen Message Line */
                                 /* For the ETen Chinese System's Bug !! */
   window (1,1,80,25);
   clrscr();
   puttext(1,1,80,24,buf);
   for(i=1;i>=0;i--)free(p2[i]);
   for(i=1;i>=0;i--)free(p1[i]);
   puttext(1,25,80,25,msgbuf);
   free(msgbuf);
   printfXY(1,1,"%cCR;",27);                 /* ver 0.24 */ /* Redraw screen */
   window(R.winleft,R.wintop,R.winright,R.winbottom);
   textattr(R.attribute);
   gotoxy(R.curx,R.cury);
   PutCursorSize(cursorsize);
   Clear_KeyBuf();
   if(FlagOfShowingCwords==1)Cwords(NULL);   /*** ET Bug need to consider ***/
}
/******************************************************************************
char CheckBudget(void);
void cline(int x1,int y1,int x2,int y2,int colors,char boundflag);
void ScreenProtect(void);
******************************************************************************/
