/*****************************************************************************/
/* UNIO2-3.C     Unit I/O  2  for Printer Output                             */
/*****************************************************************************/
#include"daymain.i"

/******************************************************************************
~ifkg2x0;
                   a   y      z      |   K Q H   ~         O   b            

bW١Gs ï  b                               LG00/00/00                               @000   000

           W   K                                     n   ()   I (U)   l       B    X
  ========  ============  =========================================  ==========  ==========  ===========  ==========
  aa/bb/cc                Iaa~bbcclB                                               99999999999
  00/00/00  ~      O  01234567890123456789012345678901234567890  1234567890  1234567890  12345678901  1234567890
  ..................................................................................................................
  00/00/00  ~      O  01234567890123456789012345678901234567890  1234567890  1234567890  12345678901  1234567890
  ========  ============  =========================================  ==========  ==========  ===========  ==========
                                                       p  BG999999999999999999999999


IܥثeAs ï  b   ϥαΦpUG

b        x W     x     J x     X x         l 
wwwwwwqwwwwwwwqwwwwwwwqwwwwwwwqwwwwwww
s ï  b x 123456789012 x 123456789012 x 123456789012 x 123456789012 

~ifkg2x0;
                   a   y      z      |   K Q H   ~         O   b            

bW١Gs ï  b                               LG00/00/00                               @000   000

                 W   K                                     n   ()   I (U)     X
        ========  ============  =========================================  ==========  ==========  ==========
        00/00/00  ~      O  01234567890123456789012345678901234567890  1234567890  1234567890  1234567890
        .....................................................................................................
        00/00/00  ~      O  01234567890123456789012345678901234567890  1234567890  1234567890  1234567890
        ========  ============  =========================================  ==========  ==========  ==========
                                                             p  BG999999999999999999999999

                   a   y      z      |   K Q H   ~         O   b            

LG00/00/00                                                                                   @000   000

       b   W      W   K                                     n   ()   I (U)     X
 ========  ============  ============  =========================================  ==========  ==========  ==========
 00/00/00  s ï  b   ~      O  01234567890123456789012345678901234567890  1234567890  1234567890  1234567890
 ...................................................................................................................
 00/00/00  s ï  b   ~      O  01234567890123456789012345678901234567890  1234567890  1234567890  1234567890
 ========  ============  ============  =========================================  ==========  ==========  ==========
                                                                    p  BG999999999999999999999999

IܥثeAUbϥαΦpUG

b        x W     x     J x     X x         l 
wwwwwwqwwwwwwwqwwwwwwwqwwwwwwwqwwwwwww
   b x 123456789012 x 123456789012 x 123456789012 x 123456789012 
wwwwwwqwwwwwwwqwwwwwwwqwwwwwwwqwwwwwww
s ï  b x 123456789012 x 123456789012 x 123456789012 x 123456789012 
wwwwwwqwwwwwwwqwwwwwwwqwwwwwwwqwwwwwww
            x              x              x              x              


******************************************************************************/


char *PPages1="bW١G%-42.42sLG%-39.39s@%3d   %3d\n";
char *PPages3="LG%-91.91s@%3d   %3d\n";

char *PPartLine="=========================================";
char *PHeader1="           W   "
               "K                                     n  "
               " ()   I (U)   l       B    X\n";
char *PartLine1="%10.8s  %12.12s  %41.41s  %10.10s  %10.10s  %11.11s  %10.10s\n";
char *PHeader2="                 W   "
               "K                                     n  "
               " ()   I (U)     X\n";
char *PartLine2="%16.8s  %12.12s  %41.41s  %10.10s  %10.10s  %10.10s\n";
char *PHeader3="       b   W      W   "
               "K                                     n  "
               " ()   I (U)     X\n";
char *PartLine3="%9.8s  %12.12s  %12.12s  %41.41s  %10.10s  %10.10s  %10.10s\n";

char *PFormat1= "%10.8s  %-12.12s  %-41.40s  %10.10s  %10.10s  %11.0f  %10.10s\n";
char *PCalcul1= "%67s%12.0f%12.0f\n";
char *PFormat2= "%16.8s  %-12.12s  %-41.40s  %10.10s  %10.10s  %10.10s\n";
char *PCalcul2= "%73s%12.0f%12.0f\n";
char *PFormat3= "%9.8s  %-12.12s  %-12.12s  %-41.40s  %10.10s  %10.10s  %10.10s\n";
char *PCalcul3= "%80s%12.0f%12.0f\n";

char *PUFrame="\n";
char *PLFrame="\n";
char *PCFrame="wwwwwwqwwwwwwwqwwwwwwwqwwwwwwwqwwwwwww\n";
char *PNFrame="            x              x              x              x              \n";
char *PStatHeader ="b        x W     x     J x     X x         l \n";
char *PStatFormat1="%12.12sx%+13.0f x%+13.0f x%+13.0f x%+13.0f \n";
char *PStatFormat2="%12.12sx%14.14sx%14.14sx%14.14sx%14.14s\n";

char *Pdaterange="%29.29s %3d ~ %2.2s  %2.2s \n";


jmp_buf printer_jmp;
FILE *DevicePrinter;
char OpenDevicePrinter(char *printername)
{
   if((DevicePrinter=fopen(printername,"a+"))==NULL)
      return ERROR;
   return OK;
}
void CloseDevicePrinter(void)
{
   fclose(DevicePrinter);
}
char CheckDevicePrinterDriver(void)             /* ver 0.248 */
{
   int i,j;
   j=255;
   for(i=0;i<61;i++)
      if(DevicePrinterName[i]==':') {j=i-1; break;}
   if(j!=255)
   {  if(GetDiskFreeSpace(DevicePrinterName[j])>2048L)return OK;  }
   else
   {  if(GetDiskFreeSpace(0)>2048L)return OK; }
   return NotOK;
}
char DealWithPrinterNotReady(void)
{
   int ch;
   while(1)
   {
      Message(1,0,1,"L|ǳƦnAˬdLC  [R] ~  [A]  H");
      Cursor(2);
      do{
         Clear_KeyBuf();
         SetEnglishInput();
         ch=bioskey(0);
      }while(!(ch==N_R || ch==S_R || ch==N_A || ch==S_A || ch==Esc));
      ch=(ch==Esc)?N_A:ch;
      Cursor(0);
      MessageOff();
      if(ch==N_A || ch==S_A)  return USERBREAK; /* Break Print */
      if(PrinterOK()==OK)     return OK;        /* OK Continue Print */
                                             /* else continue ask for check */
   }
}
char PrinterOK(void)
{
   int PrintState;
   int i;
   if(PrinterType==1)return OK;                 /* ver 0.24 */
   while(TRUE)
   {
      PrintState=biosprint(2,0,PrinterPort);    /* ver 0.24 */
                                       /* ver 0.15 fixed for no ON-LINE option*/
      if(!(PrintState==0x90 || PrintState==0x10 || PrintState==0xD0 ||
           PrintState==0x80 || PrintState==0x00 || PrintState==0xC0))
         return NotOK;                 /* NotOK -> printer is NOT Ready */
      if(PrintState==0x90 || PrintState==0x80)
         return OK;                    /* OK -> printer is Ready for write */
      for(i=0;i<1000;i++);             /* Wait for a while */
   }
}
void ToPrinter(char *fmt, ... )
{
   extern long far *cntptr;
   extern long old_time;
   va_list  argptr;                       /* Argument list pointer         */
   int cnt;                               /* Result of VFPRINTF for return */

   old_time=(*cntptr);

   FlagOfPrinting=1;
   if(PrinterOK()!=OK)
      if(DealWithPrinterNotReady()==USERBREAK)
      {
         CloseDBF();
         CloseDevicePrinter();
         FlagOfPrinting=0;
         FlagOfPrintBreak=0;
         ctrlbrk(NormalControlBreak);     /* Set Ctrl-Break function  */
         longjmp(printer_jmp,ERROR);      /* ver 0.250 */
      }
   if(FlagOfPrintBreak==1)
   {
      CloseDBF();
      CloseDevicePrinter();
      FlagOfPrinting=0;
      FlagOfPrintBreak=0;
      ctrlbrk(NormalControlBreak);        /* Set Ctrl-Break function  */
      longjmp(printer_jmp,USERBREAK);     /* ver 0.250 */
   }
   va_start( argptr, fmt );               /* Initialize va_ functions     */

   if(PrinterType!=1)
   {
      cnt = vfprintf(stdprn,fmt,argptr);        /* prints string to file */
/*    if(cnt!=EOF)delay(cnt*17);                /* 58.8 cps */*/
      if(cnt!=EOF)delay(cnt*5);                 /* 200 cps */
   }
   else
   {
      if(OpenDevicePrinter(DevicePrinterName)!=OK)
         Message(1,0,0,"Lɮ׶}ҿ~I"),   /* ver 0.24 */
         cnt = EOF;
      else  if(CheckDevicePrinterDriver()==OK)  /* ver 0.248 */
         cnt = vfprintf(DevicePrinter,fmt,argptr); /* prints string to file */
            else
         Message(1,0,0,"Lɮ׼gJ~IϺЪŶI"),
         cnt = EOF;
      CloseDevicePrinter();
   }

   va_end( argptr );                      /* Close va_ functions          */

   cnt = (cnt!=EOF) ? OK : NotOK ;
   if(cnt!=OK) longjmp(printer_jmp,NotOK);/* ver 0.250 */
}
void PrintInit(void)
{
   ToPrinter("%ci;",PrinterControlCode);
}
void PrintFormat(char formatNo)
{
   if(formatNo==0)   ToPrinter("%c%s",PrinterControlCode,PrinterControlString);
   else              ToPrinter("%cifkg2;",PrinterControlCode);
}
void FormFeed(void)
{
   ToPrinter("%c",'\x0C');
}
void PrintTitle(char *titlewords,int cCol)
{
   char PTitle[123];
   int  slen=strlen(titlewords);
   int  wnum=NumOfCword(titlewords);
   int  space,wspace,alen;
   int  i,j,k;
   space=cCol-slen;
   if(wnum==1)wspace=0;
   else       wspace=(space-20)/(wnum-1);
   wspace=(wspace>5)?5:( (wspace<0)?0:wspace );
   alen=slen+wspace*(wnum-1);

   memset(PTitle,0,123);
   for(i=0;i<(cCol-alen)/2;i++)PTitle[i]=' ';
   for(j=0;j<slen;)
      if(CwordInString(titlewords,j)==OK)
      {
         PTitle[i++]=titlewords[j++];
         PTitle[i++]=titlewords[j++];
         for(k=0;k<wspace;k++) PTitle[i++]=' ';
      }
      else
      {
         PTitle[i++]=titlewords[j++];
         if(CwordInString(titlewords,j)==OK)
            for(k=0;k<wspace;k++) PTitle[i++]=' ';
      }
   PTitle[i++]='\n';
   PTitle[i++]='\0';

   ToPrinter(PTitle);
}
void PrintPages(char formatNo,char *Astr,int pTotalPage,int pCurrentPage)
{
   char ptoday[9];
   Date_String(ptoday);
   switch(formatNo)
   {
      case 1: ToPrinter(PPages1,Astr,ptoday,pTotalPage,pCurrentPage);   break;
      case 2: ToPrinter(PPages1,Astr,ptoday,pTotalPage,pCurrentPage);   break;
      case 3: ToPrinter(PPages3,ptoday,pTotalPage,pCurrentPage);        break;
   }
}
void PrintHeader(char formatNo)
{
   switch(formatNo)
   {
      case 1: ToPrinter(PHeader1);  break;
      case 2: ToPrinter(PHeader2);  break;
      case 3: ToPrinter(PHeader3);  break;
   }
}
void PrintPartLine(char formatNo)
{
   char *i=(char *)PPartLine;
   switch(formatNo)
   {
      case 1: ToPrinter(PartLine1,i,i,i,i,i,i,i);  break;
      case 2: ToPrinter(PartLine2,i,i,i,i,i,i);    break;
      case 3: ToPrinter(PartLine3,i,i,i,i,i,i,i);  break;
   }
}
void PrintPUFrame(void)
{
   ToPrinter(PUFrame);
}
void PrintPLFrame(void)
{
   ToPrinter(PLFrame);
}
void PrintPUFrame2(void)
{
   extern char *upperb;
   ToPrinter("%s\n",upperb);
}
void PrintPLFrame2(void)
{
   extern char *lowerb;
   ToPrinter("%s\n",lowerb);
}
void PrintPCFrame(void)
{
   ToPrinter(PCFrame);
}
void PrintNullFrame(void)
{
   ToPrinter(PNFrame);
}
void PrintNull(void)
{
   ToPrinter("\n");
}
void PrintUnit(char formatNo,DAYUNIT *pUnt,double Mrest)
{
   DAYUNITSHOW S;
   char **moneytype;
   ConvertUntToShow(&S,pUnt,0);
   moneytype=(S.in_or_ex==1)? income : expend ;

/* Message(1,0,0,"Mrest = %15.2f",Mrest);
   delay(200); */

   switch(formatNo)
   {
      case 1:
         if(S.in_or_ex==1) ToPrinter(PFormat1,pUnt->date,moneytype[S.type],pUnt->memo,
                                              pUnt->money,"",Mrest,pUnt->tk_no);
         else              ToPrinter(PFormat1,pUnt->date,moneytype[S.type],pUnt->memo,
                                              "",pUnt->money,Mrest,pUnt->tk_no);
         break;
      case 2:
         if(S.in_or_ex==1) ToPrinter(PFormat2,pUnt->date,moneytype[S.type],pUnt->memo,
                                              pUnt->money,"",pUnt->tk_no);
         else              ToPrinter(PFormat2,pUnt->date,moneytype[S.type],pUnt->memo,
                                               "",pUnt->money,pUnt->tk_no);
         break;
      case 3:
         if(S.in_or_ex==1) ToPrinter(PFormat3,pUnt->date,account[S.account],
                                 moneytype[S.type],pUnt->memo,pUnt->money,"",pUnt->tk_no);
         else              ToPrinter(PFormat3,pUnt->date,account[S.account],
                                 moneytype[S.type],pUnt->memo,"",pUnt->money,pUnt->tk_no);
         break;
   }
}
void PrintCalculate(char formatNo,double pStat1,double pStat2)
{
   char *i=" p  BG";
   switch(formatNo)
   {
      case 1: ToPrinter(PCalcul1,i,pStat1,pStat2); break;
      case 2: ToPrinter(PCalcul2,i,pStat1,pStat2); break;
      case 3: ToPrinter(PCalcul3,i,pStat1,pStat2); break;
   }
}
void PrintFromday(void)
{
   char dyear[3];
   int i;
   strncpy(dyear,FirstDay,2); dyear[2]='\0'; i=atoi(dyear);
   i+=(i<50)?100:0;
   if(YearType==0)i-=11;
   ToPrinter(Pdaterange,"",i,&FirstDay[3],&FirstDay[6]);
}
void PrintToday(void)
{
   char dyear[3];
   int i;
   strncpy(dyear,LastDay,2);dyear[2]='\0';i=atoi(dyear);
   i+=(i<50)?100:0;
   if(YearType==0)i-=11;
   ToPrinter(Pdaterange,"",i,&LastDay[3],&LastDay[6]);
}
void PrintAccount(char pAccount)    /* A->1,B->2,... */
{
   if(pAccount<=account_num)
      ToPrinter(PStatFormat1,account[pAccount],AccountLEST[pAccount-1],
         AccountIN[pAccount-1],AccountEX[pAccount-1],AccountST[pAccount-1]);
   else
      ToPrinter(PStatFormat2,"","","","","");
}
void PrintStatH(void)
{
   ToPrinter(PStatHeader);
}
void PrintStatF(void)
{
   ToPrinter(PStatFormat1,"`        p",SUMofLEST,SUMofIN,SUMofEX,SUMofST);
}
void PrintAllAccount(void)
{
   char i;
   PrintPUFrame();
   PrintStatH();
   for(i=1;i<account_num;i++)
   {
      PrintPCFrame();
      PrintAccount(i);
   }
   PrintPCFrame();
   PrintStatF();
   PrintPLFrame();
}
void PrintAllType(void)
{
   char *CheckInorOut[]={" J"," X"};
   char *CenterPline[]={"  ","  "};
   char *headingformat=" %5.5s     αb    %5.5s B ";
   char *partline="============ ============ ============";
   char *useformat="%12.12s %12.12s %12.0f";
   char *useformat2="%12.12s %12.12s %12.12s";
   char i,j;

   ToPrinter(headingformat,CheckInorOut[0],CheckInorOut[0]);   /*fix 0.249*/
   ToPrinter(CenterPline[0]);
   ToPrinter(headingformat,CheckInorOut[1],CheckInorOut[1]);   /*fix 0.249*/
   ToPrinter("\n");
   ToPrinter("%s%s%s\n",partline,CenterPline[1],partline);
   j=(income_num>expend_num)?income_num:expend_num;
   for(i=0;i<j-1;i++)
   {
      if(i<income_num-1)ToPrinter(useformat,income[i+1],account[InAccount[i+1]],IncomeST[i]);
      else              ToPrinter(useformat2,"","","");
      ToPrinter(CenterPline[0]);
      if(i<expend_num-1) ToPrinter(useformat,expend[i+1],account[ExAccount[i+1]],ExpendST[i]);
      else              ToPrinter(useformat2,"","","");
      ToPrinter("\n");
   }
}
void PrintStat(char pAccount)        /* A - > 1 , B -> 2 , ... */
{
   PrintFormat(1);
   ToPrinter("IܥثeAgOϥαβέppUG\n");
   switch(pAccount)
   {
      case 0:        /* print all account of stat result */
         PrintAllAccount();
         break;

      default:       /* print specific account of stat result */
         PrintPUFrame();
         PrintStatH();
         PrintPCFrame();
         PrintAccount(pAccount);
         PrintPLFrame();
         break;
   }
   PrintFormat(0);
}
/******************************************************************************
char OpenDevicePrinter(char *printername);
void CloseDevicePrinter(void);
char CheckDevicePrinterDriver(void);
char DealWithPrinterNotReady(void);
char PrinterOK(void);
void ToPrinter(char *fmt, ... );
void PrintInit(void);
void PrintFormat(char formatNo);
void FormFeed(void);
void PrintTitle(char *titlewords,int cCol);
void PrintPages(char formatNo,char *Astr,int pTotalPage,int pCurrentPage);
void PrintHeader(char formatNo);
void PrintPartLine(char formatNo);
void PrintPUFrame(void);
void PrintPLFrame(void);
void PrintPUFrame2(void);
void PrintPLFrame2(void);
void PrintPCFrame(void);
void PrintNullFrame(void);
void PrintNull(void);
void PrintUnit(char formatNo,DAYUNIT *pUnt,double Mrest);
void PrintCalculate(char formatNo,double pStat1,double pStat2);
void PrintFromday(void);
void PrintToday(void);
void PrintAccount(char pAccount);
void PrintStatH(void);
void PrintStatF(void);
void PrintAllAccount(void);
void PrintAllType(void);
void PrintStat(char pAccount);
******************************************************************************/
