/*****************************************************************************/
/* UNIO3.C       Unit I/O  3  for Input Data                                 */
/*****************************************************************************/

#include"memain.i"

void ConvertUntToShow(MEUNITSHOW *shoW,MEUNIT *unT,int index_in_f)
{
   shoW->index=index_in_f;
   shoW->delete=unT->delete;
   shoW->unit=((unT->unit==' ' || unT->unit-'A'+1>=unit_num || unT->unit-'A'+1<0) ? 0 : unT->unit-'A'+1);
   shoW->type=((unT->type==' ' || unT->type-'A'+1>=type_num || unT->type-'A'+1<0) ? 0 : unT->type-'A'+1);
}
void Date_String(char *sdate)          /* Get date to "00/00/00" format */
{                                      /*  'Year/Month/Day              */
   struct date dtmp;
   char dstmp[3];

   getdate(&dtmp);
   if(YearType==1)
      itoa((dtmp.da_year-11)%100,dstmp,10);    /* Year */
   else
      itoa(dtmp.da_year%100,dstmp,10);    /* Year */
   sdate[0]=(atoi(dstmp)<=9)?'0':dstmp[0];
   sdate[1]=(atoi(dstmp)<=9)?dstmp[0]:dstmp[1];
   sdate[2]='/';
   itoa(dtmp.da_mon,dstmp,10);         /* Month */
   sdate[3]=(atoi(dstmp)<=9)?'0':dstmp[0];
   sdate[4]=(atoi(dstmp)<=9)?dstmp[0]:dstmp[1];
   sdate[5]='/';
   itoa(dtmp.da_day,dstmp,10);         /* Day */
   sdate[6]=(atoi(dstmp)<=9)?'0':dstmp[0];
   sdate[7]=(atoi(dstmp)<=9)?dstmp[0]:dstmp[1];
   sdate[8]='\0';
}
void IntToString(char *sstring,int iint)  /* out format like  %02d */
{
   int checknumb;
   checknumb=10;        /* two digit only */

   sstring[0]=iint/checknumb + '0';
   sstring[1]=iint%checknumb + '0';
   sstring[2]='\0';
}
int  StringToInt(char *sstring)
{
   int iInt;
   iInt=(sstring[0]==0)?0:sstring[0]-'0';
   iInt*=10;
   iInt+=(sstring[1]==0)?0:sstring[1]-'0';
   return iInt;
}
char IsNumberChar(char numberchar)
{
   return ((numberchar-'0')>=0 && (numberchar-'0')<=9) ? TRUE : FALSE;
}
void DealWithDateString(char *dstring)
{
   char year[3];
   char month[3];
   char day[3];
   int  iyear,iiyear,imonth,iday;
   strncpy(year ,&dstring[0],2);year[2]='\0';
   strncpy(month,&dstring[3],2);month[2]='\0';
   strncpy(day  ,&dstring[6],2);day[2]='\0';

   if(strcmp(year,"**")!=0)
   {
      if(IsNumberChar(year[0])==TRUE && IsNumberChar(year[1])==FALSE)year[1]='\0';
      else if(IsNumberChar(year[0])==FALSE && IsNumberChar(year[1])==TRUE)year[0]='0';
      if(IsNumberChar(year[0])==FALSE && IsNumberChar(year[1])==FALSE)
         strcpy(year,"**");
      else
      {
         iyear=atoi(year);
         iyear=(iyear<0)?0:iyear;
         IntToString(year,iyear);
      }
   }
   if(strcmp(month,"**")!=0)
   {
      if(IsNumberChar(month[0])==TRUE && IsNumberChar(month[1])==FALSE)month[1]='\0';
      else if(IsNumberChar(month[0])==FALSE && IsNumberChar(month[1])==TRUE)month[0]='0';
      if(IsNumberChar(month[0])==FALSE && IsNumberChar(month[1])==FALSE)
         strcpy(month,"**");
      else
      {
         imonth=atoi(month);
         imonth=(imonth<=0 || imonth>12)?1:imonth;
         IntToString(month,imonth);
      }
   }
   if(strcmp(day,"**")!=0)
   {
      if(IsNumberChar(day[0])==TRUE && IsNumberChar(day[1])==FALSE)day[1]='\0';
      else if(IsNumberChar(day[0])==FALSE && IsNumberChar(day[1])==TRUE)day[0]='0';
      if(IsNumberChar(day[0])==FALSE && IsNumberChar(day[1])==FALSE)
         strcpy(day,"**");
      else
      {
         iday=atoi(day);
         imonth=atoi(month);
         iyear=atoi(year);
         if(YearType==1)iiyear=iyear+11;
         else           iiyear=iyear;
         if(day[0]=='*')iiyear=0;
         switch(imonth)
         {
            case 0: case 1: case 3: case 5: case 7: case 8: case 10: case 12:
               iday=(iday<=0)? 1:iday;
               iday=(iday>31)?31:iday; break;
            case 2:
               if((iiyear)%4==0)
               {
                  iday=(iday<=0)? 1:iday;
                  iday=(iday>29)?29:iday;
               }
               else
               {
                  iday=(iday<=0)? 1:iday;
                  iday=(iday>28)?28:iday;
               }
               break;
            default:
               iday=(iday<=0)? 1:iday;
               iday=(iday>30)?30:iday; break;
         }
         IntToString(day,iday);
      }
   }
   strcpy(dstring,year);
   strcat(dstring,"/");
   strcat(dstring,month);
   strcat(dstring,"/");
   strcat(dstring,day);
}
/*******************************************************************Layout Mode
                                                                ~wwww01
    Cwords("gOƤW",48,30,10,2,'o');                    xNx 2
                                                                xA=Bx 3
                                                                xB=ҥ~բx 4
                                                                xC=|բx 5
        G [00/00/00]                                       xD=ͻբx 6
                                                                xE=Ǣx 7
    NG [A] B                                       xF=ëOǢx 8
                                                                xG=߻Ǣx 9
    ڶNG [A] ~ȶO                                       xH=ǥͷ|x 0
                                                                xI=Ǣx 1
      HG [@GT|]                                       x        x 2
                                                                x        x 3
    K    nG [@GT|CKEQ@GT|CKE]       x        x 4
                                                                x        x 5
        BG [00000000]                                        6
                                                                xڶNx 7
        G [@GT|CKEQ]                           xA=~ȶOx 8
                                                                xB=ƶOx 9
    l    BG  00000000                                        xC=]ƶOx 0
                                                                x        x 1
    HWƬO_TH]^                                wwww 2
******************************************************************************/
char Totalitem=8;
char *Hitem[]={"    ", "N", "ڶN", "  H",
               "K    n", "    B", "    ", "l    B" };
char *Hformat[]={"  /  /  "," "," ","        ","                                        ",
                 "        ","                    " };
char  Hlen[]={8,1,1,8,40,8,20,8};
void ShowFormat(char *headerword)
{
   CWORDS CC;
   int i;
   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* ToCwords(&CC,headerword,48,30,10,2,'o'); */
   BlockCenterCwords(&CC,headerword,1,1,64,3);     /* ver 1.0 */
   Cwords2(&CC);
   gotoxy(65, 1);printf("~");gotoxy(75, 1);printf("");
   gotoxy(65,22);printf("");gotoxy(75,22);printf("");
   for(i=0;i<4;i++)gotoxy(67+i*2,1),printf("w"),gotoxy(67+i*2,22),printf("w");
   for(i=0;i<20;i++)gotoxy(65,2+i),printf("x"),gotoxy(75,2+i),printf("x");
   gotoxy(65,16);printf("");gotoxy(75,16);printf("");
   for(i=0;i<4;i++)gotoxy(67+i*2,16),printf("");
   gotoxy(67,2);printf("%s",Hitem[1]);
   for(i=1;i<unit_num;i++)gotoxy(67,2+i),printf("%c=%s",'A'+i-1,unitshort[i]);
   gotoxy(67,17);printf("%s",Hitem[2]);
   for(i=1;i<type_num;i++)gotoxy(67,17+i),printf("%c=%sO",'A'+i-1,typeshort[i]);
}
char GetOneUnit(MEUNIT *tmp,char Newflag,char Drawflag)
{
   static char olddate[9];
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   long tmprest;                    /* temp for rest */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen[i]+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen[i++]+1)
      stemp[i]=(sstemp+total_stemp);

   if(Drawflag==1)
      if(Newflag==1)ShowFormat("gOƤW[");
      else          ShowFormat("gOƤק");
   if(Newflag ==1)
   {
      if(olddate[0]=='\0')
        Date_String(olddate),
        Date_String(stemp[0]);
      else
        strcpy(stemp[0],olddate);
      /*Date_String(stemp[0]);                 /* I.C. value for New */*/
      *(stemp[1])=*(stemp[2])='A';
      strcpy(stemp[5],"0");
   }
   else
   {                                         /* Use Old Value for Modify */
      *(stemp[1])=tmp->unit;
      *(stemp[2])=tmp->type;
      for(i=0;i<10;i++)
         if(tmp->money[i]!=' ')
         {
            strncpy(stemp[5],&tmp->money[i],10-i);
            break;
         }
      strncpy(stemp[0],tmp->date,8);   stemp[0][ 8]='\0';
      strncpy(stemp[3],tmp->person,8); stemp[3][ 8]='\0';
      strncpy(stemp[4],tmp->memo,40);  stemp[4][40]='\0';
      strncpy(stemp[6],tmp->remark,20);stemp[6][20]='\0';
   }
   for(i=0;i<Totalitem-1;i++)                /* Show words */
   {
      gotoxy(5,6+i*2);
      printf("%sG [",Hitem[i]);
      DrawWords2(stemp[i],wherex(),wherey(),Hlen[i]);
      printf("]");
      if(i==1) gotoxy(20,6+i*2),printf("%s",unitshort[*(stemp[i])-'A'+1]);
      if(i==2) gotoxy(20,6+i*2),printf("%sO",typeshort[*(stemp[i])-'A'+1]);
   }
   gotoxy(5,6+i*2);
   printf("%sG ",Hitem[i]);

   do{
      MessageOff();
      gotoxy(17,20); printf("         ");    /* clear rest money */
      ch=0;eitem=0;
      while(ch!=Enter || eitem!=Totalitem-1)
      {
         switch(eitem)
         {
            case 0:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               DealWithDateString(stemp[eitem]);
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;

            case 5:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
               {
                  for(i=0;i<Hlen[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                  stemp[eitem][i++]=' ';
                  stemp[eitem][i]='\0';
               }
               if(atol(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;

            case 1:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2))==Esc)break;
               if(!isalpha(*(stemp[eitem]))) *(stemp[eitem])='A';
               if(islower(*(stemp[eitem])))  *(stemp[eitem])-='a'-'A';
               if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>unit_num-2) *(stemp[eitem])='A';
               gotoxy(20,6+eitem*2);
               printf("%s",unitshort[*(stemp[eitem])-'A'+1]);
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;

            case 2:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2))==Esc)break;
               if(!isalpha(*(stemp[eitem])))  *(stemp[eitem])='A';
               if(islower(*(stemp[eitem])))   *(stemp[eitem])-='a'-'A';
               if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>type_num-2)  *(stemp[eitem])='A';
               gotoxy(20,6+eitem*2);
               printf("%sO",typeshort[*(stemp[eitem])-'A'+1]);
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;

            case 3:
            case 4:
            case 6:
               SetChineseInput();
               ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;
         }
         if(ch==Esc || ch==C_B)
         {
            ch=Ask_Yes("O_n_J");          /* Ver 0.22 */
            MessageOff();                          /* Ver 0.22 */
            if(ch!=OK)continue;                    /* Ver 0.22 */
            free(sstemp);
            free(stemp);
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-2)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?0:eitem-1;
      }
      tmp->delete=' ';
      tmp->unit=*(stemp[1]);
      tmp->type=*(stemp[2]);
      strncpy(tmp->date,stemp[0],8);
      strncpy(olddate,stemp[0],8);
      strncpy(tmp->person,stemp[3],8);
      strncpy(tmp->memo,stemp[4],40);
      strncpy(tmp->remark,stemp[6],20);
      for(i=0;i<strlen(stemp[5]);i++)
         if(stemp[5][i]==' ' || stemp[5][i]=='\0') break;
      j=i;
      for(i=0;i<10-j;i++)tmp->money[i]=' ';
      strncpy(&tmp->money[i],stemp[5],j);

      if(atol(stemp[5])>0)
      {
         tmprest=STREST[tmp->unit-'A'][tmp->type-'A']-atol(stemp[5]);
         gotoxy(17,20);
         printf("%8ld",tmprest);
         ch=Ask_Yes("HWƬO_T");
      }
      else  if(atol(stemp[5])==0)
         {
            tmprest=STREST[tmp->unit-'A'][tmp->type-'A']-atol(stemp[5]);
            gotoxy(17,20);
            printf("%8ld",tmprest);

            if(BeepControlFlag)OneBeep(250);                /* ver 0.245 */
            ch=Ask_No("ƤBO_s");            /* ver 0.245 */
            if(ch==NotOK)ch=OK;                             /* ver 0.245 */
            else ch=NotOK;                                  /* ver 0.245 */
         }
         else
         {
            Message(1,0,0,"CƤBitȡI");
            ch=NotOK;                                       /* fixed in v0.23 */
         }
   }while(ch!=OK);                                          /* fixed in v0.23 */

   MessageOff();
   free(sstemp);
   free(stemp);
   normvideo();
   Cursor(0);
   return OK;
}
void GetCurrent_CFG(void)       /* Get Current CFG file */
{
   GetPathFileExt(Current_CFG,Current_DBF,".CFG");
}
void GetCurrent_SAT(void)       /* Get Current CFG file */
{
   GetPathFileExt(Current_SAT,Current_DBF,".SAT");
}
/******************************************************************************
void ConvertUntToShow(MEUNITSHOW *shoW,MEUNIT *unT,int index_in_f);
void Date_String(char *sdate);
void IntToString(char *sstring,int iint);
int  StringToInt(char *sstring);
char IsNumberChar(char numberchar);
void DealWithDateString(char *dstring);
void ShowFormat(char *headerword);
char GetOneUnit(MEUNIT *tmp,char Newflag,char Drawflag);
void GetCurrent_CFG(void);
void GetCurrent_SAT(void);
******************************************************************************/
