/*****************************************************************************/
/* UNIO3.C       Unit I/O  3  for Input Data                                 */
/*****************************************************************************/

#include"daymain.i"

void ConvertUntToShow(DAYUNITSHOW *S,DAYUNIT *D,int index_in_f)
{
   char type_of_num;

   S->index=index_in_f;
   S->delete=D->delete;
   S->in_or_ex=(D->in_or_ex=='A' || D->in_or_ex=='B') ? D->in_or_ex-'A'+1 : 0 ;
   type_of_num=(S->in_or_ex==1)? income_num : ((S->in_or_ex==2)?expend_num:0) ;
   S->type=((D->type==' ' || D->type-'A'+1>=type_of_num || D->type-'A'+1<0) ? 0 : D->type-'A'+1);
   S->account=((D->account==' ' || D->account-'A'+1>=account_num || D->account-'A'+1<0) ? 0 : D->account-'A'+1);
}
void Date_String(char *sdate)          /* Get date to "00/00/00" format */
{                                      /*  'Year/Month/Day              */
   struct date dtmp;
   char dstmp[3];

   getdate(&dtmp);
   if(YearType==1)
      itoa((dtmp.da_year-11)%100,dstmp,10);    /* Year */
   else
      itoa(dtmp.da_year%100,dstmp,10);    /* Year */
   sdate[0]=(atoi(dstmp)<=9)?'0':dstmp[0];
   sdate[1]=(atoi(dstmp)<=9)?dstmp[0]:dstmp[1];
   sdate[2]='/';
   itoa(dtmp.da_mon,dstmp,10);         /* Month */
   sdate[3]=(atoi(dstmp)<=9)?'0':dstmp[0];
   sdate[4]=(atoi(dstmp)<=9)?dstmp[0]:dstmp[1];
   sdate[5]='/';
   itoa(dtmp.da_day,dstmp,10);         /* Day */
   sdate[6]=(atoi(dstmp)<=9)?'0':dstmp[0];
   sdate[7]=(atoi(dstmp)<=9)?dstmp[0]:dstmp[1];
   sdate[8]='\0';
}
void IntToString(char *sstring,int iint)  /* out format like  %02d */
{
   int checknumb;
   checknumb=10;        /* two digit only */

   sstring[0]=iint/checknumb + '0';
   sstring[1]=iint%checknumb + '0';
   sstring[2]='\0';
}
int  StringToInt(char *sstring)
{
   int iInt;
   iInt=(sstring[0]==0)?0:sstring[0]-'0';
   iInt*=10;
   iInt+=(sstring[1]==0)?0:sstring[1]-'0';
   return iInt;
}
char IsNumberChar(char numberchar)
{
   return ((numberchar-'0')>=0 && (numberchar-'0')<=9) ? TRUE : FALSE;
}
void DealWithDateString(char *dstring)
{
   char year[3];
   char month[3];
   char day[3];
   int  iyear,iiyear,imonth,iday;
   strncpy(year ,&dstring[0],2);year[2]='\0';
   strncpy(month,&dstring[3],2);month[2]='\0';
   strncpy(day  ,&dstring[6],2);day[2]='\0';

   if(strcmp(year,"**")!=0)
   {
      if(IsNumberChar(year[0])==TRUE && IsNumberChar(year[1])==FALSE)year[1]='\0';
      else if(IsNumberChar(year[0])==FALSE && IsNumberChar(year[1])==TRUE)year[0]='0';
      if(IsNumberChar(year[0])==FALSE && IsNumberChar(year[1])==FALSE)
         strcpy(year,"**");
      else
      {
         iyear=atoi(year);
         iyear=(iyear<0)?0:iyear;
         IntToString(year,iyear);
      }
   }
   if(strcmp(month,"**")!=0)
   {
      if(IsNumberChar(month[0])==TRUE && IsNumberChar(month[1])==FALSE)month[1]='\0';
      else if(IsNumberChar(month[0])==FALSE && IsNumberChar(month[1])==TRUE)month[0]='0';
      if(IsNumberChar(month[0])==FALSE && IsNumberChar(month[1])==FALSE)
         strcpy(month,"**");
      else
      {
         imonth=atoi(month);
         imonth=(imonth<=0 || imonth>12)?1:imonth;
         IntToString(month,imonth);
      }
   }
   if(strcmp(day,"**")!=0)
   {
      if(IsNumberChar(day[0])==TRUE && IsNumberChar(day[1])==FALSE)day[1]='\0';
      else if(IsNumberChar(day[0])==FALSE && IsNumberChar(day[1])==TRUE)day[0]='0';
      if(IsNumberChar(day[0])==FALSE && IsNumberChar(day[1])==FALSE)
         strcpy(day,"**");
      else
      {
         iday=atoi(day);
         imonth=atoi(month);
         iyear=atoi(year);
         if(YearType==1)iiyear=iyear+11;
         else           iiyear=iyear;
         if(day[0]=='*')iiyear=0;
         switch(imonth)
         {
            case 0: case 1: case 3: case 5: case 7: case 8: case 10: case 12:
               iday=(iday<=0)? 1:iday;
               iday=(iday>31)?31:iday; break;
            case 2:
               if((iiyear)%4==0)
               {
                  iday=(iday<=0)? 1:iday;
                  iday=(iday>29)?29:iday;
               }
               else
               {
                  iday=(iday<=0)? 1:iday;
                  iday=(iday>28)?28:iday;
               }
               break;
            default:
               iday=(iday<=0)? 1:iday;
               iday=(iday>30)?30:iday; break;
         }
         IntToString(day,iday);
      }
   }
   strcpy(dstring,year);
   strcat(dstring,"/");
   strcat(dstring,month);
   strcat(dstring,"/");
   strcat(dstring,day);
}
void ShowFormat(char *headerword)
{
   CWORDS CC;
   normvideo();
   Clrscr();                                       /* Drawing Screen */
   /* ToCwords(&CC,headerword,48,30,10,2,'o');  */
   BlockCenterCwords(&CC,headerword,1,1,59,5);
   Cwords2(&CC);
}
char *INlegendword="ڶN";
char *EXlegendword="IڶN";
char *AClegendword="bW٥N";
void ShowLegend(char *legendword,char **types_name,char types_num)
{
   extern int DataBaseF;
   extern int DataBaseB;
   char i;
   textcolor(DataBaseF);
   textbackground(DataBaseB);
   CFrame(60,2,76,23,4);
   Clear_Frame(62,3,75,22);
   gotoxy(62,2);printf(" %12.12s ",legendword);      /* Show Legend */
   for(i=1;i<types_num;i++)
   printfXY(62,i+2,"%c=%s",'A'+i-1,types_name[i]);
}
/*******************************************************************Layout Mode
                                                                             01
    Cwords("ObƤW",48,30,10,2,'o');             ~_ڶN_ 2
                                                           xA=ӤHJ|x 3
                                                           xB=ӤH`|x 4
                                                           xC=ӤH}|x 5
                                                           xD=鹺J|x 6
        G [00/00/00]                                  xE=鹺`|x 7
                                                           xF=鹺}|x 8
      IG [A]               AG()  BGI(U)  xG=ӤH{J|x 9
                                                           xH=ӤH{`|x 0
    ڶNG [A]     ӤHJ|   ϥ      b   xI=ӤH{}|x 1
                                                           xJ={J|x 2
    K    nG [@GT|CKEQ@GT|CKE]  xK={`|x 3
                                                           xL={}|x 4
        BG [1234567890]                                xM=   U   ڢx 5
                                                           xN=رЩeUJx 6
    ǲXG [1234567890]                                xO= L   Jx 7
                                                           xP=        wx 8
    l    BG  0000000000     ]    b  ^          xQ=        wx 9
                                                           xR=        wx 0
                                                           xS=        wx 1
                                                           xT=        wx 2
    HWƬO_TH]^                           wwwwwww 3
******************************************************************************/
char Totalitem=7;
char *Hitem[]={"    ", "  I", "ڶN",
               "K    n", "    B", "ǲX", "l    B" };
char *Hformat[]={"  /  /  "," "," ","                                        ",
                 "          ","          " };
char  Hlen[]={8,1,1,40,10,10,12};
char *accountusedmsg="%12.12s   ϥ   %12.12s";
char GetOneUnit(DAYUNIT *tmp,char Newflag,char Drawflag)
{
   static char olddate[9];
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   double tmprest;                  /* temp for rest */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char currentlegend;
   char types_num;
   char used_account;
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen[i]+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen[i++]+1)
      stemp[i]=(sstemp+total_stemp);

   if(Drawflag==1)
      if(Newflag==1)ShowFormat("ObƤW[");
      else          ShowFormat("ObƤק");
   if(Newflag ==1)
   {
      if(olddate[0]=='\0')                   /* Check if date already used */
        Date_String(olddate);
      strcpy(stemp[0],olddate);              /* Keep Use last modify date */
      /*Date_String(stemp[0]);                 /* I.C. value for New */*/
      *(stemp[1])=*(stemp[2])='A';
      strcpy(stemp[4],"0");
   }
   else
   {                                         /* Use Old Value for Modify */
      *(stemp[1])=tmp->in_or_ex;
      *(stemp[2])=tmp->type;
      for(i=0;i<10;i++)
         if(tmp->money[i]!=' ')
         {
            strncpy(stemp[4],&tmp->money[i],10-i);
            break;
         }
      strncpy(stemp[0],tmp->date,8);   stemp[0][ 8]='\0';
      strncpy(stemp[3],tmp->memo,40);  stemp[3][40]='\0';
      strncpy(stemp[5],tmp->tk_no,10);stemp[5][10]='\0';
   }
   for(i=0;i<Totalitem-1;i++)                /* Show words */
   {
      gotoxy(5,7+i*2);
      printf("%sG [",Hitem[i]);
      DrawWords2(stemp[i],wherex(),wherey(),Hlen[i]);
      printf("]");
      if(i==1)
      {
         gotoxy(34,7+i*2),printf("AG()  BGI(U)");
         if(*(stemp[i])=='B')
            currentlegend='B',
            types_num=expend_num,
            ShowLegend(EXlegendword,expend,expend_num);
         else
            *(stemp[i])=currentlegend='A',
            types_num=income_num,
            ShowLegend(INlegendword,income,income_num);
      }
      if(i==2)
      {
         gotoxy(24,7+i*2);
         if(*(stemp[i-1])=='B')
            used_account=ExAccount[*(stemp[i])-'A'+1],
            printf(accountusedmsg,expend[*(stemp[i])-'A'+1],account[used_account]);
         else
            used_account=InAccount[*(stemp[i])-'A'+1],
            printf(accountusedmsg,income[*(stemp[i])-'A'+1],account[used_account]);
      }
   }
   gotoxy(5,7+i*2);
   printf("%sG ",Hitem[i]);

   Replace_Mode();
   do{
      Message(0,0,0,"%s%23.23s%30.30s","ХΡܭns誺","F2 s","Esc ");
      printfXY(17,19,"%35.35s","");    /* clear rest money */
      ch=0;eitem=0;
      while(ch!=Enter || eitem!=Totalitem-1)
      {
         switch(eitem)
         {
            case 0:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat[eitem],17,7+eitem*2);
               DealWithDateString(stemp[eitem]);
               stemp[eitem][1]=(stemp[eitem][1]=='*')?'1':stemp[eitem][1];
               stemp[eitem][4]=(stemp[eitem][4]=='*')?'1':stemp[eitem][4];
               stemp[eitem][7]=(stemp[eitem][7]=='*')?'1':stemp[eitem][7];
               DealWithDateString(stemp[eitem]);
               DrawWords2(stemp[eitem],17,7+eitem*2,Hlen[eitem]);
               break;

            case 4:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat[eitem],17,7+eitem*2);
               while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
               {
                  for(i=0;i<Hlen[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                  stemp[eitem][i++]=' ';
                  stemp[eitem][i]='\0';
               }
               if(atol(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
               DrawWords2(stemp[eitem],17,7+eitem*2,Hlen[eitem]);
               break;

            case 1:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat[eitem],17,7+eitem*2))==Esc)break;
               if(!isalpha(*(stemp[eitem]))) *(stemp[eitem])='A';
               if(islower(*(stemp[eitem])))  *(stemp[eitem])-='a'-'A';
               if(*(stemp[eitem])!='A' && *(stemp[eitem])!='B') *(stemp[eitem])='A';
               if(*(stemp[eitem])!=currentlegend)
                  if(*(stemp[eitem])=='B')
                     currentlegend='B',
                     types_num=expend_num,
                     ShowLegend(EXlegendword,expend,expend_num),
                     gotoxy(24,7+(eitem+1)*2),
                     used_account=ExAccount[*(stemp[eitem+1])-'A'+1],
                     printf(accountusedmsg,expend[*(stemp[eitem+1])-'A'+1],account[used_account]);
                  else
                     currentlegend='A',
                     types_num=income_num,
                     ShowLegend(INlegendword,income,income_num),
                     gotoxy(24,7+(eitem+1)*2),
                     used_account=InAccount[*(stemp[eitem+1])-'A'+1],
                     printf(accountusedmsg,income[*(stemp[eitem+1])-'A'+1],account[used_account]);
               DrawWords2(stemp[eitem],17,7+eitem*2,Hlen[eitem]);
               break;

            case 2:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat[eitem],17,7+eitem*2))==Esc)break;
               if(!isalpha(*(stemp[eitem])))  *(stemp[eitem])='A';
               if(islower(*(stemp[eitem])))   *(stemp[eitem])-='a'-'A';
               if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>types_num-2)  *(stemp[eitem])='A';
               gotoxy(24,7+eitem*2);
               if(*(stemp[eitem-1])=='B')
                  printf(accountusedmsg,expend[*(stemp[eitem])-'A'+1],
                  (used_account=ExAccount[*(stemp[eitem])-'A'+1],account[used_account]));
               else
                  printf(accountusedmsg,income[*(stemp[eitem])-'A'+1],
                  (used_account=InAccount[*(stemp[eitem])-'A'+1],account[used_account]));
               DrawWords2(stemp[eitem],17,7+eitem*2,Hlen[eitem]);
               break;

            case 3:
               SetChineseInput();
               ch=FGetWords(stemp[eitem],Hformat[eitem],17,7+eitem*2);
               DrawWords2(stemp[eitem],17,7+eitem*2,Hlen[eitem]);
               break;

            case 5:
               SetEnglishInput();
               ch=FGetWords(stemp[eitem],Hformat[eitem],17,7+eitem*2);
               DrawWords2(stemp[eitem],17,7+eitem*2,Hlen[eitem]);
               break;
         }
         if(ch==F2) break;       /* save */
         if(ch==Esc || ch==C_B)
         {
            ch=Ask_Yes("O_n_J");          /* Ver 0.22 */
            MessageOff();                          /* Ver 0.22 */
            if(ch!=OK)continue;                    /* Ver 0.22 */
            free(sstemp);
            free(stemp);
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter) eitem=eitem+1;
         else  if(ch==Tab || ch==Down) eitem=(eitem>=Totalitem-2)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up) eitem=(eitem==0)?0:eitem-1;
      }
      tmp->delete=' ';
      tmp->in_or_ex=*(stemp[1]);
      tmp->type=*(stemp[2]);
      tmp->account=(used_account==0)?' ':used_account+'A'-1;
      strncpy(tmp->date,stemp[0],8);
      strncpy(olddate,stemp[0],8);
      strncpy(tmp->memo,stemp[3],40);
      strncpy(tmp->tk_no,stemp[5],10);
      for(i=0;i<strlen(stemp[4]);i++)
         if(stemp[4][i]==' ' || stemp[4][i]=='\0') break;
      j=i;
      for(i=0;i<10-j;i++)tmp->money[i]=' ';
      strncpy(&tmp->money[i],stemp[4],j);

      if(atof(stemp[4])>0)
      {
         if(tmp->in_or_ex=='A')
            tmprest=AccountST[used_account-1]+atof(stemp[4]);
         else
            tmprest=AccountST[used_account-1]-atof(stemp[4]);
         printfXY(17,19,"%12.0f   ] %s ^",tmprest,account[used_account]);

         ch=Ask_Yes("HWƬO_T");
      }
      else if(atof(stemp[4])==0)                         /* ver 0.245 */
      {
         if(tmp->in_or_ex=='A')
            tmprest=AccountST[used_account-1]+atof(stemp[4]);
         else
            tmprest=AccountST[used_account-1]-atof(stemp[4]);
         printfXY(17,19,"%12.0f   ] %s ^",tmprest,account[used_account]);

         if(BeepControlFlag)OneBeep(250);                /* ver 0.245 */
         ch=Ask_No("ƤBO_s");            /* ver 0.245 */
         if(ch==NotOK)ch=OK;                             /* ver 0.245 */
         else ch=NotOK;                                  /* ver 0.245 */
      }
      else
      {
         Message(1,0,0,"CƤBitȡI");
         ch=NotOK;                                       /* fixed in v0.23 */
      }
   }while(ch!=OK);                                       /* fixed in v0.23 */

   MessageOff();
   free(sstemp);
   free(stemp);
   normvideo();
   Cursor(0);
   return OK;
}
void GetCurrent_CFG(void)       /* Get Current CFG file */
{
   GetPathFileExt(Current_CFG,Current_DBF,".CFG");
}
void GetCurrent_SAT(void)       /* Get Current CFG file */
{
   GetPathFileExt(Current_SAT,Current_DBF,".SAT");
}
/******************************************************************************
void ConvertUntToShow(DAYUNITSHOW *shoW,DAYUNIT *unT,int index_in_f);
void Date_String(char *sdate);
void IntToString(char *sstring,int iint);
int  StringToInt(char *sstring);
char IsNumberChar(char numberchar);
void DealWithDateString(char *dstring);
void ShowFormat(char *headerword);
char GetOneUnit(DAYUNIT *tmp,char Newflag,char Drawflag);
void GetCurrent_CFG(void);
void GetCurrent_SAT(void);
******************************************************************************/
