/*****************************************************************************/
/* UNIO3-2.C     Unit I/O  3  for Input Data                                 */
/*****************************************************************************/

#include"daymain.i"

/*******************************************************************Layout Mode
                                                                             01
    Cwords("ObƷjM@",48,30,10,2,'o');             ~_ڶN_ 2
    Cwords("ObƷjMG",48,30,10,2,'o');             xA=ӤHJ|x 3
                                                           xB=ӤH`|x 4
                                                           xC=ӤH}|x 5
  zWG [00/00/00]         UG [00/00/00]    xD=鹺J|x 6
  r    G [00/00/00]        [**] ܩҦ             xE=鹺`|x 7
                                                           xF=鹺}|x 8
    bNG [A]        b                         xG=ӤH{J|x 9
                                                           xH=ӤH{`|x 0
      IG [A]           AG()  BGI(U)  xI=ӤH{}|x 1
                                                           xJ={J|x 2
    ڶNG [A]     ӤHJ|   ϥ      b   xK={`|x 3
                                                           xL={}|x 4
    K    nG [@GT|CKEQ@GT|CKE]  xM=   U   ڢx 5
  z̧CBG [1234567890]       ̰BG [1234567890]  xN=رЩeUJx 6
  r    BG [1234567890]                                xO= L   Jx 7
                                                           xP=        wx 8
    ǲXG [1234567890]                                xQ=        wx 9
                                                           xR=        wx 0
                                                           xS=        wx 1
    ijbUNG [*] ܩҦ  [ ] ܧbb(w)  xT=        wx 2
          bKnBBBǲXG ťժܩҦ          wwwwwww 3
    HWƬO_TH]^
******************************************************************************/
extern char *accountusedmsg;
extern char *INlegendword;
extern char *EXlegendword;
extern char *AClegendword;

char *wselectall="  ";
char *wunselect="b  b";
char Totalitem1=7;
char *Hitem1[]={"    ", "bN", "  I", "ڶN",
                "K    n", "    B", "ǲX" };
char *Hformat1[]={"  /  /  "," "," "," ",
      "                                        ","          ","          " };
char  Hlen1[]={8,1,1,1,40,10,10};

char Totalitem2=9;
char *Hitem2[]={"W", "U", "bN", "  I", "ڶN",
                "K    n", "̧CB", "̰B", "ǲX" };
char *Hformat2[]={"  /  /  ","  /  /  "," "," "," ",
      "                                        ",
      "          ","          ","          " };
char  Hlen2[]={8,8,1,1,1,40,10,10,10};
char swX1=5;
char swY1[]={ 7, 9,11,13,15,17,19 };
char swX2[]={ 5,35, 5, 5, 5, 5, 5,35, 5 };
char swY2[]={ 7, 7, 9,11,13,15,17,17,19 };
char swX0=12;

void DrawGetOneUnitSearch(char search_type)
{
   char *prom="G [%*.*s]";
   char *msgw1="ijbUNG [*] ܩҦ  [ ] ܧbb(w)";
   char *msgw2="bKnBBBǲXG ťժܩҦ";
   char i;

   switch(search_type)
   {
      case 1:
         for(i=0;i<Totalitem1;i++)
            printfXY(swX1,swY1[i],Hitem1[i]),
            printf(prom,Hlen1[i],Hlen1[i],"");
            printfXY(34,7,"[**] ܩҦ");
         break;
      case 2:
         for(i=0;i<Totalitem2;i++)
            printfXY(swX2[i],swY2[i],Hitem2[i]),
            printf(prom,Hlen2[i],Hlen2[i],"");
         break;
   }
   printfXY(34,11,"AG()  BGI(U)");
   printfXY( 5,22,msgw1);
   printfXY(11,23,msgw2);
}
char GetOneUnitSearch1(DAYUNITSEARCH *tmp,char Newflag,char Drawflag)
{
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char currentlegend;
   char types_num;
   char used_account;
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem1;i++)total_stemp+=Hlen1[i]+1;
   stemp=(char **)calloc(Totalitem1,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem1;total_stemp+=Hlen1[i++]+1)
      stemp[i]=(sstemp+total_stemp);

   if(Drawflag==1)
      ShowFormat("ObƷjM@"),
      DrawGetOneUnitSearch(1);

   if(Newflag ==1)
   {
      strcpy(stemp[0],"**/**/**");
      strcpy(stemp[1],"*");
      strcpy(stemp[2],"*");
      strcpy(stemp[3],"*");
      strcpy(stemp[4],"");
      strcpy(stemp[5],"");
      strcpy(stemp[6],"");
   }
   else
   {                                         /* Use Old Value for Modify */
      strncpy(stemp[0],tmp->date1,8);   stemp[0][ 8]='\0';
      *(stemp[1])=tmp->account;
      *(stemp[2])=tmp->in_or_ex;
      *(stemp[3])=tmp->type;
      strncpy(stemp[4],tmp->memo,40);  stemp[4][40]='\0';
      for(i=0,j=0;i<10;i++)
         if(tmp->money1[i]!=' ')
         {
            j=1;
            strncpy(stemp[5],&tmp->money1[i],10-i);
            break;
         }
      if(j==0)stemp[5][0]='\0';
      strncpy(stemp[6],tmp->tk_no,10);stemp[6][10]='\0';
   }
   for(i=0;i<Totalitem1;i++)                /* Show words */
   {
      switch(i)
      {
         case 1:
            if(*(stemp[i])=='*')printfXY(24,swY1[i],wselectall);
            else printfXY(24,swY1[i],"%s",account[*(stemp[i])-'A'+1]);
            break;

         case 2:
            if(*(stemp[i])=='B')
            {
               currentlegend='B';
               types_num=expend_num;
               ShowLegend(EXlegendword,expend,expend_num);
            }
            else  if(*(stemp[i])=='A')
                  {
                     currentlegend='A';
                     types_num=income_num;
                     ShowLegend(INlegendword,income,income_num);
                  }
                  else
                  {
                     *(stemp[i])='*';
                     currentlegend='*';
                     types_num=account_num;
                     ShowLegend(AClegendword,account,account_num);
                     printfXY(24,swY1[i],wselectall);
                  }
            break;

         case 3:
            if(*(stemp[i-1])=='*' || *(stemp[i])=='*')
            {
               *(stemp[i])='*';
               used_account=0;
               printfXY(24,swY1[i],"%-34.34s",wselectall);
               break;
            }
            if(*(stemp[i-1])=='B')
            {
               used_account=ExAccount[*(stemp[i])-'A'+1],
               printfXY(24,swY1[i],accountusedmsg,expend[*(stemp[i])-'A'+1],account[used_account]);
            }
            else  if(*(stemp[i-1])=='A')
                  {
                     used_account=InAccount[*(stemp[i])-'A'+1],
                     printfXY(24,swY1[i],accountusedmsg,income[*(stemp[i])-'A'+1],account[used_account]);
                  }
            break;
      }
      DrawWords2(stemp[i],swX0+swX1,swY1[i],Hlen1[i]);
   }

   Replace_Mode();
   do{
      Message(0,0,0,"%s%48.48s","ХΡܨýsnjM","Esc ");
      ch=0;eitem=0;
      while(ch!=Enter || eitem!=Totalitem1)
      {
         switch(eitem)
         {
            case 0:
               SetEnglishInput();
               ch=FGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]);
               DealWithDateString(stemp[eitem]);
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;

            case 5:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]);
               if(stemp[eitem][0]==' ' || stemp[eitem][0]=='\0')
                  strcpy(stemp[eitem],"");
               else
               {
                  while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
                  {
                     for(i=0;i<Hlen1[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                     stemp[eitem][i++]=' ';
                     stemp[eitem][i]='\0';
                  }
                  if(atol(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
               }
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;

            case 1:
               currentlegend='*';
               types_num=account_num;
               ShowLegend(AClegendword,account,account_num);
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]))==Esc)break;
               if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
               {
                  used_account=0;
                  printfXY(24,swY1[eitem],"%-12.12s",(*(stemp[eitem])=='*')?wselectall:wunselect);
               }
               else
               {
                  if(islower(*(stemp[eitem])))*(stemp[eitem])-='a'-'A';
                  if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>types_num-2)
                     used_account=0,
                     printfXY(24,swY1[eitem],"%-12.12s",(*(stemp[eitem])='*',wselectall));
                  else
                     used_account=*(stemp[eitem])-'A'+1,
                     printfXY(24,swY1[eitem],"%-12.12s",account[*(stemp[eitem])-'A'+1]);
               }
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;

            case 2:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]))==Esc)break;
               if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
               {
                  *(stemp[eitem])='*';
                  printfXY(24,swY1[eitem],wselectall);
                  if(*(stemp[eitem])!=currentlegend)
                        currentlegend='*',
                        types_num=account_num,
                        ShowLegend(AClegendword,account,account_num);
               }
               else
               {
                  printfXY(24,swY1[eitem],"%6.6s","");
                  if(!isalpha(*(stemp[eitem]))) *(stemp[eitem])='A';
                  if(islower(*(stemp[eitem])))  *(stemp[eitem])-='a'-'A';
                  if(*(stemp[eitem])!='A' && *(stemp[eitem])!='B') *(stemp[eitem])='A';
                  if(*(stemp[eitem])!=currentlegend)
                     if(*(stemp[eitem])=='B')
                     {
                        currentlegend='B';
                        types_num=expend_num;
                        ShowLegend(EXlegendword,expend,expend_num);
                        i=*(stemp[eitem+1]);
                        i=(i=='*' || i==' ')?0:i-'A'+1;
                        used_account=ExAccount[i];
                        if(!(*(stemp[eitem+1])=='*' || *(stemp[eitem+1])==' '))
                           printfXY(24,swY1[eitem+1],accountusedmsg,expend[i],account[used_account]);
                     }
                     else
                     {
                        currentlegend='A';
                        types_num=income_num;
                        ShowLegend(INlegendword,income,income_num);
                        i=*(stemp[eitem+1]);
                        i=(i=='*' || i==' ')?0:i-'A'+1;
                        used_account=InAccount[i];
                        if(!(*(stemp[eitem+1])=='*' || *(stemp[eitem+1])==' '))
                           printfXY(24,swY1[eitem+1],accountusedmsg,income[i],account[used_account]);
                     }
               }
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;

            case 3:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]))==Esc)break;
               if(*(stemp[eitem-1])!='A' && *(stemp[eitem-1])!='B')
               {
                  *(stemp[eitem])='*';
                  printfXY(24,swY1[eitem],"%-34.34s",wselectall);
               }
               else if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
                  {
                     *(stemp[eitem])='*';
                     printfXY(24,swY1[eitem],"%-34.34s",wselectall);
                  }
                  else
                  {
                     if(!isalpha(*(stemp[eitem])))  *(stemp[eitem])='A';
                     if(islower(*(stemp[eitem])))   *(stemp[eitem])-='a'-'A';
                     if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>types_num-2)  *(stemp[eitem])='A';
                     gotoxy(24,swY1[eitem]);
                     if(*(stemp[eitem-1])=='B')
                        printf(accountusedmsg,expend[*(stemp[eitem])-'A'+1],
                        (used_account=ExAccount[*(stemp[eitem])-'A'+1],account[used_account]));
                     else
                        printf(accountusedmsg,income[*(stemp[eitem])-'A'+1],
                        (used_account=InAccount[*(stemp[eitem])-'A'+1],account[used_account]));
                     if(used_account+'A'-1 != *(stemp[eitem-2]) )
                        *(stemp[eitem-2])=used_account+'A'-1,
                        printfXY(24,swY1[eitem-2],"%s",account[*(stemp[eitem-2])-'A'+1]),
                        DrawWords2(stemp[eitem-2],swX0+swX1,swY1[eitem-2],Hlen1[eitem-2]);
                  }
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;

            case 4:
               SetChineseInput();
               ch=FGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]);
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;

            case 6:
               SetEnglishInput();
               ch=FGetWords(stemp[eitem],Hformat1[eitem],swX0+swX1,swY1[eitem]);
               DrawWords2(stemp[eitem],swX0+swX1,swY1[eitem],Hlen1[eitem]);
               break;
         }
         if(ch==Esc || ch==C_B)
         {
            MessageOff();
            free(sstemp);
            free(stemp);
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem1-1)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?0:eitem-1;
      }
      strncpy(tmp->date1,stemp[0],8);
      strncpy(tmp->date2,stemp[0],8);
      tmp->account =*(stemp[1]);
      tmp->in_or_ex=*(stemp[2]);
      tmp->type    =*(stemp[3]);
      strncpy(tmp->memo,stemp[4],40);
      for(i=0;i<strlen(stemp[5]);i++)
         if(stemp[5][i]==' ' || stemp[5][i]=='\0') break;
      j=i;
      for(i=0;i<10-j;i++)tmp->money1[i]=' ';
      strncpy(&tmp->money1[i],stemp[5],j);
      tmp->money1[10]='\0';
      strncpy(tmp->money2,tmp->money1,10);
      strncpy(tmp->tk_no,stemp[6],10);

      ch=Ask_Yes("O_}ljM");
   }while(ch!=OK);

   free(sstemp);
   free(stemp);
   normvideo();
   Cursor(0);
   return OK;
}
char GetOneUnitSearch2(DAYUNITSEARCH *tmp,char Newflag,char Drawflag)
{
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char currentlegend;
   char types_num;
   char used_account;
   unsigned long date1,date2;
   double money1,money2;
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem2;i++)total_stemp+=Hlen2[i]+1;
   stemp=(char **)calloc(Totalitem2,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem2;total_stemp+=Hlen2[i++]+1)
      stemp[i]=(sstemp+total_stemp);

   if(Drawflag==1)
      ShowFormat("ObƷjMG"),
      DrawGetOneUnitSearch(2);

   if(Newflag ==1)
   {
      strcpy(stemp[0],"80/01/01");
      Date_String(stemp[1]);
      strcpy(stemp[2],"*");
      strcpy(stemp[3],"*");
      strcpy(stemp[4],"*");
      strcpy(stemp[5],"");
      strcpy(stemp[6],"0");
      strcpy(stemp[7],"9999999999");
      strcpy(stemp[8],"");
   }
   else
   {                                         /* Use Old Value for Modify */
      strncpy(stemp[0],tmp->date1,8);   stemp[0][ 8]='\0';
      strncpy(stemp[1],tmp->date2,8);   stemp[1][ 8]='\0';
      *(stemp[2])=tmp->account;
      *(stemp[3])=tmp->in_or_ex;
      *(stemp[4])=tmp->type;
      strncpy(stemp[5],tmp->memo,40);  stemp[5][40]='\0';
      for(i=0,j=0;i<10;i++)
         if(tmp->money1[i]!=' ')
         {
            j=1;
            strncpy(stemp[6],&tmp->money1[i],10-i);
            break;
         }
      if(j==0)stemp[6][0]='\0';
      for(i=0,j=0;i<10;i++)
         if(tmp->money2[i]!=' ')
         {
            j=1;
            strncpy(stemp[7],&tmp->money2[i],10-i);
            break;
         }
      if(j==0)stemp[7][0]='\0';
      strncpy(stemp[8],tmp->tk_no,10);stemp[8][10]='\0';
   }
   for(i=0;i<Totalitem2;i++)                /* Show words */
   {
      switch(i)
      {
         case 2:
            if(*(stemp[i])=='*')printfXY(24,swY2[i],wselectall);
            else printfXY(24,swY2[i],"%s",account[*(stemp[i])-'A'+1]);
            break;

         case 3:
            if(*(stemp[i])=='B')
            {
               currentlegend='B';
               types_num=expend_num;
               ShowLegend(EXlegendword,expend,expend_num);
            }
            else  if(*(stemp[i])=='A')
                  {
                     currentlegend='A';
                     types_num=income_num;
                     ShowLegend(INlegendword,income,income_num);
                  }
                  else
                  {
                     *(stemp[i])='*';
                     currentlegend='*';
                     types_num=account_num;
                     ShowLegend(AClegendword,account,account_num);
                     printfXY(24,swY2[i],wselectall);
                  }
            break;

         case 4:
            if(*(stemp[i-1])=='*' || *(stemp[i])=='*')
            {
               *(stemp[i])='*';
               used_account=0;
               printfXY(24,swY2[i],"%-34.34s",wselectall);
               break;
            }
            if(*(stemp[i-1])=='B')
            {
               used_account=ExAccount[*(stemp[i])-'A'+1],
               printfXY(24,swY2[i],accountusedmsg,expend[*(stemp[i])-'A'+1],account[used_account]);
            }
            else  if(*(stemp[i-1])=='A')
                  {
                     used_account=InAccount[*(stemp[i])-'A'+1],
                     printfXY(24,swY2[i],accountusedmsg,income[*(stemp[i])-'A'+1],account[used_account]);
                  }
            break;
      }
      DrawWords2(stemp[i],swX0+swX2[i],swY2[i],Hlen2[i]);
   }

   Replace_Mode();
   do{
      Message(0,0,0,"%s%48.48s","ХΡܨýsnjM","Esc ");
      ch=0;eitem=0;
      while(ch!=Enter || eitem!=Totalitem2)
      {
         switch(eitem)
         {
            case 0: case 1:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]);
               DealWithDateString(stemp[eitem]);
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               if(eitem==0)break;
               DateToLong(&date1,stemp[0]);
               DateToLong(&date2,stemp[1]);
               if(date2<date1)
                  ch=N_0,eitem=0,
                  Message(1,0,0,"UjWIЭsJC");
               else
                  MessageOff();
               break;

            case 6: case 7:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]);
               if(stemp[eitem][0]==' ' || stemp[eitem][0]=='\0')
                  strcpy(stemp[eitem],"0");
               else
               {
                  while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
                  {
                     for(i=0;i<Hlen2[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                     stemp[eitem][i++]=' ';
                     stemp[eitem][i]='\0';
                  }
                  if(atof(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
               }
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               if(eitem==6)break;
               money1=atof(stemp[6]);
               money2=atof(stemp[7]);
               if(money2<money1)
                  ch=N_0,eitem=6,
                  Message(1,0,0,"̰Bj̧CBIЭsJC");
               else
                  MessageOff();
               break;

            case 2:
               currentlegend='*';
               types_num=account_num;
               ShowLegend(AClegendword,account,account_num);
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]))==Esc)break;
               if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
               {
                  used_account=0;
                  printfXY(24,swY2[eitem],"%-12.12s",(*(stemp[eitem])=='*')?wselectall:wunselect);
               }
               else
               {
                  if(islower(*(stemp[eitem])))*(stemp[eitem])-='a'-'A';
                  if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>types_num-2)
                     used_account=0,
                     printfXY(24,swY2[eitem],"%-12.12s",(*(stemp[eitem])='*',wselectall));
                  else
                     used_account=*(stemp[eitem])-'A'+1,
                     printfXY(24,swY2[eitem],"%-12.12s",account[*(stemp[eitem])-'A'+1]);
               }
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               break;

            case 3:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]))==Esc)break;
               if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
               {
                  *(stemp[eitem])='*';
                  printfXY(24,swY2[eitem],wselectall);
                  if(*(stemp[eitem])!=currentlegend)
                        currentlegend='*',
                        types_num=account_num,
                        ShowLegend(AClegendword,account,account_num);
               }
               else
               {
                  printfXY(24,swY2[eitem],"%6.6s","");
                  if(!isalpha(*(stemp[eitem]))) *(stemp[eitem])='A';
                  if(islower(*(stemp[eitem])))  *(stemp[eitem])-='a'-'A';
                  if(*(stemp[eitem])!='A' && *(stemp[eitem])!='B') *(stemp[eitem])='A';
                  if(*(stemp[eitem])!=currentlegend)
                     if(*(stemp[eitem])=='B')
                     {
                        currentlegend='B';
                        types_num=expend_num;
                        ShowLegend(EXlegendword,expend,expend_num);
                        i=*(stemp[eitem+1]);
                        i=(i=='*' || i==' ')?0:i-'A'+1;
                        used_account=ExAccount[i];
                        if(!(*(stemp[eitem+1])=='*' || *(stemp[eitem+1])==' '))
                           printfXY(24,swY2[eitem+1],accountusedmsg,expend[i],account[used_account]);
                     }
                     else
                     {
                        currentlegend='A';
                        types_num=income_num;
                        ShowLegend(INlegendword,income,income_num);
                        i=*(stemp[eitem+1]);
                        i=(i=='*' || i==' ')?0:i-'A'+1;
                        used_account=InAccount[i];
                        if(!(*(stemp[eitem+1])=='*' || *(stemp[eitem+1])==' '))
                           printfXY(24,swY2[eitem+1],accountusedmsg,income[i],account[used_account]);
                     }
               }
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               break;

            case 4:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]))==Esc)break;
               if(*(stemp[eitem-1])!='A' && *(stemp[eitem-1])!='B')
               {
                  *(stemp[eitem])='*';
                  printfXY(24,swY2[eitem],"%-34.34s",wselectall);
               }
               else if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
                  {
                     *(stemp[eitem])='*';
                     printfXY(24,swY2[eitem],"%-34.34s",wselectall);
                  }
                  else
                  {
                     if(!isalpha(*(stemp[eitem])))  *(stemp[eitem])='A';
                     if(islower(*(stemp[eitem])))   *(stemp[eitem])-='a'-'A';
                     if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>types_num-2)  *(stemp[eitem])='A';
                     gotoxy(24,swY2[eitem]);
                     if(*(stemp[eitem-1])=='B')
                        printf(accountusedmsg,expend[*(stemp[eitem])-'A'+1],
                        (used_account=ExAccount[*(stemp[eitem])-'A'+1],account[used_account]));
                     else
                        printf(accountusedmsg,income[*(stemp[eitem])-'A'+1],
                        (used_account=InAccount[*(stemp[eitem])-'A'+1],account[used_account]));
                     if(used_account+'A'-1 != *(stemp[eitem-2]) )
                        *(stemp[eitem-2])=used_account+'A'-1,
                        printfXY(24,swY2[eitem-2],"%s",account[*(stemp[eitem-2])-'A'+1]),
                        DrawWords2(stemp[eitem-2],swX0+swX2[eitem-2],swY2[eitem-2],Hlen2[eitem-2]);
                  }
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               break;

            case 5:
               SetChineseInput();
               ch=FGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]);
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               break;

            case 8:
               SetEnglishInput();
               ch=FGetWords(stemp[eitem],Hformat2[eitem],swX0+swX2[eitem],swY2[eitem]);
               DrawWords2(stemp[eitem],swX0+swX2[eitem],swY2[eitem],Hlen2[eitem]);
               break;
         }
         if(ch==Esc || ch==C_B)
         {
            MessageOff();
            free(sstemp);
            free(stemp);
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem2-1)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?0:eitem-1;
      }
      strncpy(tmp->date1,stemp[0],8);
      strncpy(tmp->date2,stemp[1],8);
      tmp->account =*(stemp[2]);
      tmp->in_or_ex=*(stemp[3]);
      tmp->type    =*(stemp[4]);
      strncpy(tmp->memo,stemp[5],40);
      for(i=0;i<strlen(stemp[6]);i++)
         if(stemp[6][i]==' ' || stemp[6][i]=='\0') break;
      j=i;
      for(i=0;i<10-j;i++)tmp->money1[i]=' ';
      strncpy(&tmp->money1[i],stemp[6],j);
      tmp->money1[10]='\0';
      for(i=0;i<strlen(stemp[7]);i++)
         if(stemp[7][i]==' ' || stemp[7][i]=='\0') break;
      j=i;
      for(i=0;i<10-j;i++)tmp->money2[i]=' ';
      strncpy(&tmp->money2[i],stemp[7],j);
      tmp->money2[10]='\0';
      strncpy(tmp->tk_no,stemp[8],10);

      ch=Ask_Yes("O_}ljM");
   }while(ch!=OK);

   free(sstemp);
   free(stemp);
   normvideo();
   Cursor(0);
   return OK;
}
