/*****************************************************************************/
/* UNIO3-2.C     Unit I/O  3  for Input Data  &  Search specific data        */
/*****************************************************************************/

#include"memain.i"

unsigned long UpperDate,LowerDate;
long UpperMoney,LowerMoney,SetMoney;
char    *strstr2 (const char *s1, const char *s2,int len)
{
   char *sss,*ss1;
   char s1end=s1[len];
   ss1=(char *)s1;
   ss1[len]='\0';
   sss=strstr(ss1,s2);
   ss1[len]=s1end;
   return sss;
}
void SetDateRange(MEUNITSEARCH *Stmp)
{
   DateToLong(&LowerDate,Stmp->date1);
   DateToLong(&UpperDate,Stmp->date2);
}
char CheckDateRange(MEUNIT     *Tmp)      /* these check sub-routine will */
{                                         /* return  OK if match else NotOK */
   unsigned long date0;
   DateToLong(&date0,Tmp->date);
   return (date0>=LowerDate && date0<=UpperDate) ? OK : NotOK ;
}
char CheckYear(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (strncmp(&Stmp->date1[0],&Tmp->date[0],2)==0) ? OK : NotOK ;
}
char CheckMon(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (strncmp(&Stmp->date1[3],&Tmp->date[3],2)==0) ? OK : NotOK ;
}
char CheckDay(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (strncmp(&Stmp->date1[6],&Tmp->date[6],2)==0) ? OK : NotOK ;
}
char CheckUnit(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (Stmp->unit == Tmp->unit) ? OK : NotOK;
}
char CheckType(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (Stmp->type == Tmp->type) ? OK : NotOK;
}
char CheckPerson(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (strstr2(Tmp->person,Stmp->person,8)!=NULL) ? OK : NotOK ;
}
char CheckMemo(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (strstr2(Tmp->memo,Stmp->memo,40)!=NULL) ? OK : NotOK ;
}
char CheckRemark(MEUNITSEARCH *Stmp,MEUNIT     *Tmp)
{
   return (strstr2(Tmp->remark,Stmp->remark,20)!=NULL) ? OK : NotOK ;
}
char CheckMoney(MEUNIT     *Tmp)
{
   char t=Tmp->money[10];
   long tmoney;
   Tmp->money[10]='\0';
   tmoney=atol(Tmp->money);
   Tmp->money[10]= t  ;
   return (SetMoney == tmoney) ? OK : NotOK ;
}
void SetMoneyRange(MEUNITSEARCH *Stmp)
{
   LowerMoney=atol(Stmp->money);
   UpperMoney=atol(Stmp->money2);
}
char CheckMoneyRange(MEUNIT     *Tmp)
{
   char t=Tmp->money[10];
   long tmoney;
   Tmp->money[10]='\0';
   tmoney=atol(Tmp->money);
   Tmp->money[10]= t  ;
   return (tmoney>=LowerMoney && tmoney<=UpperMoney) ? OK : NotOK ;
}
char Searching(MEUNITSEARCH *Stmp,char Typeflag)
{
   int   *IndexT;
   MEUNIT thistmp;
   int   C_IndexT;
   char  yearflag,monflag,dayflag,unitflag,typeflag,personflag,memoflag,moneyflag,remarkflag;
   char  startx,starty,slen;
   int   i;

   IndexT=(int *)calloc(totalnumb,sizeof(int));
   C_IndexT=0;

   InitDoing(&startx,&starty,"     g  O      j  M     DDD    ",&slen,1);
   if(Typeflag==1)
   {
      if(strncmp(&Stmp->date1[0],"**",2)==0)  yearflag=0;
      else                                    yearflag=1;
      if(strncmp(&Stmp->date1[3],"**",2)==0)  monflag =0;
      else                                    monflag =1;
      if(strncmp(&Stmp->date1[6],"**",2)==0)  dayflag =0;
      else                                    dayflag =1;
   }
   else
      SetDateRange(Stmp);
   if(Stmp->unit=='*')  unitflag=0;
   else                 unitflag=1;
   if(Stmp->type=='*')  typeflag=0;
   else                 typeflag=1;
   StringKillBlankBoth(Stmp->person);
   if(Stmp->person[0]=='\0')  personflag=0;
   else                       personflag=1;
   StringKillBlankBoth(Stmp->memo);
   if(Stmp->memo[0]=='\0') memoflag=0;
   else                    memoflag=1;
   if(Typeflag==1)
   {
      if(atol(Stmp->money)==0)   moneyflag=0;
      else                       moneyflag=1,   SetMoney=atol(Stmp->money);
   }
   else
   {
      if(atol(Stmp->money)==0 && atol(Stmp->money2)==99999999L)   moneyflag=0;
      else                                   SetMoneyRange(Stmp), moneyflag=1;
   }
   StringKillBlankBoth(Stmp->remark);
   if(Stmp->remark[0]=='\0')  remarkflag=0;
   else                       remarkflag=1;

   OpenDBF();
   for(i=0;i<C_IndexY;i++)
   {
      Doing(startx,starty,100*((float)(i+1)/(float)C_IndexY),slen,1);
      ReadOneUnit(&thistmp,ALL[IndexY[i]]->index);
      if(Typeflag==1 && yearflag==1)
         if(CheckYear(Stmp,&thistmp)!=OK)continue;
      if(Typeflag==1 && monflag==1)
         if(CheckMon(Stmp,&thistmp)!=OK)continue;
      if(Typeflag==1 && dayflag==1)
         if(CheckDay(Stmp,&thistmp)!=OK)continue;
      if(Typeflag==2)
         if(CheckDateRange(&thistmp)!=OK)continue;
      if(unitflag==1)
         if(CheckUnit(Stmp,&thistmp)!=OK)continue;
      if(typeflag==1)
         if(CheckType(Stmp,&thistmp)!=OK)continue;
      if(personflag==1)
         if(CheckPerson(Stmp,&thistmp)!=OK)continue;
      if(memoflag==1)
         if(CheckMemo(Stmp,&thistmp)!=OK)continue;
      if(moneyflag==1)
         if(Typeflag==1)
         { if(CheckMoney(&thistmp)!=OK)continue; }
         else
         { if(CheckMoneyRange(&thistmp)!=OK)continue; }
      if(remarkflag==1)
         if(CheckRemark(Stmp,&thistmp)!=OK)continue;
      IndexT[C_IndexT++]=IndexY[i];
   }
   OffDoing(startx,starty,slen,1);
   CloseDBF();                                                    /*ver 1.01*/
   if(C_IndexT==0)
   {
      free(IndexT);
      return NotOK;
   }
   else
   {
      memcpy(IndexS,IndexT,sizeof(int)*C_IndexT);
      C_IndexS=C_IndexT;
      free(IndexT);
      return OK;
   }
}
char Search(void)
{
   char *scrbuf;
   static MEUNITSEARCH Stmp1;       /* Keep Old Value in memory */
   static MEUNITSEARCH Stmp2;       /* Keep Old Value in memory */
   BOOL2 findflag,getflag;
   char CurrentDataTypeBak;
   char SearchType;
   int  ch;

   SetEnglishInput();
   Message(0,0,1,"пܷjM覡  [1]@jM  [2]djM H");
   Cursor(2);
   Clear_KeyBuf();
   do{
      ch=bioskey(0);
   }while(!(ch==N_1||ch==N_2||ch==Esc));
   Cursor(0);
   MessageOff();
   if(ch==Esc) return USERBREAK;
   if(ch==N_1)SearchType=1;
   else       SearchType=2;

   CurrentDataTypeBak=CurrentDataType;
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   Replace_Mode();
   findflag=OTHER;
   do
   {
      if(SearchType==1)
         getflag=GetOneUnitSearch(&Stmp1,((Stmp1.unit==0)?1:0),((findflag==OTHER)?1:0),1);
      else
         getflag=GetOneUnitSearch(&Stmp2,((Stmp2.unit==0)?1:0),((findflag==OTHER)?1:0),2);
      findflag=NotOK;
      if(getflag==OK)
      {
         Message(0,1,0,"jMDDD");
         if(Searching((SearchType==1)?&Stmp1:&Stmp2,SearchType)==OK)  /* find */
         {
            Message(0,0,0,"jMC");
            CurrentDataType=2;
            findflag=OK;
            break;
         }
         else
            Message(1,0,0,"jMơIЦAJsdC");
      }
      else
      {
         CurrentDataType=CurrentDataTypeBak;
         MessageOff();
         break;
      }
   }while(findflag==NotOK);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   return findflag;
}
/******************************************************************************
void SetDateRange(MEUNITSEARCH *Stmp);
char CheckDateRange(MEUNIT *Tmp);
char CheckYear(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckMon(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckDay(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckUnit(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckType(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckPerson(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckMemo(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckRemark(MEUNITSEARCH *Stmp,MEUNIT *Tmp);
char CheckMoney(MEUNIT *Tmp);
void SetMoneyRange(MEUNITSEARCH *Stmp);
char CheckMoneyRange(MEUNIT *Tmp);
void SetPerson(MEUNITSEARCH *Stmp);
void SetMemo(MEUNITSEARCH *Stmp);
char Searching(MEUNITSEARCH *Stmp,char Typeflag);
char Search(void);
******************************************************************************/
