/*****************************************************************************/
/* UNIT.C        Unit I/O                                                    */
/*****************************************************************************/

#include"daymain.i"
extern unsigned _stklen=4096*2;
main(int argc,char *argv[])
{
   char *LoadTable="J   F8   ""\0";
   char *BackTable="^ F8   ""\0";
   int Hkey[]={  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
                F8 , F9 , A_B, A_R, A_N, A_D,  0 ,  0 ,  0 ,  0 , F4,
                F2 , Ins, Del, F3 ,
                F5 , F6 , A_C,
                F10, C_A, C_I, C_E, C_B, C_P,
                F7 ,
                0  ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0  };
   int Okey[]={ 0 };

   ItemType Item[7]=
      {
         6,
         6,
         "  ""\0"            /*   0   */
         "s  ""\0"            /*   0   */
         "u  ""\0"            /*   0   */
         "\\  ""\0"           /*   0   */
         "C  L""\0"            /*   0   */
         "D  U""\0",           /*   0   */
         11,
         18,
         "J   F8   ""\0"    /*  F8   */
         "   F9   ""\0"    /*  F9   */
         "ƥ   Alt-B""\0"    /*  A_B  */
         "^   Alt-R""\0"    /*  A_R  */
         "sW   Alt-N""\0"    /*  A_N  */
         "R   Alt-D""\0"    /*  A_D  */
         "ƥƨ ϡG ""\0"    /*  0    */
         "ƥƨ СG ""\0"    /*  0    */
         "^ ϡG ""\0"    /*  0    */
         "^ СG ""\0"    /*  0    */
         "         F4   ""\0",   /*  F4   */
         4,
         14,
         "sW   F2 ""\0"    /*  F2   */
         "ק   Ins""\0"    /*  Ins  */
         "R   Del""\0"    /*  Del  */
         "Ϧ^   F3 ""\0",   /*  F3   */
         3,
         20,
         "j    M       F5   ""\0"    /*  F5   */
         "           F6   ""\0"    /*  F6   */
         "ܬd߮榡   Alt-C""\0",   /*  A_C  */
         6,
         24,
         "d    l  B    F10   ""\0"      /*  F10  */
         "]wb~ץN  Ctrl-A""\0"      /*  C_A  */
         "]wJ~ץN  Ctrl-I""\0"      /*  C_I  */
         "]wX~ץN  Ctrl-E""\0"      /*  C_E  */
         "]wW      Ctrl-B""\0"      /*  C_B  */
         "]wtΰѼ      Ctrl-P""\0",     /*  C_P  */
         1,
         14,
         "C    L   F7 ""\0",   /*  F7   */
         10,
         8,
         "    ""\0"    /*   0   */
         "{""\0"    /*   0   */
         "ɮ׳Bz""\0"    /*   0   */
         "s""\0"    /*   0   */
         "u    ""\0"    /*   0   */
         "\\    ""\0"    /*   0   */
         "C    L""\0"    /*   0   */
         "    L""\0"    /*   0   */
         "wq""\0"    /*   0   */
         "wq""\0",   /*   0   */
      };
   int CurrI,CurrJ;
   int select=0;
   char Mflag=1;

   PrepareMemain();
   if(argc<2)
      strncpy(DevicePrinterName,"printer.out",59),DevicePrinterName[60]='\0';
   else
      strncpy(DevicePrinterName,argv[1],59),DevicePrinterName[60]='\0';
   Cursor(0);
   Alloc_ALL();
   GetICPath(IC_Path);
   ReadSystemSetting();
   if(Get_NewDBF(Current_DBF)==OK)
   {
      Load_DBF2();
      Yes2Show();
   }
   CurrentDataType=1;
   CurrentSortType=1;
   DisplayType=0;
   ShowUnit(&CurrJ,&CurrI,1);

   if(CVRmenuOn(Item)==0)
   {
      Message(1,0,0,"O餣I");
      sleep(3);
      exit(0);
   }

   while(1)
   {
      if(C_IndexS==0)   Message(0,1,0,"ɤwLơAзsWơC");
      Clear_KeyBuf();
      select=CVRmenu(2,Item,Hkey,Okey,Mflag);
      switch(select)
      {
         case 0 :    /* Esc Press in menu */
            Mflag=0;
            break;

         case 101 :
            if(CurrentDataType==1)
            {
               Message(0,0,0,"JɡC");
               if(Load_DBF()!=OK)break;
               Yes2Show();
               CurrentSortType=1;
            }
            else
            {
               strcpy(&Item[1].Item[0],LoadTable);    /* change menu back */
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
            }
            ShowUnit(&CurrJ,&CurrI,1);
            break;

         case 102 :
            Message(0,0,0,"ɡC");
            ReStructure();
            break;

         case 103 :
            Message(0,0,0,"ƥ");
            BackupCurrent(0);
            ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;

         case 104 :
            Message(0,0,0,"^");
            if(RestoreCurrent(0)==OTHER)    /* restore to current data base */
            {
               Message(0,0,0,"sŪɡC");
               Load_DBF2();
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            else
               ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;

         case 105 :
            Message(0,0,0,"sW");
            if(CreateNew()==OK)
               CurrentDataType=1,
               CurrentSortType=1,
               ShowUnit(&CurrJ,&CurrI,1);    /* show end */
            else
               ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;

         case 106 :
            Message(0,0,0,"R");
            if(DeleteOld()==OTHER)   /* Delete Current Data file */
            {
               if(Get_NewDBF(Current_DBF)==OK)
                  Load_DBF2(), Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            else
               ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;

         case 107 :
            BackupCurrent('A');
            ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;
         case 108 :
            BackupCurrent('B');
            ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;

         case 109 :
            if(RestoreCurrent('A')==OTHER)    /* restore to current data base */
            {
               Message(0,0,0,"sŪɡC");
               Load_DBF2();
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            else
               ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;
         case 110 :
            if(RestoreCurrent('B')==OTHER)    /* restore to current data base */
            {
               Message(0,0,0,"sŪɡC");
               Load_DBF2();
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            else
               ShowUnit(&CurrJ,&CurrI,2);    /* show current */
            break;

         case C_C    :
         case Esc    :
         case 111 :
            select=Ask_No("O_nObBz{");
            if(select==NotOK)
               exit(0);
            break;

         case 201 :
            Message(0,0,0,"sWơC");
            if(AddUnit()==OK)
               ShowUnit(&CurrJ,&CurrI,1);
            break;

         case 202 :
            if(C_IndexS==0)break;
            Message(0,0,0,"קơC");
            if(ModifyUnit(CurrI)==OK)
               ShowUnit(&CurrJ,&CurrI,2);
            break;

         case 203 :
            if(C_IndexS==0)break;
            Message(0,0,0,"RơC");
            if(DeleteUnit(&CurrJ,&CurrI)==OK)
            {                          /* delete all data */
               if(C_IndexS==0 && CurrentDataType==2)
               {
                  Yes2Show(), CurrentDataType=1;
                  if(CurrentSortType!=1)
                     ShellSortShow(CurrentSortType);
               }
               ShowUnit(&CurrJ,&CurrI,2);
            }
            break;

         case 204 :
            if(C_IndexN==0){Message(1,0,0,"SwRơI");break;}
            Message(0,0,0,"Ϧ^ơC");
            if(UnDeleteUnit()==OK)
            {
               if(CurrentSortType!=1)
                  ShellSortShow(CurrentSortType);
               ShowUnit(&CurrJ,&CurrI,2);
            }
            break;

         case 301 :
            if(C_IndexS==0)break;
            Message(0,0,0,"jMC");
            if(Search()==OK)
            {
               strcpy(&Item[1].Item[0],BackTable);    /* change menu item */
               if(CurrentSortType!=1)
                  ShellSortShow(CurrentSortType);
               ShowUnit(&CurrJ,&CurrI,0);
            }
            break;

         case 302 :
            if(C_IndexS==0)break;
            Message(0,0,0,"ƧǡC");
            if(ShowSort()==OK)             /* Data sorted */
               ShowUnit(&CurrJ,&CurrI,0);
            break;

         case 303 :                          /* Ver 0.249 */
         case Right :                        /* Message(0,0,0,"ܬd߮榡C"); */
            DisplayType=(DisplayType+1)%3;   /* if(SelectDisplayType()==OK)      */
            ShowUnit(&CurrJ,&CurrI,2);       /*    ShowUnit(&CurrJ,&CurrI,2);    */
            break;                           /* break;                           */
         case Left :
            if(DisplayType==0)DisplayType=2;
            else              DisplayType=(DisplayType-1)%3;
            ShowUnit(&CurrJ,&CurrI,2);
            break;

         case 401 :
            if(C_IndexS==0)break;
            Message(0,0,0,"dݾlBC");
            if(CheckBudget()==OTHER)
               ShowUnit(&CurrJ,&CurrI,2);
            break;

         case 402 :
            Message(0,0,0,"]wb~ץNC");
            if(SetSubstitution(0)==OK)
            {
               Message(0,0,0,"sŪɡC");
               Load_DBF2();
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            break;

         case 403 :
            Message(0,0,0,"]wJ~ץNC");
            if(SetSubstitution(1)==OK)
            {
               Message(0,0,0,"sŪɡC");
               Load_DBF2();
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            break;

         case 404 :
            Message(0,0,0,"]wX~ץNC");
            if(SetSubstitution(2)==OK)
            {
               Message(0,0,0,"sŪɡC");
               Load_DBF2();
               Yes2Show();
               CurrentDataType=1;
               CurrentSortType=1;
               ShowUnit(&CurrJ,&CurrI,1);
            }
            break;

         case 405 :
            Message(0,0,0,"]wWUbᤧC");
            SetBudget();
            break;

         case 406 :
            Message(0,0,0,"]wtΰѼơC");
            if(SystemSetting()==OK)
               ShowUnit(&CurrJ,&CurrI,2);
            break;

         case 501 :
            if(C_IndexS==0)break;
            if(PrintALL(&CurrJ,&CurrI)!=OK)
               Message(1,0,0,"Ʃ|CLI");
            ShowUnit(&CurrJ,&CurrI,2);
            break;

         case 601 : case 602 : case 603 : case 604 : case 605 :
         case 606 : case 607 : case 608 : case 609 : case 610 :
            Help("DAYMAIN.HLP",FullNumb2,select-600);
            Message(0,0,0,"DUdߧC");
            break;

         case F1     :
            Message(0,0,0,"\\}ҡC");
            Mflag=1;
            break;

/*       case Left   : case Right  :
         case Up     : case Down   :
         case Home   : case End    :
         case PgUp   : case PgDn   :
         case C_PgUp : case C_PgDn :
         case C_Home : case C_End  :   */
         default     :
               if(C_IndexS==0)break;
               ShowUnit(&CurrJ,&CurrI,select);
               MessageOff();
               break;
      }
   }
}
