/*****************************************************************************/
/* V.C           All Variable for UNIT                                       */
/*****************************************************************************/

#define NoExtern                 /* exclude extern part of DAYMAIN.I */
#include"daymain.i"
#undef  NoExtern

FILE *Main_CFG;                  /* system  CFG file pointer */
FILE *File_CFG;                  /* current CFG file pointer */
FILE *File_DBF;                  /* current DBF file pointer */
FILE *File_SAT;                  /* current SAT file pointer */
char *IC_Path;                   /* initial PATH of MeMain */
char *System_CFG;                /* system  CFG file name */
char *Current_CFG;               /* current CFG file name */
char *Current_DBF;               /* current DBF file name */
char *Current_SAT;               /* current SAT file name */

char **income;                   /* name of income */
char far *incomebase;            /* memory base - name of income */
char **expend;                   /* name of expend */
char far *expendbase;            /* memory base - name of expend */
char **account;                  /* name of account */
char far *accountbase;           /* memory base - name of account */
DAYUNITSHOW **ALL;               /* Be a Index */
DAYUNITSHOW far *ALLbase;        /* Base for *ALL[] */
char        far *ALLindex;       /* Index of ALL[] */
int   *IndexY;                   /* Index of non-deleted data */
int   *IndexN;                   /* Index of deleted data */
int   *IndexS;                   /* Index of data to show */
char  *TitlePrn=                 /* registed name >=UnitPrn+14 */
       "123456789012345678901234567890123456789012345678901234567890";
char  *UnitPrn=                  /* registed name 20 chinese words */
       "1234567890123456789012345678901234567890";

char  *FirstDay="49/12/31";      /* the very first day of the data file */
char  *LastDay="50/12/31";       /* the very last day of the data file */

char   InAccount[INCOME_KINDS+1]; /* the account of the income */
char   ExAccount[EXPEND_KINDS+1]; /* the account of the expend */
double IncomeST[INCOME_KINDS];    /* stat kinds of income */
double ExpendST[EXPEND_KINDS];    /* stat kinds of expend */
double AccountLEST[ACCOUNT_KINDS];/* rest from lest year */
double AccountIN[ACCOUNT_KINDS];  /* stat income of an account */
double AccountEX[ACCOUNT_KINDS];  /* stat expend of an account */
double AccountST[ACCOUNT_KINDS];  /* current kinds of account */
double SUMofLEST;                 /* sum of the AccountLEST[] */
double SUMofIN;                   /* sum of the AccountIN[] */
double SUMofEX;                   /* sum of the AccountEX[] */
double SUMofST;                   /* sum of the AccountST[] */
                                  /* double for the 15 (exp) is exact */

char  BeepControlFlag;           /* Beep control flag */
char  FlagOfPrinting;            /* Flag of printing data */
char  FlagOfPrintBreak;          /* Flag of Break while printing */
char  FlagOfBreakPress;          /* Flag of Ctrl-Break Press */
char  FlagOfShowingCwords;       /* Flag of Showing Chinese Words */
char  FlagOfOpeningDBF;          /* Flag of Opening Current DBF file */
int   SleepSeconds;              /* Seconds for Screen Protect */
long  DBF_HeaderLen;             /* Header Len of DBF File */
char  income_num;                /* count number of income */
char  expend_num;                /* count number of expend */
char  account_num;               /* count number of account */
int   C_IndexY;                  /* Count of IndexY */
int   C_IndexN;                  /* Count of IndexN */
int   C_IndexS;                  /* Count of IndexS */
long  totalnumb;                 /* The Number of Total Records */
int   MaxRecords;                /* Maximun Records in a DBF file */
long  MemLeft=68000L;            /* Memory Left after Alloc_ALL() */
                                 /* Memory Need Left 64k to call COMMAND.COM */

unsigned char Color_Message;
unsigned char Color_MenuNormal;
unsigned char Color_MenuLightBar;
unsigned char Color_DataNormal;
unsigned char Color_DataLightBar;
unsigned char Color_StringInput;

char  YearType;                  /* The type of the year     */
                                 /* 0 -> 褸p~   (w) */
                                 /* 1 -> p~            */
char  DisplayType;               /* The type of data display */
                                 /* 0 -> ܱb (w) */
                                 /* 1 -> ܱb,KnYu */
                                 /* 2 -> ܶǲ,KnYu */
char  CurrentDataType;           /* Current Data Type flag */
                                 /* 0 -> L   1 -> {s  */
                                 /* 2 -> jM   3 -> R  */
char  CurrentSortType;           /* Current Sort Type flag */
                                 /* 0 -> Error !    1 -> ɮ   */
                                 /* 2 ->        3 -> b   */
                                 /* 4 -> /      5 -> ڶ   */
                                 /* 6 -> Kn       7 -> B   */
                                 /* 8 -> ǲ                   */
char  CurrentYearOfDate[2];      /* Current YEAR of the data file  */
char  DevicePrinterName[61];     /* Print to ASCII file */
int   PrinterPort;               /* Printer Port 0:LPT1  1:LPT2 .. */
char  PrinterType;               /* 0 -> Printer   1 -> ASCII file */
unsigned char PrinterControlCode;/* Printer Control Code */
char  PrinterControlString[45];  /* Printer Control String */
char *FullNumb[] ={ "", "", "", "", "", "", "", "", "", ""};
char *FullNumb2[]={ "", "", "", "", "", "", "", "", "", ""};
char *FullAlpha[]={ "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "" };
