/*****************************************************************************/
/* VIEWER.I    Viewer .....  prototype & definition                          */
/*****************************************************************************/

#include<alloc.h>
#include<conio.h>
#include<io.h>
#include<dos.h>
#include<mem.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include"lee_sub.i"
#include"keycode.ii"

typedef struct    /* *.R_C files */       /* for Max 20 columns words */
   {              /* each item 80 col*/  /* for Max 100 rows words */
      char ID[6];                  /*  6*//* ID words "ROWCOL" */
      unsigned char trow;          /*  1*//* total Row of number */
      unsigned char tcol;          /*  1*//* total Col of number */
      unsigned char col[20];       /* 20*//* col position of each Col */
      unsigned char len[20];       /* 20*//* len of each col */
      unsigned char row[100];      /*100*//* rows of each Row */
      unsigned char reserved1[12]; /* 12*//* reserved for next version */

      unsigned char width;          /* 1*//* width of table */
      unsigned int  height;         /* 2*//* total row that need to alloc mem */
      unsigned int  headerlen;      /* 2*//* Length of Header offser from 256 */
      unsigned char hdlen;          /* 1*//* Length of Every Header for (1,*) */
      unsigned char hdrow;          /* 1*//* Row Number of Herder */
      unsigned char hdwordbeg;      /* 1*//* pos of hdword[x] for header word */
      unsigned char hcol[20];       /*20*//* col position of each header Col */
      unsigned char hlen[20];       /*20*//* len of each header col */
      unsigned char reserved2[48];  /*48*//* reserved for next version */
   }  ROWCOL;                       /*total length of the struct == 256 */
                                    /* forst 3 rows is */
                                    /* [0]zswwsswwwswswwwsw{*/
                                    /* [1]uqwwqqwwwqwqwwwqwt*/
                                    /* [2]|rwwrrwwwrwrwwwrw}*/

/***** UNIO0.C *****/
void fnull(void);
void *exit_f1(void);
int  NormalControlBreak(void);
void ShowProgram(void);
void CheckAllFile(void);
void PrepareMain(void);

/***** UNIO1.C *****/
void CheckROWCOLHeader(ROWCOL *r);
void ShowROWCOLHeader(char **rch,ROWCOL *rc,char ScrY);
BOOL2 ShowROWCOLOneRow(char **rch,ROWCOL *rc,unsigned char rowno,int sOff,char ScrY);
void LinesScrollUp(char **newword,int totalrow,int bindex,char rows,char ScrL,char ScrT,char ScrR,char ScrB);
void LinesScrollDown(char **newword,int bindex,char rows,char ScrL,char ScrT,char ScrR,char ScrB);
BOOL2 ShowROWCOL(char *R_C_filename);
BOOL2 ShowTXTfile(char *TXTfilename);

/***** UNIO2.C *****/
void ICScreen(void);
void FreeScreen(void);
void GetScreen(void);
void PutScreen(void);

/***** UNIO3.C *****/
BOOL2 Read_CFG(char *CFG_filename,char **fsets,char **ssets,char *nums);
BOOL2 GetCFGNum(char *CFG_filename,char *nums,int *slen);
BOOL2 ShowIDXfile(CWORDS *CC,char sTop,char sBottom,char *IDXfileName,void (func)());

/***** UNIO4.C *****/
void ITXColor(int FFFF,int BBBB);
void ITXMark(char ScrII);
char InitITX(char *ITXFile);
void OffITX(void);
void showh1(int ScrJ,int ScrI);
void showh2(int ScrJ,int ScrI);
void showh3(int ScrJ,int ScrI);
void showh4(int ScrJ,int ScrI);
void ShowITXInfo(int ScrI);
void NoITXFound(int *ScrJ,int *ScrI);
void ShowITX(int *ScrJ,int *ScrI,int keystroke);
BOOL2 ShowITXfile(CWORDS *CC,char sTop,char sBottom,char *ITXFilename,void (func)());

