/*****************************************************************************/
/* VIEWR_C.C    View *.R_C files                                             */
/*****************************************************************************/

#include<dos.h>
#include<alloc.h>
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>
#include<mem.h>
#include"lee_sub.i"
#include"keycode.ii"

typedef struct    /* *.R_C files */       /* for Max 20 columns words */
   {              /* each item 80 col*/  /* for Max 100 rows words */
      char ID[6];                  /*  6*//* ID words "ROWCOL" */
      unsigned char trow;          /*  1*//* total Row of number */
      unsigned char tcol;          /*  1*//* total Col of number */
      unsigned char col[20];       /* 20*//* col position of each Col */
      unsigned char len[20];       /* 20*//* len of each col */
      unsigned char row[100];      /*100*//* rows of each Row */
      unsigned char reserved1[12]; /* 12*//* reserved for next version */

      unsigned char width;          /* 1*//* width of table */
      unsigned int  height;         /* 2*//* total row that need to alloc mem */
      unsigned int  headerlen;      /* 2*//* Length of Header offser from 256 */
      unsigned char hdlen;          /* 1*//* Length of Every Header for (1,*) */
      unsigned char hdrow;          /* 1*//* Row Number of Herder */
      unsigned char hdwordbeg;      /* 1*//* pos of hdword[x] for header word */
      unsigned char hcol[20];       /*20*//* col position of each header Col */
      unsigned char hlen[20];       /*20*//* len of each header col */
      unsigned char reserved2[48];  /*48*//* reserved for next version */
   }  ROWCOL;                       /*total length of the struct == 256 */
                                    /* forst 3 rows is */
                                    /* [0]zswwsswwwswswwwsw{*/
                                    /* [1]uqwwqqwwwqwqwwwqwt*/
                                    /* [2]|rwwrrwwwrwrwwwrw}*/
char ErrorFlag=0;
void *exit_f1(void)                    /* Exit function to set INT back */
{
   fcloseall();
   window(1,1,80,25);
   if(ErrorFlag!=0)
      printfXY(1,25,"\n");

   MessageOff();
   gotoxy(1,25);
   Cursor(1);
   exit(0);
}
enum PROCESS { ABORT, CONTINUE };
int  NormalControlBreak(void)
{
   return (CONTINUE);            /* continue program */
}
char *upperline=/* " R_Cfile Viewer  Ver 0.02 ";*/
"\x50\x00"
"\x49\x43\x3C\x35\x55\xA7\x06\x49\xAF\x18\x84\xE9\x09\x5F\xC8\x2D"
"\xA4\x09\x7B\x9B\x94\x8D\x86\x7F\x78\x71\x6A\x63\x5C\x55\x4E\x47"
"\x40\x39\x32\x2B\x24\x1D\x16\x0F\x08\x01\xFA\xF3\xEC\xE5\xDE\xD7"
"\xD0\xC9\xC2\xBB\xB4\xAD\xA6\x9F\x98\x91\x8A\x83\x7C\x75\x6E\x67"
"\x60\x59\x79\xCF\x34\xA6\xC6\xF6\x24\x54\x86\xA6\x9F\x98\x91\x8C";
char *lowerline=/* " May,1993  Lee Dong-Liang ";*/
"\x50\x00"
"\x49\x45\x3E\x37\x57\xA4\x05\x7E\xAA\xDB\x14\x4D\x80\xA0\x99\x92"
"\x8B\x84\x7D\x76\x6F\x68\x61\x5A\x53\x4C\x45\x3E\x37\x30\x29\x22"
"\x1B\x14\x0D\x06\xFF\xF8\xF1\xEA\xE3\xDC\xD5\xCE\xC7\xC0\xB9\xB2"
"\xAB\xA4\x9D\x96\x8F\x88\x81\x7A\x73\x6C\x65\x5E\x7E\xCA\x2F\x94"
"\xB4\xF8\x67\xD5\x3C\x69\xB5\x1E\x7F\xED\x54\x74\x6D\x66\x5F\x5C";
char *showmsgwords="%-63.63sӢ뵲dߡC";
char *showmsgwords1="Шϥδd߸ơC  PgUp PgDn Home End";
BOOL2 ShowROWCOL(char *R_C_filename)
{
   FILE *R_Cfile;
   char **rcheader;
   char *rcheaderbase;
   char far *rcheaderindex;
   int  *rcindex;
   ROWCOL rc;
   int  totalrow;
   int  sx,sy,ch;
   int  i,j,k,l;
   unsigned int index_seg;   /* for far pointer of index */
   unsigned int index_off;   /* for far pointer of index */

   if((R_Cfile=fopen(R_C_filename,"rb"))==NULL)
   {
      Message(1,0,0,"ɮ \"%s\" }ҿ~I",R_C_filename);
      Clear_KeyBuf();
      bioskey(0);
      return(NotOK);
   }
   rewind(R_Cfile);
   if(fread(&rc,sizeof(ROWCOL),1,R_Cfile)!=1)                     /* Ver 0.02 */
   {
      Message(1,0,0,"ɮ \"%s\" Ū~I",R_C_filename);
      Clear_KeyBuf();
      bioskey(0);
      return(NotOK);
   }
   rcindex=(int *)calloc(rc.height+rc.trow,sizeof(int));
   rcheader=(char **)calloc(rc.height,sizeof(char *));
   rcheaderbase=(char *)calloc((rc.width+1)*rc.height,sizeof(char));
   rcheaderindex=(char far *)rcheaderbase;
   for(i=0;i<rc.height;i++)
   {
      rcheader[i]=(char *)rcheaderindex;
      rcheaderindex+=sizeof(char)*(rc.width+1);
      index_off=FP_OFF(rcheaderindex);
      index_seg=FP_SEG(rcheaderindex);
      rcheaderindex=MK_FP(index_seg+(index_off>>4),index_off%16);
   }
   fseek(R_Cfile,rc.headerlen,SEEK_SET);
   if(fread(rcheaderbase,rc.width+1,rc.height,R_Cfile)!=rc.height)/* Ver 0.02 */
   {
      Message(1,0,0,"ɮ \"%s\" Ū~I",R_C_filename);
      Clear_KeyBuf();
      bioskey(0);
      return(NotOK);
   }

   rcindex[0]=0;
   for(i=0;i<rc.hdrow;i++)
      rcindex[1+i]=rc.hdwordbeg+i;
   for(j=0,l=0;j<rc.trow;j++)
   {
      rcindex[1+i++]=rc.hdwordbeg-2;
      for(k=0;k<rc.row[j];k++)
         rcindex[1+i++]=rc.hdwordbeg+rc.hdrow+l++;
   }
   rcindex[1+i++]=rc.hdwordbeg-1;
   totalrow=i+1;

   Cursor(0);
   i=sx=sy=0;
   DrawTextWindow3(rc.col[0],3,80,23,totalrow,rcheader,rcindex,&sy);/*Ver 0.02*/
   totalrow-=rc.hdrow+2;
   memmove(&rcindex[0],&rcindex[rc.hdrow+2],totalrow*sizeof(int));
                                 /* header fixed */
   Message(0,0,0,showmsgwords,(totalrow>23-(rc.hdrow+2+3)+1)?showmsgwords1:"");
   while(TextWindow5(rc.col[0],rc.hdrow+2+3,80,23,totalrow,rcheader,rcindex,&sx,&sy)!=Esc)
   {
      if(i==sy)OneBeep(),Clear_KeyBuf();
      i=sy;
   }

   free(rcheaderbase);
   free(rcheader);
   free(rcindex);
   fclose(R_Cfile);
   return OK;
}
main(int argc,char *argv[])
{
   static char RCfilename[101];
   ctrlbrk(NormalControlBreak);                 /* Set Ctrl-Break function  */
   atexit(exit_f1);                             /* Set Exit function caller */

   if(VideoMode()==7)
   {
      MessageColor     (LIGHTRED,BLACK);
      DataBaseColor    (BLACK,LIGHTGRAY);
   }
   else
   {
      MessageColor     (LIGHTRED,BLACK);
      DataBaseColor    (YELLOW,BLUE);
   }

   if(argc<2 || argv[1]==NULL)
   {
      upperline=Decode1(upperline); lowerline=Decode1(lowerline);
      printf("%s\n\t\t\tUsage:\tViewR_C  R_Cfilename\n\n%s",upperline,lowerline);
      upperline=Encode1(upperline); lowerline=Encode1(lowerline);
   }
   else
   {
      GetPathFileExt(RCfilename,argv[1],".R_C");
      ShowROWCOL(RCfilename);
   }
}
/******************************************************************************
Version 0.02
  Auto adding ".R_C" as file ext.
  Checking Read R_C file error.
  Correct DrawTextWindow error, as rc.col[0] =\= 1
******************************************************************************/
