/*****************************************************************************/
/* VROWCOL.C   View the Header of *.R_C files                                */
/*****************************************************************************/

#include<stdio.h>
#include<conio.h>
#include<mem.h>
#include"lee_sub.i"
#include"keycode.ii"

typedef struct    /* *.R_C files */       /* for Max 20 columns words */
   {              /* each item 80 col*/  /* for Max 100 rows words */
      char ID[6];                  /*  6*//* ID words "ROWCOL" */
      unsigned char trow;          /*  1*//* total Row of number */
      unsigned char tcol;          /*  1*//* total Col of number */
      unsigned char col[20];       /* 20*//* col position of each Col */
      unsigned char len[20];       /* 20*//* len of each col */
      unsigned char row[100];      /*100*//* rows of each Row */
      unsigned char reserved1[12]; /* 12*//* reserved for next version */

      unsigned char width;          /* 1*//* width of table */
      unsigned int  height;         /* 2*//* total row that need to alloc mem */
      unsigned int  headerlen;      /* 2*//* Length of Header offser from 256 */
      unsigned char hdlen;          /* 1*//* Length of Every Header for (1,*) */
      unsigned char hdrow;          /* 1*//* Row Number of Herder */
      unsigned char hdwordbeg;      /* 1*//* pos of hdword[x] for header word */
      unsigned char hcol[20];       /*20*//* col position of each header Col */
      unsigned char hlen[20];       /*20*//* len of each header col */
      unsigned char reserved2[48];  /*48*//* reserved for next version */
   }  ROWCOL;                       /*total length of the struct == 256 */
                                    /* forst 3 rows is */
                                    /* [0]zswwsswwwswswwwsw{*/
                                    /* [1]uqwwqqwwwqwqwwwqwt*/
                                    /* [2]|rwwrrwwwrwrwwwrw}*/

void CheckROWCOLHeader(ROWCOL *r)
{
   int i;
   clrscr();
   printf("\n");
   printf("ID[6]    =%6.6s\n",r->ID);
   printf("trow     =%d\n",r->trow);
   printf("tcol     =%d\n",r->tcol);
   printf("col[0]   =%d\n",r->col[0]);
   printf("len[0]   =%d\n",r->len[0]);
   printf("width    =%d\n",r->width);
   printf("height   =%d\n",r->height);
   printf("headerlen=%d\n",r->headerlen);
   printf("hdlen    =%d\n",r->hdlen);
   printf("hdrow    =%d\n",r->hdrow);
   printf("hdwordbeg=%d\n",r->hdwordbeg);
   for(i=0;i<r->trow;i++)
      printf("row[%3d]=%d\t",i,r->row[i]);
   printf("\n");
}
void *exit_f1(void)                    /* Exit function to set INT back */
{
   fcloseall();
   window(1,1,80,25);
   normvideo();
   gotoxy(1,25);
   cprintf("\n ");
   gotoxy(1,25);
   Cursor(1);
   exit(0);
}
enum PROCESS { ABORT, CONTINUE };
int  NormalControlBreak(void)
{
   return (CONTINUE);            /* continue program */
}
/******************************************************************************
1Cwords(..........)
2
3zwwwwswwwwwwwwwwwwwwwswwwwwwwswwwwwwww{
4x P   x                     e x     v x            x
5uwwwwqwwwwwwwwwwwwwwwqwwwwwwwqwwwwwwwwt
6x   @   x ߲z                     x   ù  v   x 14:00  17:00 x
7x        x                          x              x                x
8uwwwwqwwwwwwwwwwwwwwwqwwwwwwwqwwwwwwwwt
9x   G   x ߲z                     x   B  v   x                x
0x        x                          x   ²  v   x 14:00  17:00 x
1uwwwwqwwwwwwwwwwwwwwwqwwwwwwwqwwwwwwwwt
2x   T   x ߲z                     x   B  v   x                x
3x        x                          x              x                x
4uwwwwqwwwwwwwwwwwwwwwqwwwwwwwqwwwwwwwwt
5x   |   x ߲z                     x     v   x 09:00  12:00 x
6x        x                          x   B  v   x                x
7uwwwwqwwwwwwwwwwwwwwwqwwwwwwwqwwwwwwwwt
8x      x ߲z                     x   B  v   x                x
9x        x                          x              x                x
0uwwwwqwwwwwwwwwwwwwwwqwwwwwwwqwwwwwwwwt
1x      x ߲z                     x   B  v   x                x
2x        x                          x              x                x
3|wwwwrwwwwwwwwwwwwwwwrwwwwwwwrwwwwwwww}
4
5Message
******************************************************************************/

main(int argc,char *argv[])
{
   FILE *R_Cfile;
   char *R_Cfilename;
   char **rcheader;
   char *rcheaderbase;
   char far *rcheaderindex;
   int  *rcindex;
   ROWCOL rc;
   int  totalrow;
   int  sx,sy,ch;
   int  i,j,k,l;
#ifdef _LARGE_
   unsigned int index_seg;   /* for far pointer of index */
   unsigned int index_off;   /* for far pointer of index */
#endif

   ctrlbrk(NormalControlBreak);                 /* Set Ctrl-Break function  */
   atexit(exit_f1);                             /* Set Exit function caller */

   if(argc<2 || argv[1]==NULL)exit(0);
   R_Cfile=fopen(argv[1],"rb");
   rewind(R_Cfile);
   fread(&rc,sizeof(ROWCOL),1,R_Cfile);
   CheckROWCOLHeader(&rc);
   bioskey(0);
   rcindex=(int *)calloc(rc.height+rc.trow,sizeof(int));
   rcheader=(char **)calloc(rc.height,sizeof(char *));
   rcheaderbase=(char *)calloc((rc.width+1)*rc.height,sizeof(char));
   rcheaderindex=(char far *)rcheaderbase;
   for(i=0;i<rc.height;i++)
   {
      rcheader[i]=(char *)rcheaderindex;
      rcheaderindex+=sizeof(char)*(rc.width+1);
#ifdef _LARGE_
      index_off=FP_OFF(rcheaderindex);
      index_seg=FP_SEG(rcheaderindex);
      rcheaderindex=MK_FP(index_seg+(index_off>>4),index_off%16);
#endif
   }
   fseek(R_Cfile,rc.headerlen,SEEK_SET);
   fread(rcheaderbase,rc.width+1,rc.height,R_Cfile);
   fclose(R_Cfile);

   rcindex[0]=0;
   for(i=0;i<rc.hdrow;i++)
      rcindex[1+i]=rc.hdwordbeg+i;
   for(j=0,l=0;j<rc.trow;j++)
   {
      rcindex[1+i++]=rc.hdwordbeg-2;
      for(k=0;k<rc.row[j];k++)
         rcindex[1+i++]=rc.hdwordbeg+rc.hdrow+l++;
   }
   rcindex[1+i++]=rc.hdwordbeg-1;
   totalrow=i+1;

   Cursor(0);
   sx=sy=0;
   DrawTextWindow3(1,3,80,23,totalrow,rcheader,rcindex,&sy);
   totalrow-=rc.hdrow+2;
   memmove(&rcindex[0],&rcindex[rc.hdrow+2],totalrow*sizeof(int));
                                 /* header fixed */
   while((ch=TextWindow3(1,rc.hdrow+2+3,80,23,totalrow,rcheader,rcindex,&sx,&sy,0))!=Esc && ch!=Enter);

   free(rcheaderindex);
   free(rcheaderbase);
   free(rcheader);
   free(rcindex);
   Cursor(1);
}
