/*****************************************************************************/
/* DOING.C     Show percentage of work done ! for Chinese & English          */
/*             30 Chinese Words    or    64 English Words                    */
/*****************************************************************************/
/* Use         Cursor(), Frame(), and CFrame()                               */
/*****************************************************************************/

#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "lee_sub.i"

static char *scrBuf;
char DoScrX,DoScrY;
float OldTimeS;
void InitDoing(char *startX,char *startY,char *HeaderWord,char *Len,char Cflag)
{
   char bxx,bxxe,byy;
   char i,j;
   char empty=10;

   DoScrX=wherex();
   DoScrY=wherey();
   OldTimeS=0.0;
/* *Len=(strlen(HeaderWord)+empty > *Len) ? strlen(HeaderWord)+empty : *Len ;*/
   *Len=strlen(HeaderWord)+empty;
   if(Cflag==1)
   {
      scrBuf=(char *)calloc((*Len+8+2)*5*2,sizeof(char));
      byy =10;
      bxx =(80-(*Len+8))/2 ;
      bxxe=bxx+(*Len+8)-1  ;
      gettext(bxx-1,byy,bxxe+1,byy+4,scrBuf);
      Clear_Frame(bxx-1,byy,bxxe+1,byy+4);
      CFrame(bxx,byy,bxxe-1,byy+4,1);
      for(i=1;i<=3;i++)
         for(j=0,gotoxy(bxx+2,byy+i);j<(*Len)+4;j++)putch(' ');
      gotoxy(bxx+4+(empty/2),byy+1);
      printf(HeaderWord);
      gotoxy(bxx+4,byy+3);
      for(i=0;i<(*Len)*0.5;i++)printf("");
      *startX=bxx+4;
      *startY=byy+3;
   }
   else
   {
      scrBuf=(char *)calloc((*Len+4+2)*5*2,sizeof(char));
      byy =10;
      bxx =(80-(*Len+4))/2;
      bxxe=bxx+(*Len+4)-1;
      gettext(bxx-1,byy,bxxe+1,byy+4,scrBuf);
      Clear_Frame(bxx-1,byy,bxxe+1,byy+4);
      Frame(bxx,byy,bxxe,byy+4,1);
      for(i=1;i<=3;i++)
         for(j=0,gotoxy(bxx+1,byy+i);j<(*Len)+2;j++)putch(' ');
      gotoxy(bxx+2+(empty/2),byy+1);
      printf(HeaderWord);
      gotoxy(bxx+2,byy+3);
      for(i=0;i<*Len;i++)putch('');
      *startX=bxx+2;
      *startY=byy+3;
   }
}

void Doing(char startX,char startY,char Percent,char Len,char Cflag)
{
   float times;
   char i;
   if(Percent<1 || Percent>100)return;
   gotoxy(startX,startY);
   if(Cflag==1)
   {
      times=(0.5*(float)Len)*((float)Percent*0.01);
      if((int)times>(int)OldTimeS)
         for(i=(int)OldTimeS;i<(int)times;i++)
            gotoxy(startX+(i)*2,startY),printf("i");
   }
   else
   {
      times=(float)Len*((float)Percent*0.01);
      if((int)times>(int)OldTimeS)
         for(i=(int)OldTimeS;i<(int)times;i++)
            gotoxy(startX+(i),startY),printf("");
   }
   OldTimeS=times;
}

void OffDoing(char startX,char startY,char Len,char Cflag)
{
   if(Cflag==1)
      puttext(startX-4-1,startY-3,startX-4+(Len+8)-1+1,startY-3+4,scrBuf);
   else
      puttext(startX-2-1,startY-3,startX-2+(Len+4)-1+1,startY-3+4,scrBuf);
   free(scrBuf);
   gotoxy(DoScrX,DoScrY);
}
/******** DOING.C ***************************************** Test Program ******
void exit_1()
{
   Cursor(3);
}

main(int argc,char *argv[])
{
   char i,cflag,total,x=0,y=0,len=0;

   atexit(&exit_1);

   Cursor(0);
   if(argc<2)
   {
      printf("\n [arg1]=HeaderWord [arg2]=items [arg3]=Cflag");
      exit(0);
   }
   total=(argc>=3)?atoi(argv[2]):100;
   cflag=(argc>=4)?atoi(argv[3]):0;
   InitDoing(&x,&y,argv[1],&len,cflag);
   for(i=1;i<=total;i++)
   {
      Doing(x,y,i*100./total,len,cflag);
      gotoxy(1,1);
      printf("Doing Other Works i=%3d  percent= %f",i,(float)i*100./(float)total);
   }
   OffDoing(x,y,len,cflag);
}
/* gotoxy(1,18);printf("Before InitDoing %6ld ",farcoreleft()); */
/* gotoxy(1,19);printf("After InitDoing  %6ld ",farcoreleft()); */
/* gotoxy(1,20);printf("Before OffDoing  %6ld ",farcoreleft()); */
/* gotoxy(1,21);printf("After  OffDoing  %6ld ",farcoreleft()); */
******************************************************************************/
