/*---------------------------------------------------------------------------//
// ETUFONT.CPP    Convert font file to ETen USERfont file      <TC++/BC++>   //
//---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
typedef struct
   {
      char     ch[2];
      unsigned index;
      char     font[15*2];
   }  UFONT;

void main(int argc,char *argv[])
{
   FILE *in,*out;
   UFONT temp;
   unsigned preindex=0xE000;
   if(argc<3)
   {
      printf("USAGE:\n %s fontfile(16_bit_width*15_bit_height) outputfile\n",argv[0]);
      exit(0);
   }
   if((in=fopen(argv[1],"rb"))==NULL)
   {
      printf(">> %s open error !!",argv[1]);
      exit(0);
   }
   if((out=fopen(argv[2],"wb"))==NULL)
   {
      printf(">> %s open error !!",argv[2]);
      exit(0);
   }
   while(1)
   {
      if(fread(temp.font,15,2,in)<1)break;
      temp.ch[0]=0x01;
      temp.ch[1]=0x80;
      temp.index=preindex++;
      fwrite(&temp,sizeof(UFONT),1,out);
   }
   fcloseall();
}
