/*****************************************************************************/
/* STAT.C        Stat All data for UNIT                                      */
/*****************************************************************************/

#include"memain.i"

void ResetMoney(void)
{
   memset(STREST,0,UNIT_KINDS*TYPE_KINDS*sizeof(long));
   memset(STALL,0,UNIT_KINDS*TYPE_KINDS*sizeof(long));
   memset(STATALL,0,TYPE_KINDS*sizeof(long));
   memset(STATREST,0,TYPE_KINDS*sizeof(long));
   STATERR=0L;
}
void PlusMoney(MEUNIT *Mtmp)
{
   char money[11];
   int test1,test2;

   strncpy(money,Mtmp->money,10); money[10]='\0';
   test1=Mtmp->unit - 'A' ;
   test2=Mtmp->type - 'A' ;
   if((test1>=0 && test1<=unit_num-2) && (test2>=0 && test2<=type_num-2))
      STALL[test1][test2]+=atol(money);
   else
      STATERR+=atol(money);
}
void MinusMoney(MEUNIT *Mtmp)
{
   char money[11];
   int test1,test2;

   strncpy(money,Mtmp->money,10); money[10]='\0';
   test1=Mtmp->unit - 'A' ;
   test2=Mtmp->type - 'A' ;
   if((test1>=0 && test1<=unit_num-2) && (test2>=0 && test2<=type_num-2))
      STALL[test1][test2]-=atol(money);
   else
      STATERR-=atol(money);
}
void CalculateMoney(void)
{
   int i,j;
   for(j=0;j<TYPE_KINDS;j++)
   {
      for(STATALL[j]=0,i=0;i<UNIT_KINDS;i++)
         STREST[i][j]=STSET[i][j]-STALL[i][j],
         STATALL[j]+=STALL[i][j];
      STATREST[j]=STATSET[j]-STATALL[j];
   }
}
/******************************************************************************
void ResetMoney(void);
void PlusMoney(MEUNIT *Mtmp);
void MinusMoney(MEUNIT *Mtmp);
void CalculateMoney(void);
******************************************************************************/
