/*****************************************************************************/
/* UNIO1-6.C     Unit I/O  1  for Setup File reading & setting               */
/*****************************************************************************/

#include"daymain.i"

extern long after_time;

unsigned char default_color[6];

int  SelectColor(char left,char top,int *colorattr)
{
   char *scrbuf;
   int pos;
   int ch;
   int i;
   unsigned int cursorsize=GetCursorSize();
   char numberlock=Get_NumLock();
   Cursor(0);
   scrbuf=(char *)malloc(sizeof(char)*70*10*2);
   gettext(left,top,left+69,top+9,scrbuf);   /* get text */
   Clear_Frame(left,top,left+68,top+9);
   CFrame(left,top,left+68,top+9,4);         /* draw frame */
   gotoxy(left+22,top);
   printf(" мƦrVCݩ ");
   normvideo();
   window(left+2,top+1,left+67,top+8);       /* reset window */
   clrscr();                                 /* clear window */
   for(i=0;i<=127;i++)                       /* draw characters */
   {
      gotoxy(2+(i%16)*4,1+(i/16));
      textattr(i);
      cprintf("***");
   }
   pos=*colorattr;
   textattr(YELLOW|BLACK<<4|BLINK);          /* ver 0.24 */
   SetEnglishInput();
   while(1)
   {
      NumLockON();
      gotoxy(1+(pos%16)*4,1+(pos/16));       /* show [] */
      cprintf("[");
      gotoxy(5+(pos%16)*4,1+(pos/16));
      cprintf("]");
      Clear_KeyBuf();
      ch=bioskey(0);                         /* get key */
      gotoxy(1+(pos%16)*4,1+(pos/16));       /* off []  */
      cprintf(" ");
      gotoxy(5+(pos%16)*4,1+(pos/16));
      cprintf(" ");
      switch(ch)
      {
         case pad_8:            pos-=16; break;
         case pad_2:            pos+=16; break;
         case Left: case pad_4: pos=(pos%16==0) ? pos+15 : pos-1 ;  break;
         case Right:case pad_6: pos=(pos%16==15)? pos-15 : pos+1 ;  break;
         case pad_7:  pos-=16;  pos=(pos%16==0) ? pos+15 : pos-1 ;  break;
         case pad_9:  pos-=16;  pos=(pos%16==15)? pos-15 : pos+1 ;  break;
         case pad_1:  pos+=16;  pos=(pos%16==0) ? pos+15 : pos-1 ;  break;
         case pad_3:  pos+=16;  pos=(pos%16==15)? pos-15 : pos+1 ;  break;
         case Home:  case C_Home:   pos=0;   break;
         case End:   case C_End:    pos=127; break;
      }
      if(ch==Esc || ch==Enter || ch==F2 || ch==Tab || ch==S_Tab || ch==Up || ch==Down)break;
      pos=(pos<0)?pos+128:pos;
      pos=(pos>127)?pos-128:pos;
   }
   window(1,1,80,25);                        /* set back window */
   normvideo();
   puttext(left,top,left+69,top+9,scrbuf);   /* put text back */
   free(scrbuf);
   PutCursorSize(cursorsize);
   if(numberlock)NumLockON(); else NumLockOFF();
   if(ch==Enter)                             /* if selected , set new color */
      *colorattr=pos;                        /* else   no modify colorattr  */
   return ch;
}
extern char *endfooter;
extern char *ending;
char *maincfgheader=
   ";ɦW : DAYMAIN.CFG\n" ";\n"
   ";]wOb_l\n" ";\n"
   ";Cȥb 0  127 AY 0 hϥΤw\n" ";\n"
   "; 0 = BLACK,       1 = BLUE,           2 = GREEN,        3 = CYAN,\n"
   "; 4 = RED,         5 = MAGENTA,        6 = BROWN,        7 = LIGHTGRAY,\n"
   "; 8 = DARKGRAY,    9 = LIGHTBLUE,     10 = LIGHTGREEN,  11 = LIGHTCYAN,\n"
   ";12 = LIGHTRED,   13 = LIGHTMAGENTA,  14 = YELLOW,      15 = WHITE\n" ";\n"
   ";C    IC      eC\n" ";\n"
   ";~ܪkY  hܦ褸ALܥC\n" ";\n"
   ";ĭY  hܵLnALܦnC\n" ";\n"
   ";ù۰ʥ𮧮ɶY  hܿù|۰ʥ𮧡C\n" ";\n"
   ";L(Port)]wG\n"                                 /* ver 0.24 */
   ";      0  LPT1 ]NOĤ@ӦLX\n"               /* ver 0.24 */
   ";      1  LPT2 ]NOĤGӦLX\n"               /* ver 0.24 */
   ";      :       :   ̦\n\n";                            /* ver 0.24 */



char *maincfgbegin="[tγ]w]";
char *maincfgitem[]={ "TC", "Menu`C", "MenuϥզC",
                      "ƥ`C", "ƤϥզC", "rJC",
                      "U", "~ܪk", "", "ù۰ʥ𮧮ɶ()",
                      "L(Port)", "LX", "L]w" };
unsigned char colorsets[6];
void WriteSystemSetting(void)
{
   if(GetDiskFreeSpace(System_CFG[0])<2048L)
   {
      Message(1,0,0,"%sЪŶItγ]wɵLkإߡI",FullAlpha[System_CFG[0]]);
      return;
   }
   Message(0,1,0,"tγ]wxsDDD");
   if( (Main_CFG=fopen(System_CFG,"w"))==NULL)
   {
      Message(1,0,0,"tγ]wɼgJ~I");
      return;
   }
   fprintf(Main_CFG,"%s\n",maincfgheader);
   fprintf(Main_CFG,"%s\n\n",maincfgbegin);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 0],colorsets[0]);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 1],colorsets[1]);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 2],colorsets[2]);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 3],colorsets[3]);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 4],colorsets[4]);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 5],colorsets[5]);
      fprintf(Main_CFG,"%s=%s\n",maincfgitem[ 6],UnitPrn);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 7],YearType);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 8],BeepControlFlag);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[ 9],SleepSeconds);
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[10],PrinterPort);    /* ver 0.24 */
      fprintf(Main_CFG,"%s=%d\n",maincfgitem[11],PrinterControlCode); /* ver 0.25 */
      fprintf(Main_CFG,"%s=%s\n",maincfgitem[12],PrinterControlString);
   fprintf(Main_CFG,"\n%s\n\n",ending);

   fprintf(Main_CFG,"%s",endfooter);
   fclose(Main_CFG);                            /* Close CFG file */
   Message(0,0,0,"tγ]wxsC");
}
void SettingParameter(void)
{
   after_time=SleepSeconds*18.2;
   UnitPrn[40]='\0';
   strncpy(TitlePrn,UnitPrn,40);
   strcat(TitlePrn,"Obϥγ");
   TitlePrn[60]='\0';
   MessageColor     (Color_Message&0x0F,Color_Message>>4);
   VRNormalMColor   (Color_MenuNormal&0x0F,Color_MenuNormal>>4);
   VRMenuColor      (Color_MenuLightBar&0x0F,Color_MenuLightBar>>4);
   DataBaseColor    (Color_DataNormal&0x0F,Color_DataNormal>>4);
   DataLightBarColor(Color_DataLightBar&0x0F,Color_DataLightBar>>4);
   GetWordColor     (Color_StringInput&0x0F,Color_StringInput>>4);

   ShowWordColor    (Color_MenuNormal&0x0F,Color_MenuNormal>>4);
   LightBarColor    (Color_MenuLightBar&0x0F,Color_MenuLightBar>>4);
   SelectedColor    (Color_MenuNormal&0x0F,Color_MenuNormal>>4);
   NormalColor      (Color_MenuNormal&0x0F,Color_MenuNormal>>4);
   HelpColor        (Color_DataLightBar&0x0F,Color_DataLightBar>>4);
}
void ReadSystemSetting(void)
{
   char *linetemp;     /* Size : 127 */ /* read line temp from file */
   char  maincfgflag=0;                /* If account setting in CFG file */
   int   i,j,k;

   strcpy(System_CFG,IC_Path);
   strcat(System_CFG,"DAYMAIN.CFG");

   if( (Main_CFG=fopen(System_CFG,"r"))==NULL)
      Message(1,0,0,"tγ]wŪ~I ϥιw]ȡC");

   strncpy(UnitPrn,"",40);
   YearType          =1;
   BeepControlFlag   =1;
   SleepSeconds      =180;
   PrinterPort       =0;               /* ver 0.24 */
   PrinterControlCode=0x7E;            /* ver 0.25 */
   strncpy(PrinterControlString,"ifkx0g2;",40);

   if(VideoMode()==7)                  /* Setting default color */
   {
      default_color[0]=Color_Message     =LIGHTRED   + 16*BLACK;
      default_color[1]=Color_MenuNormal  =LIGHTGRAY  + 16*BLACK;
      default_color[2]=Color_MenuLightBar=BLACK      + 16*LIGHTGRAY;
      default_color[3]=Color_DataNormal  =LIGHTGRAY  + 16*BLACK;
      default_color[4]=Color_DataLightBar=BLACK      + 16*LIGHTGRAY;
      default_color[5]=Color_StringInput =BLACK      + 16*LIGHTGRAY;
   }
   else
   {
      default_color[0]=Color_Message     =LIGHTRED   + 16*BLACK;
      default_color[1]=Color_MenuNormal  =BLUE       + 16*CYAN;
      default_color[2]=Color_MenuLightBar=YELLOW     + 16*CYAN;
      default_color[3]=Color_DataNormal  =LIGHTGRAY  + 16*BLUE;
      default_color[4]=Color_DataLightBar=WHITE      + 16*BLUE;
      default_color[5]=Color_StringInput =WHITE      + 16*GREEN;
   }

   linetemp=(char *)calloc(128,sizeof(char)); /* Memory locate for Data */
   for(;fgets(linetemp,127,Main_CFG)!=NULL;)
   {
      if(linetemp[0]==';')continue;              /* Deal with remark line */
      if(strnicmp(linetemp,maincfgbegin,10)==0)  /* if [tγ]w] */
      {  maincfgflag=1; continue; }
      if(strnicmp(linetemp,ending,5)==0)         /* if [END] */
      {  maincfgflag=0; break;  }
      if(maincfgflag==1)
      {
         DealWith_fget(linetemp);
         StringKillString(linetemp," ");
         if(linetemp[0]=='\0')continue;
         for(i=0;i<13;i++)
         {
            j=strlen(maincfgitem[i]);
            if(strncmp(linetemp,maincfgitem[i],j)==0)
            {
               k=atoi(&linetemp[j+1]);
               switch(i)
               {
                  case  0: k%=128; colorsets[0]=k; if(k!=0)Color_Message     =(unsigned char)k; break;
                  case  1: k%=128; colorsets[1]=k; if(k!=0)Color_MenuNormal  =(unsigned char)k; break;
                  case  2: k%=128; colorsets[2]=k; if(k!=0)Color_MenuLightBar=(unsigned char)k; break;
                  case  3: k%=128; colorsets[3]=k; if(k!=0)Color_DataNormal  =(unsigned char)k; break;
                  case  4: k%=128; colorsets[4]=k; if(k!=0)Color_DataLightBar=(unsigned char)k; break;
                  case  5: k%=128; colorsets[5]=k; if(k!=0)Color_StringInput =(unsigned char)k; break;
                  case  6: strncpy(UnitPrn,&linetemp[j+1],40);          break;
                  case  7: YearType          =(k!=0)?1:0;               break;
                  case  8: BeepControlFlag   =(k!=0)?1:0;               break;
                  case  9: SleepSeconds      =(k<=0)?0:k;               break;
                  case 10: PrinterPort       =(k<=0)?0:k;               break;   /* ver 0.24 */
                  case 11: PrinterControlCode=(k%256==0)?(0x7E):(k%256);break;   /* ver 0.25 */
                  case 12: strncpy(PrinterControlString,&linetemp[j+1],40);
                           if(PrinterControlString[strlen(PrinterControlString)-1]!=';')
                              strcat(PrinterControlString,";");
                           break;
                  default:                                              break;
               }
               break;
            }
         }
      }
   }
   fclose(Main_CFG);                            /* Close CFG file */
   free(linetemp);                      /* free unused memory */
   SettingParameter();
}
/******************************************************************************
1
2
3
4
5                C]w  G
6                  TC  G  [000]       Demo Demo Demo Demo Demo
7              Menu`C  G  [000]       Demo Demo Demo Demo Demo
8              MenuϥզC  G  [000]       Demo Demo Demo Demo Demo
9              ƥ`C  G  [000]       Demo Demo Demo Demo Demo
0              ƤϥզC  G  [000]       Demo Demo Demo Demo Demo
1              rJC  G  [000]       Demo Demo Demo Demo Demo
2
3                U  G  [1234567890123456789012345678901234567890]
4
5                L]w  G
6                ~ܪk  G  [0]         0 ܦ褸    1 ܥ
7                      G  [0]         0 ܵLn    1 ܦn
8        ù۰ʥ𮧮ɶ  G  [0000]    0 ܤ
9        L(Port)  G  [0]         0  LPT1   1  LPT2  ...
0              LX  G  [000]       0x00 (@뤤] "" 126 = 0x7E)
1                L]w  G  [1234567890123456789012345678901234567890]
2                              Ix}[D]G[ifkx0g2] pg[L]G[ifk3tx20x0g2]
3
******************************************************************************/
void showcolordemo(unsigned char Scolor,char Ypos,unsigned char dcolor)
{
   if(Scolor!=0)
   {
      char *demo="Demo";
      textattr(Scolor);
      gotoxy(44,Ypos);
      cprintf("%s %s %s %s %s",demo,demo,demo,demo,demo);
   }
   else
   {
      char *demo="Default";
      textattr(dcolor);
      gotoxy(44,Ypos);
      cprintf("%s %s %s ",demo,demo,demo);
   }
}
BOOL2 SystemSetting(void)
{
   char Totalitem=13;
   char Hlen[]={  3, 3, 3, 3, 3, 3,40, 1, 1, 4, 1, 3,40};
   char wx    =  33;
   char wy[]  ={  6, 7, 8, 9,10,11,13,16,17,18,19,20,21};
   char *scrbuf;
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   char i,j;
   int k[6];
   unsigned char kk;
   CWORDS CC;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen[i]+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen[i++]+1)
      stemp[i]=(sstemp+total_stemp);
   scrbuf=(char *)malloc(24*80*2*sizeof(char));
   gettext(1,1,80,24,scrbuf);
   Clrscr();

   for(i=0;i<6;i++)
   {
      k[i]=colorsets[i];
      itoa(k[i],stemp[i],10);
      showcolordemo(k[i],wy[i],default_color[i]);
   }
   strncpy(stemp[6],UnitPrn,40);
   itoa(YearType          ,stemp[ 7],10);
   itoa(BeepControlFlag   ,stemp[ 8],10);
   itoa(SleepSeconds      ,stemp[ 9],10);
   itoa(PrinterPort       ,stemp[10],10);    /* ver 0.24 */
   itoa(PrinterControlCode,stemp[11],10);    /* ver 0.25 */
   strncpy(stemp[12],PrinterControlString,40);

   /* CenterCwords(&CC,"Ob{tγ]w",48); */
   CenterCwords(&CC,"Ob{tγ]w",3); /* ver 0.248 */
   Cwords2(&CC);

   maincfgitem[9][16]='\0';
   for(i=0;i<Totalitem;i++)
   {
      gotoxy(wx-strlen(maincfgitem[i])-7,wy[i]);
      printf("%s  G  [",maincfgitem[i]);
      DrawWords2(stemp[i],wx,wy[i],Hlen[i]);
      printf("]");
   }
   maincfgitem[9][16]='(';
   printfXY(18, 5,"C]w  G");
   printfXY(18,15,"L]w  G");
   printfXY(44,16,"0 ܦ褸    1 ܥ");
   printfXY(44,17,"0 ܵLn    1 ܦn");
   printfXY(44,18,"0 ܤ");
   printfXY(39,18,"%2.2s",&maincfgitem[9][17]);
   printfXY(44,19,"0  LPT1   1  LPT2  ...");
   printfXY(44,20,"0x00 (@뤤] \"\" 126 = 0x7E)");
   printfXY(32,22,"Ix}[D]G[ifkx0g2] pg[L]G[ifk3tx20x0g2]");

   Replace_Mode();
   do{
      ch=0;eitem=0;
      while(ch!=Enter || eitem!=Totalitem)
      {
         Message(0,0,0,"Шϥ F2 sɡB Esc C");
         switch(eitem)
         {
            case 0: case 1: case 2: case 3: case 4: case 5:
               SetEnglishInput();
               Message(0,0,0,"ШϥμƦrCBEnter wCBW@BW@BF2 sɡBEsc ");
               printfXY(wx-3,wy[eitem],"=>");
               printfXY(wx+4,wy[eitem],"<=");
               ch=SelectColor(5,14,&k[eitem]);
               printfXY(wx-3,wy[eitem],"  ");
               printfXY(wx+4,wy[eitem],"  ");
               itoa(k[eitem],stemp[eitem],10);
               showcolordemo(k[eitem],wy[eitem],default_color[eitem]);
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               break;

            case 6:
               SetChineseInput();
               ch=GetWords(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               StringKillString(stemp[eitem]," ");
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               break;

            case 7: case 8:
               SetEnglishInput();
               ch=DGetWords(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               if(*(stemp[eitem])!='0') *(stemp[eitem])='1';
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               break;

            case 9:
               SetEnglishInput();
               ch=DGetWords(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
               {
                  for(i=0;i<Hlen[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                  stemp[eitem][i++]=' ';
                  stemp[eitem][i]='\0';
               }
               if(atoi(stemp[eitem])<0)strcpy(stemp[eitem],"180");
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               break;

            case 10:
               SetEnglishInput();
               ch=DGetWords(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               break;

            case 11:                                           /* ver 0.250 */
               SetEnglishInput();
               Message(0,0,0,"`NGi 0, 10, 12, 13, 65~90, 97~112");
               ch=DGetWords(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
               {
                  for(i=0;i<Hlen[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                  stemp[eitem][i++]=' ';
                  stemp[eitem][i]='\0';
               }
               kk=(unsigned char)((atoi(stemp[eitem]))%256);
               /* i 0x00 0x0A 0x0C 0x0D */ /* i AZ */
               if(kk==0 || kk==0x0A || kk==0x0C || kk==0x0D
                  ||(kk>'a' && kk<'z') || (kk>'A' && kk<'Z'))
                  itoa(PrinterControlCode,stemp[eitem],10);
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               printfXY(44,wy[eitem],"0x%02X",(unsigned char)atoi(stemp[eitem]));
               break;

            case 12:                                           /* ver 0.250 */
               SetEnglishInput();
               Message(0,0,0,"J D ]wIx}LAJ L ]wpgL  JL]wC");
               ch=GetWords(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               StringKillString(stemp[eitem]," ");
               if(stemp[eitem][0]=='D' || stemp[eitem][0]=='d')
                  strcpy(stemp[eitem],"ifkx0g2;");
               if(stemp[eitem][0]=='L' || stemp[eitem][0]=='l')
                  strcpy(stemp[eitem],"ifk3tx20x0g2;");
               if(stemp[eitem][0]!='I' && stemp[eitem][0]!='i')
               {
                  char pcstemp[42];
                  pcstemp[0]='i';
                  strncpy(pcstemp+1,stemp[eitem],40);
                  strncpy(stemp[eitem],pcstemp,40);
               }
               DrawWords2(stemp[eitem],wx,wy[eitem],Hlen[eitem]);
               break;
         }
         if(ch==F2)break;           /* save */
         if(ch==Esc || ch==C_B)
         {
            MessageOff();
            CwordsOff2();
            puttext(1,1,80,24,scrbuf);
            free(scrbuf);
            free(sstemp);
            free(stemp);
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-1)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?0:eitem-1;
      }
      ch=NotOK;
      ch=Ask_Yes("HWƬO_T");
   }while(!(ch==OK));
      Color_Message     =colorsets[0]=(unsigned char )k[0];
      Color_MenuNormal  =colorsets[1]=(unsigned char )k[1];
      Color_MenuLightBar=colorsets[2]=(unsigned char )k[2];
      Color_DataNormal  =colorsets[3]=(unsigned char )k[3];
      Color_DataLightBar=colorsets[4]=(unsigned char )k[4];
      Color_StringInput =colorsets[5]=(unsigned char )k[5];
      strncpy(UnitPrn,stemp[ 6],40);
      YearType          =(*(stemp[7])!='0')?1:0;
      BeepControlFlag   =(*(stemp[8])!='0')?1:0;
      SleepSeconds      =atoi(stemp[9]);
      PrinterPort       =atoi(stemp[10]);    /* ver 0.24 */
      PrinterControlCode=atoi(stemp[11]);    /* ver 0.250 */
      strncpy(PrinterControlString,stemp[12],40);
      if(PrinterControlString[strlen(PrinterControlString)-1]!=';')
         strcat(PrinterControlString,";");

   MessageOff();
   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   free(sstemp);
   free(stemp);
   normvideo();
   Cursor(0);
   WriteSystemSetting();
   SettingParameter();
   ReadSystemSetting();
   return OK;
}

/******************************************************************************
int   SelectColor(char left,char top,int *colorattr);
void  WriteSystemSetting(void);
void  SettingParameter(void);
void  ReadSystemSetting(void);
void  showcolordemo(unsigned char Scolor,char Ypos,unsigned char dcolor);
BOOL2 SystemSetting(void);
******************************************************************************/
