/*****************************************************************************/
/* UNIO2-3.C     Unit I/O  2  for Printer Output                             */
/*****************************************************************************/

#include"memain.i"

/*      #define NoPrinter         */

/******************************************************************************
~ifkx0;
01
02                               j        V        B    g    O                
03                                                                                                   @         
04       W   ڶW    H  K                                     n      B                   
05========  ==========  ========  ========  =========================================  ========  =====================
0679/10/01  B      ~  O  01234567  01234567890123456789012345678901234567890  99999999  012345678901234567890
0779/10/01  B      ~  O  01234567  01234567890123456789012345678901234567890  99999999  012345678901234567890
......................................................................................................................
4979/10/01  B      ~  O  01234567  01234567890123456789012345678901234567890  99999999  012345678901234567890
5079/10/01  B      ~  O  01234567  01234567890123456789012345678901234567890  99999999  012345678901234567890
51========  ==========  ========  ========  =========================================  ========  =====================
52                                                                         p  BG99999999
53 IܥثeAgOϥαβέppUG
54
55    B          ~  O        t B G 99999999      w   G 99999999      l    B G 99999999     
56    B            O        t B G 99999999      w   G 99999999      l    B G 99999999     
57    B          ]  O        t B G 99999999      w   G 99999999      l    B G 99999999     
58
59
60sG  j   V  B                                                                   LG00/00/00

pGCLe
ơP@AP@ڶ(1,1)
54
55
56    B          ~  O        t B G 01234567      w   G 01234567      l    B G 01234567     
57
58
ƢPAP@ڶ(0,1)
54
55
56    `  g  O      ~  O        t B G 99999999      w   G 99999999      l    B G 99999999     
57
58
ƣP@APڶ(1,0)
54
55    B          ~  O        t B G 99999999      w   G 99999999      l    B G 99999999     
56    B            O        t B G 99999999      w   G 99999999      l    B G 99999999     
57    B          ]  O        t B G 99999999      w   G 99999999      l    B G 99999999     
58
ƤPAPڶ(0,0)
54
55    `  g  O      ~  O        t B G 99999999      w   G 99999999      l    B G 99999999     
56    `  g  O        O        t B G 99999999      w   G 99999999      l    B G 99999999     
57    `  g  O      ]  O        t B G 99999999      w   G 99999999      l    B G 99999999     
57wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
58
******************************************************************************/

char *PPages="                                                      "
             "                                             @%3d   %3d\n";
char *PHeader=  "       W   ڶW    H  "
                "K                                     n  "
                "    B                   \n";
char *PartLine= "========  ==========  ========  ========  "
                "=========================================  "
                "========  =====================\n";
char *PFormat=  "%8s  %-10s  %c%c %c%c O  %8s  %-41s  %8s  %-21s\n";
char *PCalcul="                                           "
              "                              p  BG%8ld\n";
char *PFooter="sG%-40s           "
              "                                    LG%s";
char *PUFrame=""
              "\n";
char *PLFrame=""
              "\n";
char *PCFrame="wwwwwwwwwwwwwwwwwwwwwwwwwwwwww"
              "wwwwwwwwwwwwwwwwwwwwwwwwww\n";
char *PNFrame="                                                            "
              "                                                    \n";
char *PStatFormat ="    %10s      %c%c %c%c O        t B G %8ld      "
                   "w   G %8ld      l    B G %8ld     \n";
char *PStatFormat2="      %10s      %c%c %c%c O        t B G %8ld      "
                   "w   G %8ld      l    B G %8ld\n";

FILE *DevicePrinter;
char OpenDevicePrinter(char *printername)
{
   if((DevicePrinter=fopen(printername,"a+"))==NULL)
      return ERROR;
   return OK;
}
void CloseDevicePrinter(void)
{
   fclose(DevicePrinter);
}
char CheckDevicePrinterDriver(void)             /* ver 0.248 */
{
   int i,j;
   j=255;
   for(i=0;i<61;i++)
      if(DevicePrinterName[i]==':') {j=i-1; break;}
   if(j!=255)
   {  if(GetDiskFreeSpace(DevicePrinterName[j])>2048L)return OK;  }
   else
   {  if(GetDiskFreeSpace(0)>2048L)return OK; }
   return NotOK;
}
char DealWithPrinterNotReady(void)
{
   int ch;
   while(1)
   {
      Message(1,0,1,"L|ǳƦnAˬdLC  [R] ~  [A]  H");
      Cursor(2);
      do{
         Clear_KeyBuf();
         SetEnglishInput();
         ch=bioskey(0);
      }while(!(ch==N_R || ch==S_R || ch==N_A || ch==S_A || ch==Esc));
      ch=(ch==Esc)?N_A:ch;
      Cursor(0);
      MessageOff();
      if(ch==N_A || ch==S_A)  return USERBREAK; /* Break Print */
      if(PrinterOK()==OK)     return OK;        /* OK Continue Print */
                                             /* else continue ask for check */
   }
}
char PrinterOK(void)
{
   int PrintState;
   int i;
   if(PrinterType==1)return OK;                 /* ver 0.24 */
   while(TRUE)
   {
      PrintState=biosprint(2,0,PrinterPort);    /* ver 0.24 */
                                       /* ver 0.15 fixed for no ON-LINE option*/
      if(!(PrintState==0x90 || PrintState==0x10 || PrintState==0xD0 ||
           PrintState==0x80 || PrintState==0x00 || PrintState==0xC0))
         return NotOK;                 /* NotOK -> printer is NOT Ready */
      if(PrintState==0x90 || PrintState==0x80)
         return OK;                    /* OK -> printer is Ready for write */
      for(i=0;i<1000;i++);             /* Wait for a while */
   }
}
int  ToPrinter(char *fmt, ... )
{
   extern long far *cntptr;
   extern long old_time;
   va_list  argptr;                       /* Argument list pointer         */
   int cnt;                               /* Result of VFPRINTF for return */

   old_time=(*cntptr);

   FlagOfPrinting=1;
   if(PrinterOK()!=OK)
      if(DealWithPrinterNotReady()==USERBREAK)
      {
         CloseDBF();
         CloseDevicePrinter();
         FlagOfPrinting=0;
         FlagOfPrintBreak=0;
         ctrlbrk(NormalControlBreak);     /* Set Ctrl-Break function  */
         return ERROR;                    /* Printer Error */
      }
   if(FlagOfPrintBreak==1)
   {
      CloseDBF();
      CloseDevicePrinter();
      FlagOfPrinting=0;
      FlagOfPrintBreak=0;
      ctrlbrk(NormalControlBreak);        /* Set Ctrl-Break function  */
      return USERBREAK;                   /* User Break while printing */
   }
   va_start( argptr, fmt );               /* Initialize va_ functions     */

   if(PrinterType!=1)
   {
      cnt = vfprintf(stdprn,fmt,argptr);        /* prints string to file */
/*    if(cnt!=EOF)delay(cnt*17);                /* 58.8 cps */*/
      if(cnt!=EOF)delay(cnt*5);                 /* 200 cps */
   }
   else
   {
      if(OpenDevicePrinter(DevicePrinterName)!=OK)
         Message(1,0,0,"Lɮ׶}ҿ~I"),   /* ver 0.24 */
         cnt = EOF;
      else  if(CheckDevicePrinterDriver()==OK)  /* ver 0.248 */
         cnt = vfprintf(DevicePrinter,fmt,argptr); /* prints string to file */
            else
         Message(1,0,0,"Lɮ׼gJ~IϺЪŶI"),
         cnt = EOF;
      CloseDevicePrinter();
   }

   va_end( argptr );                      /* Close va_ functions          */

   cnt = (cnt!=EOF) ? OK : NotOK ;
   return( cnt );                         /* Return the conversion count  */
}
char PrintInit(void)
{
   return (ToPrinter("%ci;",PrinterControlCode)==OK) ? OK : NotOK ;
}
char PrintFormat(void)
{
   return (ToPrinter("%c%s",PrinterControlCode,PrinterControlString)==OK) ? OK : NotOK ;
}
char FormFeed(void)
{
   return (ToPrinter("%c",'\x0C')==OK) ? OK : NotOK ;
}
char PrintTitle(void)
{
   char *titlewords=TitlePrn;
   int  cCol=120;
   char PTitle[123];
   int  slen=strlen(titlewords);
   int  wnum=NumOfCword(titlewords);
   int  space,wspace,alen;
   int  i,j,k;
   space=cCol-slen;
   if(wnum==1)wspace=0;
   else       wspace=(space-20)/(wnum-1);
   wspace=(wspace>5)?5:( (wspace<0)?0:wspace );
   alen=slen+wspace*(wnum-1);

   memset(PTitle,0,123);
   for(i=0;i<(cCol-alen)/2;i++)PTitle[i]=' ';
   for(j=0;j<slen;)
      if(CwordInString(titlewords,j)==OK)
      {
         PTitle[i++]=titlewords[j++];
         PTitle[i++]=titlewords[j++];
         for(k=0;k<wspace;k++) PTitle[i++]=' ';
      }
      else
      {
         PTitle[i++]=titlewords[j++];
         if(CwordInString(titlewords,j)==OK)
            for(k=0;k<wspace;k++) PTitle[i++]=' ';
      }
   PTitle[i++]='\n';
   PTitle[i++]='\0';

   return ToPrinter(PTitle);
}
char PrintPages(int pTotalPage,int pCurrentPage)
{
   return (ToPrinter(PPages,pTotalPage,pCurrentPage)==OK) ? OK : NotOK ;
}
char PrintHeader(void)
{
   return (ToPrinter(PHeader)==OK) ? OK : NotOK ;
}
char PrintPartLine(void)
{
   return (ToPrinter(PartLine)==OK) ? OK : NotOK ;
}
char PrintPUFrame(void)
{
   return (ToPrinter(PUFrame)==OK) ? OK : NotOK ;
}
char PrintPLFrame(void)
{
   return (ToPrinter(PLFrame)==OK) ? OK : NotOK ;
}
char PrintPCFrame(void)
{
   return (ToPrinter(PCFrame)==OK) ? OK : NotOK ;
}
char PrintNullFrame(void)
{
   return (ToPrinter(PNFrame)==OK) ? OK : NotOK ;
}
char PrintNull(void)
{
   return (ToPrinter("\n")==OK) ? OK : NotOK ;
}
char PrintUnit(MEUNIT *pUnt)
{
   char Pperson[ 8+1];
   char Pdate  [ 8+1];
   char Pmoney [ 8+1];
   char Pmemo  [40+1];
   char Premark[20+1];
   char Punit;
   char Ptype;
   strncpy(Pperson,pUnt->person   , 8);Pperson[ 8]='\0';
   strncpy(Pdate  ,pUnt->date     , 8);Pdate  [ 8]='\0';
   strncpy(Pmoney ,&pUnt->money[2], 8);Pmoney [ 8]='\0';
   strncpy(Pmemo  ,pUnt->memo     ,40);Pmemo  [40]='\0';
   strncpy(Premark,pUnt->remark   ,20);Premark[20]= '\0';
   Punit=((pUnt->unit==' ' || pUnt->unit-'A'+1>=unit_num || pUnt->unit-'A'+1<0) ? 0 : pUnt->unit-'A'+1);
   Ptype=((pUnt->type==' ' || pUnt->type-'A'+1>=type_num || pUnt->type-'A'+1<0) ? 0 : pUnt->type-'A'+1);

   return (ToPrinter(PFormat,Pdate,unitlong[Punit],typeshort[Ptype][0],
           typeshort[Ptype][1],typeshort[Ptype][2],typeshort[Ptype][3],
           Pperson,Pmemo,Pmoney,Premark)==OK) ? OK : NotOK ;
}
char PrintCalculate(long pStat)
{
   return (ToPrinter(PCalcul,pStat)==OK) ? OK : NotOK ;
}
char PrintFooter(void)
{
   char Pdate[9];
   Date_String(Pdate);
   return (ToPrinter(PFooter,UnitPrn,Pdate)==OK) ? OK : NotOK ;
}
char PrintUnitType(char pUnit,char pType,char frameflag)    /* A->1,B->2,... */
{
   char *utotal="`  g  O";
   if(frameflag==1)
      return (ToPrinter(PStatFormat,(pUnit==0)?utotal:unitlong[pUnit],
         typeshort[pType][0],typeshort[pType][1],
         typeshort[pType][2],typeshort[pType][3],
         (pUnit==0)?STATSET [pType-1] : STSET [pUnit-1][pType-1],
         (pUnit==0)?STATALL [pType-1] : STALL [pUnit-1][pType-1],
         (pUnit==0)?STATREST[pType-1] : STREST[pUnit-1][pType-1])==OK)?OK:NotOK;
   else
      return (ToPrinter(PStatFormat2,(pUnit==0)?utotal:unitlong[pUnit],
         typeshort[pType][0],typeshort[pType][1],
         typeshort[pType][2],typeshort[pType][3],
         (pUnit==0)?STATSET [pType-1] : STSET [pUnit-1][pType-1],
         (pUnit==0)?STATALL [pType-1] : STALL [pUnit-1][pType-1],
         (pUnit==0)?STATREST[pType-1] : STREST[pUnit-1][pType-1])==OK)?OK:NotOK;
}
char PrintStat(char pUnit,char pType)        /* A - > 1 , B -> 2 , ... */
{
   char i;

   if(pType>TYPE_KINDS)                /* Not the end page , print null lines */
   {
      for(i=0;i<7;i++)
         if(PrintNull()!=OK)   return NotOK;
      return OK;
   }

   if(ToPrinter("IܥثeAgOϥαβέppUG\n")!=OK)   return NotOK;
   switch(pType)
   {
      case 0:        /* print all type of stat result */
         if(PrintPUFrame()!=OK)   return NotOK;
         switch(pUnit)
         {
            case 0:  /* print Total of all type of stat result */
               for(i=1;i<type_num;i++)
                  if(PrintUnitType(0,i,1)!=OK)return NotOK;
               break;

            default: /* print specific unit of all type of stat result */
               for(i=1;i<type_num;i++)
                  if(PrintUnitType(pUnit,i,1)!=OK)return NotOK;
               break;
         }
         if(PrintPLFrame()!=OK)return NotOK;
         for(;i<5;i++)if(PrintNull()!=OK)return NotOK;
         break;

      default:       /* print specific type of stat result */
         if(PrintNull()!=OK)return NotOK;
         if(PrintPUFrame()!=OK)return NotOK;
         switch(pUnit)
         {
            case 0:  /* print Total of specific type of stat result */
               if(PrintUnitType(0,pType,1)!=OK)return NotOK;
               break;

            default: /* print specific unit of specific type of stat result */
               if(PrintUnitType(pUnit,pType,1)!=OK)return NotOK;
               break;
         }
         if(PrintPLFrame()!=OK)return NotOK;
         if(PrintNull()!=OK)return NotOK;
         if(PrintNull()!=OK)return NotOK;
         break;
   }
   return OK;
}
/******************************************************************************
char OpenDevicePrinter(char *printername);
void CloseDevicePrinter(void);
char DealWithPrinterNotReady(void);
char PrinterOK(void);
int  ToPrinter(char *fmt, ... );
char PrintInit(void);
char PrintFormat(void);
char FormFeed(void);
char PrintTitle(void);
char PrintPages(int pTotalPage,int pCurrentPage);
char PrintHeader(void);
char PrintPartLine(void);
char PrintPUFrame(void);
char PrintPLFrame(void);
char PrintPCFrame(void);
char PrintNullFrame(void);
char PrintNull(void);
char PrintUnit(MEUNIT *pUnt);
char PrintCalculate(long pStat);
char PrintFooter(void);
char PrintUnitType(char pUnit,char pType,char frameflag);
char PrintStat(char pUnit,char pType);
******************************************************************************/
