/*****************************************************************************/
/* UNIO3-2.C     Unit I/O  3  for Input Data                                 */
/*****************************************************************************/

#include"memain.i"

/*******************************************************************Layout Mode
                                                                ~wwww01
    Cwords("gOƷjM@",48,30,10,2,'o');                    xNx 2
    Cwords("gOƷjMG",48,30,10,2,'o');                    xA=Bx 3
                                                                xB=ҥ~բx 4
                                                                xC=|բx 5
    WG [00/00/00]   [**] ܩҦ                       xD=ͻբx 6
                                                                xE=Ǣx 7
    UG [00/00/00]   [**] ܩҦ                       xF=ëOǢx 8
                                                                xG=߻Ǣx 9
    NG [A] B    [*] ܩҦ  [ ] ܧbb(w)   xH=ǥͷ|x 0
                                                                xI=Ǣx 1
    ڶNG [A] ~ȶO    [*] ܩҦ  [ ] ܧbb(w)   x        x 2
                                                                x        x 3
      HG [@GT|]                                       x        x 4
                                                                x        x 5
    K    nG [@GT|CKEQ@GT|CKE]        6
                                                                xڶNx 7
    BWG [00000000]                                       xA=~ȶOx 8
                                                                xB=ƶOx 9
    BUG [00000000]                                       xC=]ƶOx 0
                                                                x        x 1
        G [@GT|CKEQ]                           wwww 2
    HWƬO_TH]^
******************************************************************************/
char GetOneUnitSearch(MEUNITSEARCH *tmp,char Newflag,char Drawflag,char Typeflag)
{
   char *Hitem[]={"W","U","N","ڶN", "  H",
                  "K    n","BW","BU","    "   };
   char *Hformat[]={ "  /  /  ","  /  /  "," "," ","        ",
                     "                                        ",
                     "        ","        ","                    " };
   char *typehelp1="[**] ܩҦ";
   char *typehelp2="[*] ܩҦ  [ ] ܧbb(w)";
   char *allknown="  ";
   char *unknown ="b  b";
   char Hlen[]={8,8,1,1,8,40,8,8,20};
   char Totalitem=9;
   char **stemp;                    /* *stemp[] temp of each data */
   char *sstemp;                    /* base for *stemp[] */
   long tmprest;                    /* temp for rest */
   unsigned int total_stemp;        /* total bytes need for *stemp[] */
   char eitem;                      /* Current Item of editing */
   int  ch;                         /* Get from bioskey() */
   unsigned long date1,date2;       /* date to long to cmpare */
   char i,j;

   /* Dynamic Usage of the memory -- One Dimension Pointer Array */
   for(i=0,total_stemp=0;i<Totalitem;i++)total_stemp+=Hlen[i]+1;
   stemp=(char **)calloc(Totalitem,sizeof(char *));
   sstemp=(char *)calloc(total_stemp,sizeof(char));
   for(i=0,total_stemp=0;i<Totalitem;total_stemp+=Hlen[i++]+1)
      stemp[i]=(sstemp+total_stemp);

   if(Drawflag==1)
   {
      if(Typeflag==1)                     /* draw fram and table */
         ShowFormat("gOƷjM@");
      else
         ShowFormat("gOƷjMG");
      if(Typeflag==1)gotoxy(29, 8),printf(typehelp1);
      gotoxy(30,10);printf(typehelp2);
      gotoxy(30,12);printf(typehelp2);
   }
   if(Newflag==1)
   {
      if(Typeflag==1)                        /* I.C. value for New */
         strcpy(stemp[0],"**/**/**"), strcpy(stemp[1],"**/**/**");
      else
         strcpy(stemp[0],"80/01/01"), Date_String(stemp[1]);
      *(stemp[2])=*(stemp[3])='*';
      strcpy(stemp[6],"0");
      strcpy(stemp[7],"99999999");                                /*ver 1.01*/
   }
   else
   {                                         /* Use Old Value for Modify */
      strncpy(stemp[0],tmp->date1,8);     stemp[0][ 8]='\0';
      strncpy(stemp[1],tmp->date2,8);     stemp[1][ 8]='\0';
      *(stemp[2])=tmp->unit;
      *(stemp[3])=tmp->type;
      strncpy(stemp[4],tmp->person,8);    stemp[4][ 8]='\0';
      strncpy(stemp[5],tmp->memo,40);     stemp[5][40]='\0';
      ltoa(atol(tmp->money),stemp[6],10); stemp[6][ 8]='\0';
      ltoa(atol(tmp->money2),stemp[7],10);stemp[7][ 8]='\0';      /*ver 1.01*/
      strncpy(stemp[8],tmp->remark,20);   stemp[8][20]='\0';      /*ver 1.01*/
   }

   for(i=0;i<Totalitem;i++)                /* Show words */
   {
      gotoxy(5,6+i*2);
      if(Typeflag==1 && i==1)             printf("%sG [","    ");
      else  if(Typeflag==1 && i==6)             printf("%sG [","    B");
            else  if(!(Typeflag==1 && (i==0 || i==7)))printf("%sG [",Hitem[i]);
      if(!(Typeflag==1 && (i==0 || i==7)))
         DrawWords2(stemp[i],wherex(),wherey(),Hlen[i]),printf("]");
      switch(i)
      {
         case 2:
            gotoxy(20,6+i*2);
            if(*(stemp[i])=='*')printf(allknown);
            else  if(*(stemp[i])==' ')printf(unknown);
                  else  if(*(stemp[i])-'A'<0 || *(stemp[i])-'A'>unit_num-2)
                           printf(unknown);
                        else
                           printf("%s",unitshort[*(stemp[i])-'A'+1]);
            break;
         case 3:
            gotoxy(20,6+i*2);
            if(*(stemp[i])=='*')printf(allknown);
            else  if(*(stemp[i])==' ')printf(unknown);
                  else  if(*(stemp[i])-'A'<0 || *(stemp[i])-'A'>type_num-2)
                           printf(unknown);
                        else
                           printf("%sO",typeshort[*(stemp[i])-'A'+1]);
            break;
      }
   }
   ch=0;
   do{
      if(ch==N_N|| ch==S_N)MessageOff();
      ch=0;eitem=0;
      while(ch!=Enter || eitem!=Totalitem)
      {
         switch(eitem)
         {
            case 0:
               if(Typeflag==1)
                  ch=Down;
               else
               {
                  SetEnglishInput();
                  ch=DFGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
                  DealWithDateString(stemp[eitem]);
                  DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               }
               break;

            case 1:
               SetEnglishInput();
               if(Typeflag==1)
                  ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               else
                  ch=DFGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               DealWithDateString(stemp[eitem]);
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);

               if(Typeflag==1)break;
               DateToLong(&date1,stemp[0]);
               DateToLong(&date2,stemp[1]);
               if(date2<date1)
                  ch=N_0,eitem=0,
                  Message(1,0,0,"UjWIЭsJC");
               else
                  MessageOff();

               break;

            case 6:
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
               {
                  for(i=0;i<Hlen[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                  stemp[eitem][i++]=' ';
                  stemp[eitem][i]='\0';
               }
               if(atol(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;

            case 7:
               if(Typeflag==1) break;
               SetEnglishInput();
               ch=DFGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               while(stemp[eitem][0]=='0' && (stemp[eitem][1]!=' ' && stemp[eitem][1]!='\0'))
               {
                  for(i=0;i<Hlen[eitem]-1;i++) stemp[eitem][i]=stemp[eitem][i+1];
                  stemp[eitem][i++]=' ';
                  stemp[eitem][i]='\0';
               }
               if(atol(stemp[eitem])<=0)strcpy(stemp[eitem],"0");
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);

               if(atol(stemp[7])<atol(stemp[6]))
                  ch=N_0,eitem=6,
                  Message(1,0,0,"BUjBWIЭsJC");
               else
                  MessageOff();
               break;


            case 2:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2))==Esc)break;
               if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
               {
                  gotoxy(20,6+eitem*2);
                  printf("%s",(*(stemp[eitem])=='*')?allknown:unknown);
                  DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               }
               else
               {
                  if(islower(*(stemp[eitem])))*(stemp[eitem])-='a'-'A';
                  gotoxy(20,6+eitem*2);
                  if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>unit_num-2)
                     printf("%s",(*(stemp[eitem])='*',allknown));
                  else
                     printf("%s",unitshort[*(stemp[eitem])-'A'+1]);
                  DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               }
               break;

            case 3:
               SetEnglishInput();
               if((ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2))==Esc)break;
               if(*(stemp[eitem])=='*' || *(stemp[eitem])==' ')
               {
                  gotoxy(20,6+eitem*2);
                  printf("%s",(*(stemp[eitem])=='*')?allknown:unknown);
                  DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               }
               else
               {
                  if(islower(*(stemp[eitem])))*(stemp[eitem])-='a'-'A';
                  gotoxy(20,6+eitem*2);
                  if(*(stemp[eitem])-'A'<0||*(stemp[eitem])-'A'>type_num-2)
                     printf("%s",(*(stemp[eitem])='*',allknown));
                  else
                     printf("%sO",typeshort[*(stemp[eitem])-'A'+1]);
                  DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               }
               break;

            case 4:
            case 5:
            case 8:
               SetChineseInput();
               ch=FGetWords(stemp[eitem],Hformat[eitem],17,6+eitem*2);
               StringKillBlankBoth(stemp[eitem]);
               DrawWords2(stemp[eitem],17,6+eitem*2,Hlen[eitem]);
               break;
         }
         if(ch==Esc || ch==C_B)
         {
            free(sstemp);
            free(stemp);
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter)
                  eitem=eitem+1;
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-1)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?0:eitem-1;
      }
      if(Typeflag==1)strncpy(tmp->date1,stemp[1],9);
      else           strncpy(tmp->date1,stemp[0],9);
      strncpy(tmp->date2,stemp[1],9);
      tmp->unit=*(stemp[2]);
      tmp->type=*(stemp[3]);
      strncpy(tmp->person,stemp[4],9);
      strncpy(tmp->memo,stemp[5],41);
      for(i=0;i<strlen(stemp[6]);i++)
         if(stemp[6][i]==' ' || stemp[6][i]=='\0') break;
      j=i;
      for(i=0;i<8-j;i++)tmp->money[i]=' ';
      strncpy(&tmp->money[i],stemp[6],j); tmp->money[8]='\0';
      for(i=0;i<strlen(stemp[7]);i++)
         if(stemp[7][i]==' ' || stemp[7][i]=='\0') break;
      j=i;
      for(i=0;i<8-j;i++)tmp->money2[i]=' ';
      strncpy(&tmp->money2[i],stemp[7],j); tmp->money2[8]='\0';
      strncpy(tmp->remark,stemp[8],21);

      ch=Ask_Yes("O_}ljM");
   }while(ch!=OK);

   free(sstemp);
   free(stemp);
   normvideo();
   Cursor(0);
   return OK;
}
