/*****************************************************************************/
/* UNIO3-2.C     Unit I/O  3  for Input Data  &  Search specific data        */
/*****************************************************************************/

#include"daymain.i"

unsigned long   UpperDate,LowerDate;
double UpperMoney,LowerMoney,SetMoney;
char    *strstr2 (const char *s1, const char *s2,int len)
{
   char *sss,*ss1;
   char s1end=s1[len];
   ss1=(char *)s1;
   ss1[len]='\0';
   sss=strstr(ss1,s2);
   ss1[len]=s1end;
   return sss;
}
void SetDateRange(DAYUNITSEARCH *Stmp)
{
   DateToLong(&LowerDate,Stmp->date1);
   DateToLong(&UpperDate,Stmp->date2);
}
void SetMoneyRange(DAYUNITSEARCH *Stmp)
{
   LowerMoney=atof(Stmp->money1);
   UpperMoney=atof(Stmp->money2);
}
char CheckDateRange(DAYUNIT     *Tmp)      /* these check sub-routine will */
{                                         /* return  OK if match else NotOK */
   unsigned long date0;
   DateToLong(&date0,Tmp->date);
   return (date0>=LowerDate && date0<=UpperDate) ? OK : NotOK ;
}
char CheckYear(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (strncmp(&Stmp->date1[0],&Tmp->date[0],2)==0) ? OK : NotOK ;
}
char CheckMon(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (strncmp(&Stmp->date1[3],&Tmp->date[3],2)==0) ? OK : NotOK ;
}
char CheckDay(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (strncmp(&Stmp->date1[6],&Tmp->date[6],2)==0) ? OK : NotOK ;
}
char CheckIn_or_Ex(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (Stmp->in_or_ex == Tmp->in_or_ex) ? OK : NotOK;
}
char CheckType(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (Stmp->type == Tmp->type) ? OK : NotOK;
}
char CheckAccount(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (Stmp->account == Tmp->account) ? OK : NotOK;
}
char CheckMemo(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)
{
   return (strstr2(Tmp->memo,Stmp->memo,40)!=NULL) ? OK : NotOK ;
}
char CheckMoneyRange(DAYUNIT     *Tmp)
{
   char t=Tmp->money[10];
   double tmoney;
   Tmp->money[10]='\0';
   tmoney=atof(Tmp->money);
   Tmp->money[10]= t  ;
   return (tmoney>=LowerMoney && tmoney<=UpperMoney) ? OK : NotOK ;
}
char CheckMoney(DAYUNIT     *Tmp)
{
   char t=Tmp->money[10];
   double tmoney;
   Tmp->money[10]='\0';
   tmoney=atof(Tmp->money);
   Tmp->money[10]= t  ;
   return ( SetMoney == tmoney ) ? OK : NotOK ;
}
char CheckTk_no(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp)       /* temp */
{
   return (strstr2(Tmp->tk_no,Stmp->tk_no,10)!=NULL) ? OK : NotOK ;
}
void SetMemo(DAYUNITSEARCH *Stmp)
{
   StringKillBlankBoth(Stmp->memo);
}
void SetTk_no(DAYUNITSEARCH *Stmp)
{
   StringKillBlankBoth(Stmp->tk_no);
}
char Searching(DAYUNITSEARCH *Stmp,char Typeflag)
{
   int   *IndexT;
   DAYUNIT thistmp;
   int   C_IndexT;
   char  yearflag,monflag,dayflag,in_or_exflag,typeflag,accountflag,memoflag,moneyflag,tk_noflag;
   char  startx,starty,slen;
   int   i;

   IndexT=(int *)calloc(totalnumb,sizeof(int));
   C_IndexT=0;

   InitDoing(&startx,&starty,"      O  b    j M    DDD   ",&slen,1);
   if(Typeflag%2==1)
   {
      if(strncmp(&Stmp->date1[0],"**",2)==0)  yearflag=0;
      else                                    yearflag=1;
      if(strncmp(&Stmp->date1[3],"**",2)==0)  monflag =0;
      else                                    monflag =1;
      if(strncmp(&Stmp->date1[6],"**",2)==0)  dayflag =0;
      else                                    dayflag =1;
   }
   else
      SetDateRange(Stmp);
   if(Stmp->in_or_ex=='*') in_or_exflag=0;
   else                    in_or_exflag=1;
   if(Stmp->type=='*')     typeflag=0;
   else                    typeflag=1;
   if(Stmp->account=='*')  accountflag=0;
   else                    accountflag=1;
   SetMemo(Stmp);
   if(Stmp->memo[0]=='\0') memoflag=0;
   else                    memoflag=1;
   SetTk_no(Stmp);
   if(Stmp->tk_no[0]=='\0')tk_noflag=0;
   else                    tk_noflag=1;
   if(Typeflag%2==1)
   {
      if(atof(Stmp->money1)==0)   moneyflag=0;
      else                        moneyflag=1,  SetMoney=atof(Stmp->money1);
   }
   else
   {
      if(atof(Stmp->money1)==0 && atof(Stmp->money2)>=(double)9999999999.0)
            moneyflag=0;
      else  moneyflag=1;
      SetMoneyRange(Stmp);
   }

   OpenDBF();
   for(i=0;i<C_IndexY;i++)
   {
      Doing(startx,starty,100*((float)(i+1)/(float)C_IndexY),slen,1);
      ReadOneUnit(&thistmp,ALL[IndexY[i]]->index);
      if(Typeflag%2==1 && yearflag==1)
         if(CheckYear(Stmp,&thistmp)!=OK)continue;
      if(Typeflag%2==1 && monflag==1)
         if(CheckMon(Stmp,&thistmp)!=OK)continue;
      if(Typeflag%2==1 && dayflag==1)
         if(CheckDay(Stmp,&thistmp)!=OK)continue;
      if(Typeflag%2==0)
         if(CheckDateRange(&thistmp)!=OK)continue;
      if(in_or_exflag==1)
         if(CheckIn_or_Ex(Stmp,&thistmp)!=OK)continue;
      if(typeflag==1)
         if(CheckType(Stmp,&thistmp)!=OK)continue;
      if(accountflag==1)
         if(CheckAccount(Stmp,&thistmp)!=OK)continue;
      if(memoflag==1)
         if(CheckMemo(Stmp,&thistmp)!=OK)continue;
      if(Typeflag%2==1 && moneyflag==1)
         if(CheckMoney(&thistmp)!=OK)continue;
      if(Typeflag%2==0 && moneyflag==1)
         if(CheckMoneyRange(&thistmp)!=OK)continue;
      if(tk_noflag==1)
         if(CheckTk_no(Stmp,&thistmp)!=OK)continue;
      IndexT[C_IndexT++]=IndexY[i];
   }
   OffDoing(startx,starty,slen,1);
   CloseDBF();                                                    /*ver 1.01*/
   if(C_IndexT==0)
   {
      free(IndexT);
      return NotOK;
   }
   else
   {
      memcpy(IndexS,IndexT,sizeof(int)*C_IndexT);
      C_IndexS=C_IndexT;
      free(IndexT);
      return OK;
   }
}
char Search(void)
{
   char *scrbuf;
   static DAYUNITSEARCH Stmp[2];    /* Keep Old Value in memory */
   BOOL2 findflag,getflag;
   char CurrentDataTypeBak;
   char SearchType;
   int  ch;

   Message(0,0,1,"пܷjM覡  [1]@jM  [2]djM H");
   Cursor(2);
   Clear_KeyBuf();
   do{
      SetEnglishInput();
      ch=bioskey(0);
   }while(!(ch==N_1||ch==N_2||ch==Esc));
   Cursor(0);
   MessageOff();
   if(ch==Esc) return USERBREAK;
   switch(ch)
   {
      case N_1:SearchType=1;break;
      case N_2:SearchType=2;break;
   }

   CurrentDataTypeBak=CurrentDataType;
   scrbuf=(char *)malloc(sizeof(char)*80*24*2);
   gettext(1,1,80,24,scrbuf);

   Replace_Mode();
   findflag=OTHER;
   do
   {
      if(SearchType==1)
         getflag=GetOneUnitSearch1(&Stmp[0],((Stmp[0].in_or_ex==0)?1:0),((findflag==OTHER)?1:0));
      else
         getflag=GetOneUnitSearch2(&Stmp[1],((Stmp[1].in_or_ex==0)?1:0),((findflag==OTHER)?1:0));

      findflag=NotOK;
      if(getflag==OK)
      {
         Message(0,0,0,"jMDDD");
         if(Searching(&Stmp[SearchType-1],SearchType)==OK)  /* find */
         {
            Message(0,0,0,"jMC");
            CurrentDataType=2;
            findflag=OK;
            break;
         }
         else
            Message(1,0,0,"jMơIЦAJsdC");
      }
      else
      {
         CurrentDataType=CurrentDataTypeBak;
         MessageOff();
         break;
      }
   }while(findflag==NotOK);

   CwordsOff2();
   puttext(1,1,80,24,scrbuf);
   free(scrbuf);
   return findflag;
}

/******************************************************************************
void SetDateRange(DAYUNITSEARCH *Stmp);
void SetMoneyRange(DAYUNITSEARCH *Stmp);
char CheckDateRange(DAYUNIT     *Tmp);
char CheckYear(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckMon(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckDay(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckIn_or_Ex(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckType(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckAccount(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckMemo(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
char CheckMoneyRange(DAYUNIT     *Tmp);
char CheckMoney(DAYUNIT     *Tmp);
char CheckTk_no(DAYUNITSEARCH *Stmp,DAYUNIT     *Tmp);
void SetMemo(DAYUNITSEARCH *Stmp);
void SetTk_no(DAYUNITSEARCH *Stmp);
char Searching(DAYUNITSEARCH *Stmp,char Typeflag);
char Search(void);
******************************************************************************/
