/*****************************************************************************/
/* UNIO1-3.C     Unit I/O  1  for File input/output                          */
/*****************************************************************************/

#include"viewer.i"

char *IDXquit0=  "^De";
char *IDXquit1=  "d";
int TimeofIDX=0;
BOOL2 Read_CFG(char *CFG_filename,char **fsets,char **ssets,char *nums)
{
   FILE *File_CFG;
   char *eptr;
   char *linetemp;     /* Size : 129 *//* read line temp from file */
   int   i;

   if( (File_CFG=fopen(CFG_filename,"r"))==NULL)
   {
      Message(1,0,0,"]w \"%s\" Ū~I",CFG_filename);
      return NotOK;
   }
   *nums=0;
   linetemp=(char *)calloc(129,sizeof(char)); /* Memory locate for Data */

   for(;fgets(linetemp,128,File_CFG)!=NULL;)
   {
      if(linetemp[0]==';')continue;              /* Deal with remark line */
      if(linetemp[0]=='\n')continue;             /* Deal with null line */
      if(strnicmp(linetemp,"[END]",5)==0)        /* if [END] */
         break;
      DealWith_fget(linetemp);
      StringKillBlankAll(linetemp);
      if((eptr=(char *)strchr(linetemp,(int)'='))==NULL)       /* no '=' mark */
         continue;
      *eptr='\0'; eptr++;
      strncpy(fsets[*nums],linetemp,12);fsets[*nums][12]='\0';
      strupr(fsets[*nums]);
      strncpy(ssets[*nums],eptr,52);ssets[*nums][52]='\0';
      *nums+=1;
   }
   free(linetemp);                      /* free unused memory */
   fclose(File_CFG);                            /* Close CFG file */
}
BOOL2 GetCFGNum(char *CFG_filename,char *nums,int *slen)
{
   FILE *File_CFG;
   char *eptr;
   char *linetemp;     /* Size : 129 *//* read line temp from file */
   int   i,sslen;

   if( (File_CFG=fopen(CFG_filename,"r"))==NULL)
   {
      Message(1,0,0,"]w \"%s\" Ū~I",CFG_filename);
      return NotOK;
   }
   *nums=0;
   linetemp=(char *)calloc(129,sizeof(char)); /* Memory locate for Data */
   *slen=0;
   for(;fgets(linetemp,128,File_CFG)!=NULL;)
   {
      if(linetemp[0]==';')continue;              /* Deal with remark line */
      if(linetemp[0]=='\n')continue;             /* Deal with null line */
      if(strnicmp(linetemp,"[END]",5)==0)        /* if [END] */
         break;
      DealWith_fget(linetemp);
      StringKillBlankAll(linetemp);
      if((eptr=(char *)strchr(linetemp,(int)'='))==NULL)       /* no '=' mark */
         break;
      *eptr='\0'; eptr++;
      *nums+=1;
      sslen=strlen(eptr);
      *slen=(*slen<sslen)?sslen:*slen;
   }
   free(linetemp);                      /* free unused memory */
   fclose(File_CFG);                            /* Close CFG file */
}

/*extern char FlagOfShowingCwords;*/
extern char *menuselectmsg;
extern char *menuselectmsg2;
extern char *menuselectmsg3;
BOOL2 ShowIDXfile(CWORDS *CC,char sTop,char sBottom,char *IDXfileName,void (func)())
{
   char *quit;
   char **item;      /* 81 */
   char **titleA;    /* 53 */
   char **file;      /* 13 */
   char *bitem;      /* 81 */
   char *btitleA;    /* 53 */
   char *bfile;      /* 13 */
   CWORDS *CCA;
   int i,j,ch;
   char ii;
   char totalitems;
   int  leng;
   TimeofIDX++;

   if(TimeofIDX==1)  quit=IDXquit1;
   else              quit=IDXquit0;
   GetCFGNum(IDXfileName,&totalitems,&leng);

   item   =(char **)  calloc((totalitems+1)   ,sizeof(char *));
   titleA =(char **)  calloc((totalitems+1)   ,sizeof(char *));
   file   =(char **)  calloc((totalitems+1)   ,sizeof(char *));
   CCA    =(CWORDS*)  calloc((totalitems+1)   ,sizeof(CWORDS));
   bitem  =(char *)   calloc((totalitems+1)*81,sizeof(char));
   btitleA=(char *)   calloc((totalitems+1)*53,sizeof(char));
   bfile  =(char *)   calloc((totalitems+1)*13,sizeof(char));
   for(i=0;i<(totalitems+1);i++)item[i]  =(bitem  +i*81);
   for(i=0;i<(totalitems+1);i++)titleA[i]=(btitleA+i*53);
   for(i=0;i<(totalitems+1);i++)file[i]  =(bfile  +i*13);

   Read_CFG(IDXfileName,file,titleA,&ii);
   strcpy(titleA[totalitems++],quit);
   for(i=0;i<totalitems-1;i++)
      CenterCwords(&CCA[i],titleA[i],2);
   for(i=0;i<totalitems;i++)
      CenterCstring2(item[i],titleA[i],80,1);

   ICScreen();
   Clrscr();
   i=0,j=0;
   func();
   window(1,sTop,80,sBottom);
   ShowTextWindow2NoColor(item,totalitems,0);
   /*FlagOfShowingCwords=1;*/
   while(TRUE)
   {
      window(1,1,80,24);
      Cwords(CC);
      Message(0,0,0,(TimeofIDX!=1)?menuselectmsg2:menuselectmsg3,menuselectmsg);
      Cursor(0);
      while((ch=TextWindow2(1,sTop,80,sBottom,totalitems,item,&i,&j,0))!=Esc && ch!=Enter);
      if(ch==Esc || i+1==totalitems)
      {
         if( TimeofIDX != 1) break;
         else  if(Ask_No("O_d")==NotOK)break;
               else continue;
      }
      GetScreen(); Clrscr();

      if(strstr(file[i],".IDX")!=NULL)
         CenterCwords(&CCA[i],titleA[i],4),
         ShowIDXfile(&CCA[i],sTop,sBottom,file[i],fnull);
      else if(strstr(file[i],".ITX")!=NULL)
         CenterCwords(&CCA[i],titleA[i],4),
         ShowITXfile(&CCA[i],sTop,sBottom,file[i],fnull);
      else
      {
         Cwords(&CCA[i]);
         if(strstr(file[i],".R_C")!=NULL)ShowROWCOL (file[i]);
         else ShowTXTfile(file[i]);
      }

      Clrscr();
      PutScreen();
   }
   FreeScreen();

   free(bfile);
   free(btitleA);
   free(bitem);
   free(CCA);
   free(file);
   free(titleA);
   free(item);
   TimeofIDX--;
}
