/*****************************************************************************/
/* UNIO4-1.C     Unit I/O  4  for ALL Memory allocation & free  & Sort       */
/*****************************************************************************/

#include"memain.i"
#define BytesToCmp 10

char **sALL;               /* Be a Index */
char far *sALLbase;        /* Base for *sALL[] */
char far *sALLindex;       /* Index of sALL[] */

void MemNotEnough(void)
{
   static char *eee="\n\7O餣II"
                    "\nбNJO餧`n{֡AA榹{"
                    "\nέs}AA榹{\n";
   printf(eee);
   sleep(3);
   Clear_KeyBuf();
   SetEnglishInput();
   bioskey(0);
   exit(0);
}
void MemNotEnough2(void)
{
   Message(1,0,0,"O餣!! Lk榹\\C");
}
void Alloc_ALL(void)
{
   int i;
   long LenR;
   unsigned int ALL_seg;   /* for far pointer of ALL */
   unsigned int ALL_off;   /* for far pointer of ALL */

   if(coreleft()<MemLeft)MemNotEnough();        /* Check Memory Size */

   IC_Path    =(char *)calloc(61,sizeof(char)); /* Include Full Path */
   System_CFG =(char *)calloc(61,sizeof(char)); /* Include Full Path */
   Current_CFG=(char *)calloc(61,sizeof(char)); /* Include Full Path */
   Current_DBF=(char *)calloc(61,sizeof(char)); /* Include Full Path */
   Current_SAT=(char *)calloc(61,sizeof(char)); /* Include Full Path */

   unitshort=(char **)calloc(UNIT_KINDS+1,sizeof(char *));  /* include   */
   unitlong =(char **)calloc(UNIT_KINDS+1,sizeof(char *));  /* undefined */
   typeshort=(char **)calloc(TYPE_KINDS+1,sizeof(char *));  /* type,so +1*/

   unitshortbase=(char far *)farcalloc(UNIT_KINDS+1,sizeof(char)*7);
   unitlongbase =(char far *)farcalloc(UNIT_KINDS+1,sizeof(char)*11);
   typeshortbase=(char far *)farcalloc(TYPE_KINDS+1,sizeof(char)*5);

   ALLindex=(char far *)unitshortbase;
   for(i=0;i<=UNIT_KINDS;i++)
   {
      unitshort[i]=(char far *)ALLindex;
      ALLindex+=sizeof(char)*7;
      ALL_off=FP_OFF(ALLindex);
      ALL_seg=FP_SEG(ALLindex);
      ALLindex=MK_FP(ALL_seg+(ALL_off>>4),ALL_off%16);
   }
   ALLindex=(char far *)unitlongbase;
   for(i=0;i<=UNIT_KINDS;i++)
   {
      unitlong[i]=(char far *)ALLindex;
      ALLindex+=sizeof(char)*11;
      ALL_off=FP_OFF(ALLindex);
      ALL_seg=FP_SEG(ALLindex);
      ALLindex=MK_FP(ALL_seg+(ALL_off>>4),ALL_off%16);
   }
   ALLindex=(char far *)typeshortbase;
   for(i=0;i<=TYPE_KINDS;i++)
   {
      typeshort[i]=(char far *)ALLindex;
      ALLindex+=sizeof(char)*5;
      ALL_off=FP_OFF(ALLindex);
      ALL_seg=FP_SEG(ALLindex);
      ALLindex=MK_FP(ALL_seg+(ALL_off>>4),ALL_off%16);
   }
   if(coreleft()<MemLeft)MemNotEnough();        /* Check Memory Size */

   printf("\nثeѾlO   %6ld 줸]Jơ^",coreleft());
   printf("\nwdO   %6ld 줸",MemLeft);
   LenR=sizeof(int)+sizeof(int)+sizeof(int)+sizeof(MEUNITSHOW *)+sizeof(MEUNITSHOW);
   printf("\nCƶO %6ld 줸",LenR);
   MaxRecords=(coreleft()-MemLeft)/LenR;
   printf("\n̦hiJ   %6d ",MaxRecords);

   if(MaxRecords > 10000) MaxRecords=10000;           /* 64000 / 4 = 16000 */
   printf("\n̦hiJ   %6d ",MaxRecords);

   ALL=(MEUNITSHOW **)calloc(MaxRecords,sizeof(MEUNITSHOW *));
   ALLbase=(MEUNITSHOW far *)farcalloc(MaxRecords,sizeof(MEUNITSHOW));
   if(ALLbase==NULL)MemNotEnough();
   ALLindex=(char far *)ALLbase;
   for(i=0;i<MaxRecords;i++)
   {
      ALL[i]=(MEUNITSHOW far *)ALLindex;
      ALLindex+=sizeof(MEUNITSHOW);
      ALL_off=FP_OFF(ALLindex);
      ALL_seg=FP_SEG(ALLindex);
      ALLindex=MK_FP(ALL_seg+(ALL_off>>4),ALL_off%16);
   }
   IndexY=(int *)calloc(MaxRecords,sizeof(int));
   IndexN=(int *)calloc(MaxRecords,sizeof(int));
   IndexS=(int *)calloc(MaxRecords,sizeof(int));

   printf("\nѾl(wd)O %6ld 줸",coreleft());
}
void Reset_ALL(void)
{
   int i;
   for(i=0;i<MaxRecords;i++)
      memset(ALL[i],'\0',sizeof(MEUNITSHOW));
}
void Free_ALL(void)
{
   free(IndexS);
   free(IndexN);
   free(IndexY);
   farfree(ALLbase);
   free(ALL);
   farfree(typeshortbase);
   farfree(unitlongbase);
   farfree(unitshortbase);
   free(typeshort);
   free(unitlong);
   free(unitshort);
   free(Current_SAT);
   free(Current_DBF);
   free(Current_CFG);
   free(System_CFG);
   free(IC_Path);
}
void Yes2Show(void)
{
   int i;
   C_IndexS=C_IndexY;
   for(i=0;i<C_IndexS;i++)
      IndexS[i]=IndexY[i];
}
void No2Show(void)
{
   int i;
   C_IndexS=C_IndexN;
   for(i=0;i<C_IndexS;i++)
      IndexS[i]=IndexN[i];
}
void SwapALL(MEUNITSHOW *unt1,MEUNITSHOW *unt2)
{
   MEUNITSHOW unttmp;
   unttmp = *unt1;
   *unt1  = *unt2;
   *unt2  = unttmp;
}
void SwapIndexS(int *i1,int *i2)
{
   int itmp;
   itmp = *i1;
   *i1  = *i2;
   *i2  = itmp;
}
void SwapsALL(char *i1,char *i2)
{
   char itmp[BytesToCmp];
   strncpy(itmp,i1,BytesToCmp);
   strncpy(i1  ,i2,BytesToCmp);
   strncpy(i2,itmp,BytesToCmp);
}
char FlagOfYearOver99;                                      /* ver 1.01 */
void SetFlagOfYearOver99(void)                              /* ver 1.01 */
{
   char today[9];
   Date_String(today);
   if(DateToL(today)>=100000000L)FlagOfYearOver99=1;
   else                          FlagOfYearOver99=0;
}
void DateToLong(unsigned long *lLong,char *sdate)
{
   char *s;
   char t;
   t=sdate[8];
   sdate[2]=sdate[5]='0';
   sdate[8]='\0';
   *lLong=strtoul(sdate,&s,10);
   sdate[8]=t;
   *lLong+=(*lLong<50000000L)?100000000L:0L;
   sdate[2]=sdate[5]='/';
}
unsigned long DateToL(char *sdate)
{
   char *s;
   unsigned long lLong;
   char t;
   t=sdate[8];
   sdate[2]=sdate[5]='0';
   sdate[8]='\0';
   lLong=strtoul(sdate,&s,10);
   sdate[8]=t;
   lLong+=(lLong<50000000L)?100000000L:0L;
   sdate[2]=sdate[5]='/';
   return lLong;
}
int UnitCmp(MEUNITSHOW *unt1,MEUNITSHOW *unt2,char cmpflag)
{
   int u1,u2;
   unsigned long ldiff,ldiff2;
   double ddiff;

   switch(cmpflag)
   {  /* WƧ */
      case 1:  return (unt1->index - unt2->index);             /* index */
      case 2:  if(FlagOfYearOver99)
               {
                  ldiff=DateToL((char *)unt1);                 /* date */
                  ldiff2=DateToL((char *)unt2);
                  ddiff=(double)ldiff-(double)ldiff2; /* unsigned ! compare */
                  return ( (ddiff>0)? 1 : ((ddiff<0)? -1 : 0) );
               }
               else  return strcmp((char *)unt1,(char *)unt2);
      case 3:  return ((int)unt1->unit - (int)unt2->unit);     /* unit */
      case 4:  return ((int)unt1->type - (int)unt2->type);     /* type */
      case 5:                                                  /* person */
      case 6:                                                  /* memo */
      case 7:                                                  /* money *//*v1.01*/
      case 8:  return strcmp((char *)unt1,(char *)unt2);       /* remark *//*v1.02*/
      /* Ƨ */
      case 11: return (unt2->index - unt1->index);             /* index */
      case 12: if(FlagOfYearOver99)
               {
                  DateToLong(&ldiff,(char *)unt2);             /* date */
                  DateToLong(&ldiff2,(char *)unt1);
                  ddiff=(double)ldiff-(double)ldiff2; /* unsigned ! compare */
                  return ( (ddiff>0)? 1 : ((ddiff<0)? -1 : 0) );
               }
               else  return strcmp((char *)unt2,(char *)unt1);
      case 13: return ((int)unt2->unit - (int)unt1->unit);     /* unit */
      case 14: return ((int)unt2->type - (int)unt1->type);     /* type */
      case 15:                                                 /* person */
      case 16:                                                 /* memo */
      case 17:                                                 /* money *//*v1.01*/
      case 18: return strcmp((char *)unt2,(char *)unt1);       /* remark *//*v1.02*/

      default: return 0;
   }
}
char *sortokstring="ƧǧC";
char ShellSortShow(char cmpflag)
{
   int iOffset, iSwitch, iLimit, iRow;
   unsigned int sALL_seg;   /* for far pointer of sALL */
   unsigned int sALL_off;   /* for far pointer of sALL */
   MEUNIT u;
   int i;

   Message(0,1,0,"ƧǤDDDбzyDDD");

   if(   cmpflag== 1 || cmpflag== 3 || cmpflag== 4
      || cmpflag==11 || cmpflag==13 || cmpflag==14)
   {
      /* Set comparison offset to half the number of bars. */
      iOffset = (C_IndexS-1) / 2;
      while( iOffset )                 /* Loop until offset gets to zero. */
      {
         iLimit = (C_IndexS-1) - iOffset;
         do
         {
            iSwitch = 0;               /* Assume no switches at this offset. */
                           /* Compare elements and switch ones out of order. */
            for( iRow = 0; iRow <= iLimit; iRow++ )
            {
               if(UnitCmp(ALL[IndexS[iRow]],ALL[IndexS[iRow+iOffset]],cmpflag)>0)
               {
                  SwapIndexS(&IndexS[iRow],&IndexS[iRow+iOffset]);
                  iSwitch = iRow;
               }
            }
                     /* Sort on next pass only to where last switch was made. */
            iLimit = iSwitch - iOffset;
         } while( iSwitch );
         /* No switches at last offset, try one half as big. */
         iOffset = iOffset / 2;
      }
      Message(0,0,0,sortokstring);
      return OK;
   }

   OpenDBF();
   sALL=(char **)calloc(C_IndexS,sizeof(char *));
   sALLbase=(char far *)farcalloc(C_IndexS,BytesToCmp);
   if(sALLbase==NULL)
   {
      if(sALL!=NULL) free(sALL);
      MemNotEnough2();
      return ERROR;
   }
   sALLindex=(char far *)sALLbase;
   for(i=0;i<C_IndexS;i++)
   {
      sALL[i]=(char far *)sALLindex;
      sALLindex+=BytesToCmp;
      sALL_off=FP_OFF(sALLindex);
      sALL_seg=FP_SEG(sALLindex);
      sALLindex=MK_FP(sALL_seg+(sALL_off>>4),sALL_off%16);
   }
   switch(cmpflag)
   {
      case  2: case 12:    /* date */
         for(i=0;i<C_IndexS;i++)
         {
            ReadOneUnit(&u,ALL[IndexS[i]]->index);
            strncpy(sALL[i],u.date,8);
            sALL[i][8]='\0';
         }
         break;
      case  5: case 15:    /* person */
         for(i=0;i<C_IndexS;i++)
         {
            ReadOneUnit(&u,ALL[IndexS[i]]->index);
            strncpy(sALL[i],u.person,8);
            sALL[i][8]='\0';
         }
         break;
      case  6: case 16:    /* memo */
         for(i=0;i<C_IndexS;i++)
         {
            ReadOneUnit(&u,ALL[IndexS[i]]->index);
            strncpy(sALL[i],u.memo,BytesToCmp-1);
            sALL[i][BytesToCmp-1]='\0';
         }
         break;
      case  7: case 17:    /* money */
         for(i=0;i<C_IndexS;i++)
         {
            ReadOneUnit(&u,ALL[IndexS[i]]->index);
            strncpy(sALL[i],u.money,BytesToCmp-1);
            sALL[i][BytesToCmp-1]='\0';
         }
         break;
      case  8: case 18:    /* remark */
         for(i=0;i<C_IndexS;i++)
         {
            ReadOneUnit(&u,ALL[IndexS[i]]->index);
            strncpy(sALL[i],u.remark,BytesToCmp-1);
            sALL[i][BytesToCmp-1]='\0';
         }
         break;
   }
   /* Set comparison offset to half the number of bars. */
   iOffset = (C_IndexS-1) / 2;
   while( iOffset )                 /* Loop until offset gets to zero. */
   {
      iLimit = (C_IndexS-1) - iOffset;
      do
      {
         iSwitch = 0;               /* Assume no switches at this offset. */
                        /* Compare elements and switch ones out of order. */
         for( iRow = 0; iRow <= iLimit; iRow++ )
         {
            if(UnitCmp((MEUNITSHOW *)sALL[iRow],(MEUNITSHOW *)sALL[iRow+iOffset],cmpflag)>0)
            {
               SwapIndexS(&IndexS[iRow],&IndexS[iRow+iOffset]);
               SwapsALL  ( sALL  [iRow], sALL  [iRow+iOffset]);
               iSwitch = iRow;
            }
         }
                  /* Sort on next pass only to where last switch was made. */
         iLimit = iSwitch - iOffset;
      } while( iSwitch );
      /* No switches at last offset, try one half as big. */
      iOffset = iOffset / 2;
   }

   free(sALLbase);
   free(sALL);
   CloseDBF();
   Message(0,0,0,sortokstring);
   return OK;
}
char ShowSort(void)
{
   extern char *sorttype0[];
   extern char *sorttype2[];
   static char *sword="A+";
   int ch;

   CenterFrame(9);
   gotoxy(33,2);printf("пJƧǪN");
   gotoxy( 9,4);
   for(ch=0;ch<8;ch++) printf("%c:%s  ",'A'+ch,sorttype2[ch+1]);
   gotoxy(39,6);printf("[%s]",sword);
   do{
      Replace_Mode();
      gotoxy(9,8);
      printf("GbN᭱i[W     +  ܻW]w^     -  ܻ");
      ch=0;
      while(ch!=Enter)
      {
         SetEnglishInput();
         ch=FGetWords(sword,"  ",40,6);
         if(!isalpha(sword[0])) sword[0] ='A';
         if(islower(sword[0]))  sword[0]-='a'-'A';
         if(sword[0]<'A' || sword[0]>'H') sword[0]='A';
         if(!(sword[1]=='+' || sword[1]=='-')) sword[1]='+';
         sword[2]='\0';
         DrawWords2(sword,40,6,2);
         if(ch==Esc)
         {
            FreeCenterFrame(9);           /* Put back screen text */
            normvideo();
            Cursor(0);
            return USERBREAK ;            /* USERBREAK -> Esc Press no input */
         }
      }
      gotoxy(1,8);ShowOneNull();
      gotoxy(22,8);
      SetEnglishInput();
      printf("O_H  %6s%4s  ӱƧǡH]^", sorttype2[sword[0]-'A'+1],
               (sword[1]=='-')?sorttype0[1]:sorttype0[0]);
      gotoxy(60,8);
      Cursor(2);
      Clear_KeyBuf();
      ch=bioskey(0);
      ch=(ch==Esc)?N_N:ch;
      Cursor(0);
      gotoxy(1,8);ShowOneNull();
   }while(ch==N_N || ch==S_N);
   FreeCenterFrame(9);
   CurrentSortType=sword[0]-'A'+1;
   CurrentSortType+=(sword[1]=='-')?10:0;
   return ShellSortShow(CurrentSortType);
}
/******************************************************************************

                                пJƧǪN

        A:ɮ  B:  C:  D:ڶ  E:ʤH  F:Kn  G:B  H:Ƶ

                                      [  ]

        GbN᭱i[W     +  ܻW]w^     -  ܻ

*******************************************************************************/
/******************************************************************************
void MemNotEnough(void);
void Alloc_ALL(void);
void Reset_ALL(void);
void Free_ALL(void);
void Yes2Show(void);
void No2Show(void);

void SwapALL(MEUNITSHOW *unt1,MEUNITSHOW *unt2);
void SwapIndexS(int *i1,int *i2);
void DateToLong(unsigned long *lLong,char *sdate);
unsigned long DateToL(char *sdate);
int  UnitCmp(MEUNITSHOW *unt1,MEUNITSHOW *unt2,char cmpflag);
char ShellSortShow(char cmpflag);
char ShowSort(void);

void ShellSortALL(char cmpflag)
{
   int iOffset, iSwitch, iLimit, iRow;
   Message(0,1,0,"ƧǤDDDбzyDDD");
   /* Set comparison offset to half the number of bars. */
   iOffset = (totalnumb-1) / 2;

   while( iOffset )
   {
      /* Loop until offset gets to zero. */
      iLimit = (totalnumb-1) - iOffset;
      do
      {
         iSwitch = 0;     /* Assume no switches at this offset. */

         /* Compare elements and switch ones out of order. */
         for( iRow = 0; iRow <= iLimit; iRow++ )
         {
            if( UnitCmp(ALL[iRow],ALL[iRow + iOffset],cmpflag)>0)
            {
               SwapALL(ALL[iRow],ALL[iRow + iOffset]);
               iSwitch = iRow;
            }
         }

         /* Sort on next pass only to where last switch was made. */
         iLimit = iSwitch - iOffset;
      } while( iSwitch );

      /* No switches at last offset, try one half as big. */
      iOffset = iOffset / 2;
   }
   Message(0,0,0,"ƧǧC");
}
int UnitCmpOLD(MEUNITSHOW *unt1,MEUNITSHOW *unt2,char cmpflag)
{
   MEUNIT u1,u2;
   unsigned long ldiff,ldiff2;
   double ddiff;

   switch(cmpflag)
   {  /* WƧ */
      case 1:  return (unt1->index - unt2->index);             /* index */
      case 2:  if(FlagOfYearOver99)
               {
                  ldiff=DateToL(unt1->date);                   /* date */
                  ldiff2=DateToL(unt2->date);
                  ddiff=(double)ldiff-(double)ldiff2; /* unsigned ! compare */
                  return ( (ddiff>0)? 1 : ((ddiff<0)? -1 : 0) );
               }
               else
                  return strcmp(unt1->date,unt2->date);
      case 3:  return ((int)unt1->unit - (int)unt2->unit);     /* unit */
      case 4:  return ((int)unt1->type - (int)unt2->type);     /* type */
      case 5:  return strcmp(unt1->person,unt2->person);       /* person */
      case 6:  return strcmp(unt1->memo,unt2->memo);           /* memo */
      case 7:  return strcmp(unt1->money,unt2->money);         /* money *//*v1.01*/
/*    case 7:  ddiff=atof(unt1->money)-atof(unt2->money);      /* money */
               return ( (ddiff>0)? 1 : ((ddiff<0)? -1 : 0) );                 */
      /* Ƨ */
      case 11: return (unt2->index - unt1->index);             /* index */
      case 12: if(FlagOfYearOver99)
               {
                  DateToLong(&ldiff,unt2->date);                  /* date */
                  DateToLong(&ldiff2,unt1->date);
                  ddiff=(double)ldiff-(double)ldiff2;      /* unsigned ! compare */
                  return ( (ddiff>0)? 1 : ((ddiff<0)? -1 : 0) );
               }
               else  return strcmp(unt2->date,unt1->date);
      case 13: return ((int)unt2->unit - (int)unt1->unit);     /* unit */
      case 14: return ((int)unt2->type - (int)unt1->type);     /* type */
      case 15: return strcmp(unt2->person,unt1->person);       /* person */
      case 16: return strcmp(unt2->memo,unt1->memo);           /* memo */
      case 17: return strcmp(unt2->money,unt1->money);         /* money *//*v1.01*/
/*    case 17: ddiff=atof(unt2->money)-atof(unt1->money);         /* money */
               return ( (ddiff>0)? 1 : ((ddiff<0)? -1 : 0) );                 */

      default: return 0;
   }
}
*******************************************************************************/
