/*****************************************************************************/
/* UNIO4-2.C     Unit I/O  4  for Print ALL data & Budget                    */
/*****************************************************************************/

#include"memain.i"

char *printmessage="gOLsDDDi Ctrl-Break _CLDDD";
char *printOKmessage="gOLsC";
char AskPrinterFile(void)              /* ver 0.24 */
{
   extern char *null;
   char sword[61];
   int ch;

   strncpy(sword,DevicePrinterName,60);sword[60]='\0';
   null[60]='\0';
   CenterFrame(5);
   printfXY(32,2,"пJLXɦW");
   printfXY(10,4,"[%60.60s]",sword);

      Replace_Mode();
      ch=0;
      while(ch!=Enter)
      {
         SetEnglishInput();
         ch=FGetWords(sword,null,11,4);
         DrawWords2(sword,11,4,60);
         if(ch==Esc)
         {
            FreeCenterFrame(5);           /* Put back screen text */
            normvideo();
            Cursor(0);
            null[60]=' ';
            return USERBREAK ;            /* USERBREAK -> Esc Press no input */
         }
      }

   strncpy(DevicePrinterName,sword,60);DevicePrinterName[60]='\0';
   FreeCenterFrame(5);
   null[60]=' ';
   Cursor(0);
   return OK;
}
char AskPrinterType(void)              /* ver 0.24 */
{
   int ch;
   while(TRUE)
   {
      ch=NotOK;
      ch=Ask_No("O_NLXɮ");
      if(ch==OTHER)return NotOK;
      if(ch==OK)
      {
         PrinterType=0;
         return OK;
      }
      else
      {
         PrinterType=1;
         if(AskPrinterFile()==OK)return OK;
         else                    continue;
      }
   }
}
char PrintBudget(void)
{
   char i,j;

   if(AskPrinterType()!=OK)return USERBREAK;    /* ver 0.24 */

   Message(0,0,0,printmessage);
   ctrlbrk(PrintControlBreak);                 /* Set Ctrl-Break function  */

   if(PrintFormat()!=OK)return NotOK;
   if(PrintTitle()!=OK)return NotOK;
   if(PrintPUFrame()!=OK)return NotOK;
   for(i=0;i<unit_num;i++)
   {
      for(j=1;j<type_num;j++)
         if(PrintUnitType(i,j,1)!=OK)return NotOK;
      for(;j<=3;j++)
         if(PrintNullFrame()!=OK)return NotOK;
      for(;j<=4;j++)
         if(i!=13){ if(PrintPCFrame()!=OK)   return NotOK; }
         else     { if(PrintNullFrame()!=OK) return NotOK; }
   }
   for(;i<=13;i++)
   {
      for(j=1;j<=3;j++)
         if(PrintNullFrame()!=OK)return NotOK;
      if(i!=13){ if(PrintPCFrame()!=OK)   return NotOK; }
      else     { if(PrintNullFrame()!=OK) return NotOK; }
   }
   if(PrintPLFrame()!=OK)return NotOK;
   if(PrintFooter()!=OK)return NotOK;

   if(PrintInit()!=OK)return NotOK;
   if(FormFeed()!=OK)return NotOK;

   ctrlbrk(NormalControlBreak);                 /* Set Ctrl-Break function  */
   FlagOfPrinting=0;
   Message(0,0,0,printOKmessage);
   return OK;
}
/******************************************************************************

                 q [1   ]     CL [end ] 

******************************************************************************/
char AskPrintRange(int *pFirst,int *pEnd)
{
   char *sformat="    ";
   char Totalitem=2;
   char stemp[2][5];
   int  ch,eitem;

   Message(0,0,0,"бzJCLdAEsc C");
   CenterFrame(3);
   gotoxy(18,2);
   *pFirst=1,*pEnd=C_IndexS;
   printf("q [%4d]     CL [%4d] ",*pFirst,*pEnd);
   itoa(*pFirst,stemp[0],10);
   itoa(*pEnd  ,stemp[1],10);
   DrawWords2(stemp[0],24,2,4);
   DrawWords2(stemp[1],52,2,4);
   do{
      ch=0;eitem=0;
      SetEnglishInput();
      while(TRUE)
      {
         switch(eitem)
         {
            case 0:
               ch=DFGetWords(stemp[eitem],sformat,24,2);
               *pFirst=atoi(stemp[0]);
               if(*pFirst<1)*pFirst=1;
               itoa(*pFirst,stemp[0],10);
               DrawWords2(stemp[eitem],24,2,4);
               break;

            case 1:
               ch=DFGetWords(stemp[eitem],sformat,52,2);
               *pEnd=atoi(stemp[1]);
               if(*pEnd<1)*pEnd=1;
               itoa(*pEnd,stemp[1],10);
               DrawWords2(stemp[eitem],52,2,4);
               break;
         }
         if(ch==Esc)
         {
            normvideo();
            Cursor(0);
            return USERBREAK;
         }
         if(ch==Enter)
         {
            if(eitem==Totalitem-1)break;
            eitem++;
         }
         else  if(ch==Tab || ch==Down)
                  eitem=(eitem>=Totalitem-1)?eitem:eitem+1;
               else  if(ch==S_Tab || ch==Up)
                  eitem=(eitem==0)?0:eitem-1;
      }
   }while(*pFirst>*pEnd);
   Cursor(0);
   FreeCenterFrame(3);
   return OK;
}

#define  PrintPAGEL  45                /* 45 records per page */
char PrintALL(int *ScrJJ,int *ScrII)
{
   extern char *sorttype0[];
   extern char *sorttype2[];
   MEUNIT pUnt;
   int totalpages;
   int ch;
   long pStat;
   char pUnit,pType,tmp_char;
   int  FirstToP,EndToP,TotalToP;
   int  i,j,k;

   if(C_IndexS==0)
   {
      Message(1,0,0,"䤣ƥiCLI");
      return ERROR;
   }
   Message(0,0,1,"O_Nثeƨ %s %s ƧǨӦCLH]^",
                  sorttype2[CurrentSortType%10],
                  (CurrentSortType>10)?sorttype0[1]:sorttype0[0]);
   Cursor(2);
   Clear_KeyBuf();
   SetEnglishInput();
   ch=bioskey(0);
   ch=(ch==Esc)?N_N:ch;
   Cursor(0);
   MessageOff();
   if(ch==N_N || ch==S_N)  return USERBREAK;

   if(AskPrinterType()!=OK)return USERBREAK;    /* ver 0.24 */

   if(AskPrintRange(&FirstToP,&EndToP)!=OK) return NotOK;
   FirstToP-=1;
   TotalToP=EndToP-FirstToP;
   Message(0,0,0,printmessage);
   totalpages=((TotalToP%PrintPAGEL==0)?TotalToP/PrintPAGEL:TotalToP/PrintPAGEL+1);

   ctrlbrk(PrintControlBreak);               /* Set Ctrl-Break function  */
   ShowUnit(ScrJJ,ScrII,0);                  /* Show First Unit */

   OpenDBF();
   pStat=0;
   pUnit=ALL[IndexS[0]]->unit;
   pType=ALL[IndexS[0]]->type;
   for(i=0;i<totalpages;i++)
   {
      if(PrintFormat()!=OK)return NotOK;
      if(PrintNull()!=OK)return NotOK;
      if(PrintTitle()!=OK)return NotOK;
      if(PrintPages(totalpages,i+1)!=OK)return NotOK;
      if(PrintHeader()!=OK)return NotOK;
      if(PrintPartLine()!=OK)return NotOK;
      for(j=0;j<PrintPAGEL && i*PrintPAGEL+j<TotalToP;j++)
      {
         k=i*PrintPAGEL+FirstToP+j;                      /* ver 0.15 fixed */
         ReadOneUnit(&pUnt,ALL[IndexS[k]]->index);
         tmp_char=pUnt.money[10]; pUnt.money[10]='\0';
         pStat+=atol(pUnt.money); pUnt.money[10]=tmp_char;
         pUnit=(pUnit==ALL[IndexS[k]]->unit)?pUnit:0;
         pType=(pType==ALL[IndexS[k]]->type)?pType:0;
         if(PrintUnit(&pUnt)!=OK)return NotOK;
         if(FlagOfBreakPress==1)
            ShowUnit(ScrJJ,ScrII,2), FlagOfBreakPress=0;
         ShowUnit(ScrJJ,ScrII,Down);            /* Show Unit while printing */
      }
      for(;j<PrintPAGEL;j++)
         if(PrintNull()!=OK)return NotOK;
      if(PrintPartLine()!=OK)return NotOK;
      if(PrintCalculate(pStat)!=OK)return NotOK;
      if(PrintStat(pUnit,(i==totalpages-1)?pType:TYPE_KINDS+1)!=OK)return NotOK;
      if(PrintFooter()!=OK)return NotOK;
      if(PrintInit()!=OK)return NotOK;
      if(FormFeed()!=OK)return NotOK;
   }
   CloseDBF();
   ctrlbrk(NormalControlBreak);                 /* Set Ctrl-Break function  */
   FlagOfPrinting=0;
   Message(0,0,0,printOKmessage);
   return OK;
}
/******************************************************************************
char PrintBudget(void);
char AskPrintRange(int *pFirst,int *pEnd);
char PrintALL(int *ScrJJ,int *ScrII);
******************************************************************************/
