/*****************************************************************************/
/* V.C           All Variable for UNIT                                       */
/*****************************************************************************/

#define NoExtern                 /* exclude extern part of MEMAIN.I */
#include"memain.i"
#undef  NoExtern

FILE *Main_CFG;                  /* system  CFG file pointer */
FILE *File_CFG;                  /* current CFG file pointer */
FILE *File_DBF;                  /* current DBF file pointer */
FILE *File_SAT;                  /* current SAT file pointer */
char *IC_Path;                   /* initial PATH of MeMain */
char *System_CFG;                /* system  CFG file name */
char *Current_CFG;               /* current CFG file name */
char *Current_DBF;               /* current DBF file name */
char *Current_SAT;               /* current SAT file name */

char **unitshort;                /* short name of unit */
char far *unitshortbase;         /* memory base - short name of unit */
char **unitlong;                 /* long  name of unit */
char far *unitlongbase;          /* memory base - long  name of unit */
char **typeshort;                /* short name of type */
char far *typeshortbase;         /* memory base - short name of type */
MEUNITSHOW **ALL;                /* Be a Index */
MEUNITSHOW far *ALLbase;         /* Base for *ALL[] */
char       far *ALLindex;        /* Index of ALL[] */
int   *IndexY;                   /* Index of non-deleted data */
int   *IndexN;                   /* Index of deleted data */
int   *IndexS;                   /* Index of data to show */
char  *TitlePrn=                 /* registed name >=UnitPrn+14 */
       "123456789012345678901234567890123456789012345678901234567890";
char  *UnitPrn=                  /* registed name 20 chinese words */
       "1234567890123456789012345678901234567890";

long  STSET [UNIT_KINDS][TYPE_KINDS];  /* total available money */
long  STALL [UNIT_KINDS][TYPE_KINDS];  /* money used */
long  STREST[UNIT_KINDS][TYPE_KINDS];  /* money left */
long  STATSET[TYPE_KINDS];       /* stat all   total available money */
long  STATALL[TYPE_KINDS];       /* stat all   money used */
long  STATREST[TYPE_KINDS];      /* stat all   money left */
long  STATERR;                   /* stat all   money of undefined type */

char  BeepControlFlag;           /* Beep control flag */
char  FlagOfPrinting;            /* Flag of printing data */
char  FlagOfPrintBreak;          /* Flag of Break while printing */
char  FlagOfBreakPress;          /* Flag of Ctrl-Break Press */
char  FlagOfShowingCwords;       /* Flag of Showing Chinese Words */
char  FlagOfOpeningDBF;          /* Flag of Opening Current DBF file *//*ver1.01*/
int   SleepSeconds;              /* Seconds for Screen Protect */
long  DBF_HeaderLen;             /* Header Len of DBF File */
char  unit_num;                  /* count number of unit */
char  type_num;                  /* count number of type */
int   C_IndexY;                  /* Count of IndexY */
int   C_IndexN;                  /* Count of IndexN */
int   C_IndexS;                  /* Count of IndexS */
long  totalnumb;                 /* The Number of Total Records */
int   MaxRecords;                /* Maximun Records in a DBF file */
long  MemLeft=68000L;            /* Memory Left after Alloc_ALL() */
                                 /* Memory Need Left 64k to call COMMAND.COM */

unsigned char Color_Message;
unsigned char Color_MenuNormal;
unsigned char Color_MenuLightBar;
unsigned char Color_DataNormal;
unsigned char Color_DataLightBar;
unsigned char Color_StringInput;

char  YearType;                  /* The type of the year     */
                                 /* 0 -> 褸p~   (w) */
                                 /* 1 -> p~            */

char  DisplayType;               /* The type of data display */   /*ver 1.01*/
                                 /* 0 -> ܳƵ (w) */
                                 /* 1 -> ܳƵ,ܳڶʤH */
char  CurrentDataType;           /* Current Data Type flag */
                                 /* 0 -> L   1 -> {s  */
                                 /* 2 -> jM   3 -> R  */
char  CurrentSortType;           /* Current Sort Type flag */
                                 /* 0 -> Error !    1 -> ɮ   */
                                 /* 2 ->        3 ->    */
                                 /* 4 -> ڶ       5 -> ʤH */
                                 /* 6 -> Kn       7 -> B   */
char  CurrentYearOfDate[2];      /* Current YEAR of the data file  */
char  DevicePrinterName[61];     /* Print to ASCII file */
int   PrinterPort;               /* Printer Port 0:LPT1  1:LPT2 .. */
char  PrinterType;               /* 0 -> Printer   1 -> ASCII file */
unsigned char PrinterControlCode;/* Printer Control Code */
char  PrinterControlString[45];  /* Printer Control String */
char *FullNumb[] ={ "", "", "", "", "", "", "", "", "", ""};
char *FullNumb2[]={ "", "", "", "", "", "", "", "", "", ""};
char *FullAlpha[]={ "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "", "", "", "", "",
                    "", "", "", "", "", "" };
