#******************************************************************************#
# MAKEFILE        Compile & Link  all needed files - *.obj , *.lib             #
#                                                                              #
# Makefile for    VIEWER.EXE                                                   #
# Variable MDL    Memory Model                                                 #
# Variable LIB    Path of Library                                              #
# Variable OPS    General Options                                              #
#******************************************************************************#

EXE=c:\l\tc\tcc
MDL=l
LIB=c:\l\tc\lib
LIB2=..\lee
OPS=-c -C -m$(MDL) -p-

##viewer.exe: i0.obj i1.obj i2.obj i3.obj i4.obj v.obj
##   tlink /c/e $(LIB)\c0$(MDL) v i0 i1 i2 i3 i4,viewer,m,$(LIB)\emu $(LIB)\math$(MDL) $(LIB)\c$(MDL) $(LIB2)\leem$(MDL)

viewer.exe: i0.obj i1.obj i2.obj i3.obj v.obj
   tlink /c/e $(LIB)\c0$(MDL) v i0 i1 i2 i3 ,viewer,m,$(LIB)\emu $(LIB)\math$(MDL) $(LIB)\c$(MDL) $(LIB2)\leem$(MDL)

I0.OBJ:      UNI20.C
   $(EXE) $(OPS) -oi0  uni20.c

I1.OBJ:      UNI21.C
   $(EXE) $(OPS) -oi1 uni21.c

I2.OBJ:      UNI22.C
   $(EXE) $(OPS) -oi2 uni22.c

I3.OBJ:      UNI23.C
   $(EXE) $(OPS) -oi3 uni23.c

I4.OBJ:      UNI24.C
   $(EXE) $(OPS) -oi4 uni24.c

V.OBJ:       VIEWER2.C
   $(EXE) $(OPS) -ov   viewer2.c

